#pragma once

#include <string>

static std::string const otherLicenses{R"(Most of the code is licensed under GPLv3 (see below), the license for individual
parts and dependencies are as follows:

libkeccak-tiny:
  The file libsolutil/Keccak256.cpp incorporates libkeccak-tiny.

  A single-file implementation of SHA-3 and SHAKE implemented by David Leon Gil
  License: CC0, attribution kindly requested. Blame taken too, but not liability.

nlohmann-json:
  The source code of nlohmann-json is licensed under the following
  conditions:

  The class is licensed under the MIT License:

  Copyright © 2013-2022 Niels Lohmann

  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the “Software”), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED “AS IS”, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

  The class contains the UTF-8 Decoder from Bjoern Hoehrmann which is licensed under the MIT License (see above). Copyright © 2008-2009 Björn Hoehrmann bjoern@hoehrmann.de

  The class contains a slightly modified version of the Grisu2 algorithm from Florian Loitsch which is licensed under the MIT License (see above). Copyright © 2009 Florian Loitsch

  The class contains a copy of Hedley from Evan Nemerson which is licensed as CC0-1.0.

picosha2:
  The file libsolutil/picosha2.h is imported.

  Copyright (C) 2017 okdshin

  Permission is hereby granted, free of charge, to any person obtaining a copy
  of this software and associated documentation files (the "Software"), to deal
  in the Software without restriction, including without limitation the rights
  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  copies of the Software, and to permit persons to whom the Software is
  furnished to do so, subject to the following conditions:

  The above copyright notice and this permission notice shall be included in
  all copies or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
  THE SOFTWARE.

range-v3:
  The range-v3 library is licensed under the following conditions:

  ========================================================
  Boost Software License - Version 1.0 - August 17th, 2003
  ========================================================

  Permission is hereby granted, free of charge, to any person or organization
  obtaining a copy of the software and accompanying documentation covered by
  this license (the "Software") to use, reproduce, display, distribute,
  execute, and transmit the Software, and to prepare derivative works of the
  Software, and to permit third-parties to whom the Software is furnished to
  do so, all subject to the following:

  The copyright notices in the Software and this entire statement, including
  the above license grant, this restriction and the following disclaimer,
  must be included in all copies of the Software, in whole or in part, and
  all derivative works of the Software, unless such copies or derivative
  works are solely in the form of machine-executable object code generated by
  a source language processor.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT
  SHALL THE COPYRIGHT HOLDERS OR ANYONE DISTRIBUTING THE SOFTWARE BE LIABLE
  FOR ANY DAMAGES OR OTHER LIABILITY, WHETHER IN CONTRACT, TORT OR OTHERWISE,
  ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
  DEALINGS IN THE SOFTWARE.

  ==============================================================================
  libc++ License
  ==============================================================================

  The libc++ library is dual licensed under both the University of Illinois
  "BSD-Like" license and the MIT license.  As a user of this code you may choose
  to use it under either license.  As a contributor, you agree to allow your code
  to be used under both.

  Full text of the relevant licenses is included below.

  ==============================================================================

  University of Illinois/NCSA
  Open Source License

  Copyright (c) 2009-2014 by the contributors listed in CREDITS.TXT
  http://llvm.org/svn/llvm-project/libcxx/trunk/CREDITS.TXT

  All rights reserved.

  Developed by:

      LLVM Team

      University of Illinois at Urbana-Champaign

      http://llvm.org

  Permission is hereby granted, free of charge, to any person obtaining a copy of
  this software and associated documentation files (the "Software"), to deal with
  the Software without restriction, including without limitation the rights to
  use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
  of the Software, and to permit persons to whom the Software is furnished to do
  so, subject to the following conditions:

      * Redistributions of source code must retain the above copyright notice,
        this list of conditions and the following disclaimers.

      * Redistributions in binary form must reproduce the above copyright notice,
        this list of conditions and the following disclaimers in the
        documentation and/or other materials provided with the distribution.

      * Neither the names of the LLVM Team, University of Illinois at
        Urbana-Champaign, nor the names of its contributors may be used to
        endorse or promote products derived from this Software without specific
        prior written permission.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
  FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
  CONTRIBUTORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS WITH THE
  SOFTWARE.

  ==============================================================================

  Copyright (c) 2009-2014 by the contributors listed in CREDITS.TXT
    http://llvm.org/svn/llvm-project/libcxx/trunk/CREDITS.TXT

  Permission is hereby granted, free of charge, to any person obtaining a copy
  of this software and associated documentation files (the "Software"), to deal
  in the Software without restriction, including without limitation the rights
  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  copies of the Software, and to permit persons to whom the Software is
  furnished to do so, subject to the following conditions:

  The above copyright notice and this permission notice shall be included in
  all copies or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
  THE SOFTWARE.

  ==============================================================================
  Stepanov and McJones, "Elements of Programming" license
  ==============================================================================

  // Copyright (c) 2009 Alexander Stepanov and Paul McJones
  //
  // Permission to use, copy, modify, distribute and sell this software
  // and its documentation for any purpose is hereby granted without
  // fee, provided that the above copyright notice appear in all copies
  // and that both that copyright notice and this permission notice
  // appear in supporting documentation. The authors make no
  // representations about the suitability of this software for any
  // purpose. It is provided "as is" without express or implied
  // warranty.
  //
  // Algorithms from
  // Elements of Programming
  // by Alexander Stepanov and Paul McJones
  // Addison-Wesley Professional, 2009

  ==============================================================================
  SGI C++ Standard Template Library license
  ==============================================================================

  // Copyright (c) 1994
  // Hewlett-Packard Company
  //
  // Permission to use, copy, modify, distribute and sell this software
  // and its documentation for any purpose is hereby granted without fee,
  // provided that the above copyright notice appear in all copies and
  // that both that copyright notice and this permission notice appear
  // in supporting documentation.  Hewlett-Packard Company makes no
  // representations about the suitability of this software for any
  // purpose.  It is provided "as is" without express or implied warranty.
  //
  // Copyright (c) 1996
  // Silicon Graphics Computer Systems, Inc.
  //
  // Permission to use, copy, modify, distribute and sell this software
  // and its documentation for any purpose is hereby granted without fee,
  // provided that the above copyright notice appear in all copies and
  // that both that copyright notice and this permission notice appear
  // in supporting documentation.  Silicon Graphics makes no
  // representations about the suitability of this software for any
  // purpose.  It is provided "as is" without express or implied warranty.
  //

scanner/token:
  The liblangutil/{CharStream,Scanner,Token}.{h,cpp} files are derived from
  code originating from the V8 project licensed under the following terms:

  Copyright 2006-2012, the V8 project authors. All rights reserved.
  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions are
  met:

      * Redistributions of source code must retain the above copyright
        notice, this list of conditions and the following disclaimer.
      * Redistributions in binary form must reproduce the above
        copyright notice, this list of conditions and the following
        disclaimer in the documentation and/or other materials provided
        with the distribution.
      * Neither the name of Google Inc. nor the names of its
        contributors may be used to endorse or promote products derived
        from this software without specific prior written permission.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

evmc:
  The code in test/evmc is licensed under the Apache License version 2:

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.

mini-lz4:
  The file scripts/ci/mini-lz4.js is derived from the emscripten adaptation of
  node-lz4 and licensed under the following terms:

  Copyright (c) 2012 Pierre Curto

  Permission is hereby granted, free of charge, to any person obtaining a copy
  of this software and associated documentation files (the "Software"), to deal
  in the Software without restriction, including without limitation the rights
  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  copies of the Software, and to permit persons to whom the Software is
  furnished to do so, subject to the following conditions:

  The above copyright notice and this permission notice shall be included in
  all copies or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
  THE SOFTWARE.

base64:
  The file scripts/ci/base64DecToArr.js is derived from a code example
  in the MDN Web Docs, which permits use under CC0 terms:

  Any copyright is dedicated to the Public Domain. http://creativecommons.org/publicdomain/zero/1.0/

Z3:
  The Z3 library is licensed under the following terms:

  Copyright (c) Microsoft Corporation
  All rights reserved.
  MIT License

  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED *AS IS*, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.


All other code is licensed under GPL version 3:

)"};

static char const licenseText[] = {
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x47,
	0x4e,
	0x55,
	0x20,
	0x47,
	0x45,
	0x4e,
	0x45,
	0x52,
	0x41,
	0x4c,
	0x20,
	0x50,
	0x55,
	0x42,
	0x4c,
	0x49,
	0x43,
	0x20,
	0x4c,
	0x49,
	0x43,
	0x45,
	0x4e,
	0x53,
	0x45,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x56,
	0x65,
	0x72,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x33,
	0x2c,
	0x20,
	0x32,
	0x39,
	0x20,
	0x4a,
	0x75,
	0x6e,
	0x65,
	0x20,
	0x32,
	0x30,
	0x30,
	0x37,
	0x0a,
	0x0a,
	0x20,
	0x43,
	0x6f,
	0x70,
	0x79,
	0x72,
	0x69,
	0x67,
	0x68,
	0x74,
	0x20,
	0x28,
	0x43,
	0x29,
	0x20,
	0x32,
	0x30,
	0x30,
	0x37,
	0x20,
	0x46,
	0x72,
	0x65,
	0x65,
	0x20,
	0x53,
	0x6f,
	0x66,
	0x74,
	0x77,
	0x61,
	0x72,
	0x65,
	0x20,
	0x46,
	0x6f,
	0x75,
	0x6e,
	0x64,
	0x61,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x2c,
	0x20,
	0x49,
	0x6e,
	0x63,
	0x2e,
	0x20,
	0x3c,
	0x68,
	0x74,
	0x74,
	0x70,
	0x3a,
	0x2f,
	0x2f,
	0x66,
	0x73,
	0x66,
	0x2e,
	0x6f,
	0x72,
	0x67,
	0x2f,
	0x3e,
	0x0a,
	0x20,
	0x45,
	0x76,
	0x65,
	0x72,
	0x79,
	0x6f,
	0x6e,
	0x65,
	0x20,
	0x69,
	0x73,
	0x20,
	0x70,
	0x65,
	0x72,
	0x6d,
	0x69,
	0x74,
	0x74,
	0x65,
	0x64,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x63,
	0x6f,
	0x70,
	0x79,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x64,
	0x69,
	0x73,
	0x74,
	0x72,
	0x69,
	0x62,
	0x75,
	0x74,
	0x65,
	0x20,
	0x76,
	0x65,
	0x72,
	0x62,
	0x61,
	0x74,
	0x69,
	0x6d,
	0x20,
	0x63,
	0x6f,
	0x70,
	0x69,
	0x65,
	0x73,
	0x0a,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x69,
	0x73,
	0x20,
	0x6c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x20,
	0x64,
	0x6f,
	0x63,
	0x75,
	0x6d,
	0x65,
	0x6e,
	0x74,
	0x2c,
	0x20,
	0x62,
	0x75,
	0x74,
	0x20,
	0x63,
	0x68,
	0x61,
	0x6e,
	0x67,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x69,
	0x74,
	0x20,
	0x69,
	0x73,
	0x20,
	0x6e,
	0x6f,
	0x74,
	0x20,
	0x61,
	0x6c,
	0x6c,
	0x6f,
	0x77,
	0x65,
	0x64,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x50,
	0x72,
	0x65,
	0x61,
	0x6d,
	0x62,
	0x6c,
	0x65,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x54,
	0x68,
	0x65,
	0x20,
	0x47,
	0x4e,
	0x55,
	0x20,
	0x47,
	0x65,
	0x6e,
	0x65,
	0x72,
	0x61,
	0x6c,
	0x20,
	0x50,
	0x75,
	0x62,
	0x6c,
	0x69,
	0x63,
	0x20,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x20,
	0x69,
	0x73,
	0x20,
	0x61,
	0x20,
	0x66,
	0x72,
	0x65,
	0x65,
	0x2c,
	0x20,
	0x63,
	0x6f,
	0x70,
	0x79,
	0x6c,
	0x65,
	0x66,
	0x74,
	0x20,
	0x6c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x0a,
	0x73,
	0x6f,
	0x66,
	0x74,
	0x77,
	0x61,
	0x72,
	0x65,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x6f,
	0x74,
	0x68,
	0x65,
	0x72,
	0x20,
	0x6b,
	0x69,
	0x6e,
	0x64,
	0x73,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x73,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x54,
	0x68,
	0x65,
	0x20,
	0x6c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x73,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x20,
	0x6d,
	0x6f,
	0x73,
	0x74,
	0x20,
	0x73,
	0x6f,
	0x66,
	0x74,
	0x77,
	0x61,
	0x72,
	0x65,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x6f,
	0x74,
	0x68,
	0x65,
	0x72,
	0x20,
	0x70,
	0x72,
	0x61,
	0x63,
	0x74,
	0x69,
	0x63,
	0x61,
	0x6c,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x73,
	0x20,
	0x61,
	0x72,
	0x65,
	0x20,
	0x64,
	0x65,
	0x73,
	0x69,
	0x67,
	0x6e,
	0x65,
	0x64,
	0x0a,
	0x74,
	0x6f,
	0x20,
	0x74,
	0x61,
	0x6b,
	0x65,
	0x20,
	0x61,
	0x77,
	0x61,
	0x79,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x72,
	0x20,
	0x66,
	0x72,
	0x65,
	0x65,
	0x64,
	0x6f,
	0x6d,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x73,
	0x68,
	0x61,
	0x72,
	0x65,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x63,
	0x68,
	0x61,
	0x6e,
	0x67,
	0x65,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x73,
	0x2e,
	0x20,
	0x20,
	0x42,
	0x79,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x74,
	0x72,
	0x61,
	0x73,
	0x74,
	0x2c,
	0x0a,
	0x74,
	0x68,
	0x65,
	0x20,
	0x47,
	0x4e,
	0x55,
	0x20,
	0x47,
	0x65,
	0x6e,
	0x65,
	0x72,
	0x61,
	0x6c,
	0x20,
	0x50,
	0x75,
	0x62,
	0x6c,
	0x69,
	0x63,
	0x20,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x20,
	0x69,
	0x73,
	0x20,
	0x69,
	0x6e,
	0x74,
	0x65,
	0x6e,
	0x64,
	0x65,
	0x64,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x67,
	0x75,
	0x61,
	0x72,
	0x61,
	0x6e,
	0x74,
	0x65,
	0x65,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x72,
	0x20,
	0x66,
	0x72,
	0x65,
	0x65,
	0x64,
	0x6f,
	0x6d,
	0x20,
	0x74,
	0x6f,
	0x0a,
	0x73,
	0x68,
	0x61,
	0x72,
	0x65,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x63,
	0x68,
	0x61,
	0x6e,
	0x67,
	0x65,
	0x20,
	0x61,
	0x6c,
	0x6c,
	0x20,
	0x76,
	0x65,
	0x72,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x73,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x61,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x67,
	0x72,
	0x61,
	0x6d,
	0x2d,
	0x2d,
	0x74,
	0x6f,
	0x20,
	0x6d,
	0x61,
	0x6b,
	0x65,
	0x20,
	0x73,
	0x75,
	0x72,
	0x65,
	0x20,
	0x69,
	0x74,
	0x20,
	0x72,
	0x65,
	0x6d,
	0x61,
	0x69,
	0x6e,
	0x73,
	0x20,
	0x66,
	0x72,
	0x65,
	0x65,
	0x0a,
	0x73,
	0x6f,
	0x66,
	0x74,
	0x77,
	0x61,
	0x72,
	0x65,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x20,
	0x61,
	0x6c,
	0x6c,
	0x20,
	0x69,
	0x74,
	0x73,
	0x20,
	0x75,
	0x73,
	0x65,
	0x72,
	0x73,
	0x2e,
	0x20,
	0x20,
	0x57,
	0x65,
	0x2c,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x46,
	0x72,
	0x65,
	0x65,
	0x20,
	0x53,
	0x6f,
	0x66,
	0x74,
	0x77,
	0x61,
	0x72,
	0x65,
	0x20,
	0x46,
	0x6f,
	0x75,
	0x6e,
	0x64,
	0x61,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x2c,
	0x20,
	0x75,
	0x73,
	0x65,
	0x20,
	0x74,
	0x68,
	0x65,
	0x0a,
	0x47,
	0x4e,
	0x55,
	0x20,
	0x47,
	0x65,
	0x6e,
	0x65,
	0x72,
	0x61,
	0x6c,
	0x20,
	0x50,
	0x75,
	0x62,
	0x6c,
	0x69,
	0x63,
	0x20,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x20,
	0x6d,
	0x6f,
	0x73,
	0x74,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x6f,
	0x75,
	0x72,
	0x20,
	0x73,
	0x6f,
	0x66,
	0x74,
	0x77,
	0x61,
	0x72,
	0x65,
	0x3b,
	0x20,
	0x69,
	0x74,
	0x20,
	0x61,
	0x70,
	0x70,
	0x6c,
	0x69,
	0x65,
	0x73,
	0x20,
	0x61,
	0x6c,
	0x73,
	0x6f,
	0x20,
	0x74,
	0x6f,
	0x0a,
	0x61,
	0x6e,
	0x79,
	0x20,
	0x6f,
	0x74,
	0x68,
	0x65,
	0x72,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x20,
	0x72,
	0x65,
	0x6c,
	0x65,
	0x61,
	0x73,
	0x65,
	0x64,
	0x20,
	0x74,
	0x68,
	0x69,
	0x73,
	0x20,
	0x77,
	0x61,
	0x79,
	0x20,
	0x62,
	0x79,
	0x20,
	0x69,
	0x74,
	0x73,
	0x20,
	0x61,
	0x75,
	0x74,
	0x68,
	0x6f,
	0x72,
	0x73,
	0x2e,
	0x20,
	0x20,
	0x59,
	0x6f,
	0x75,
	0x20,
	0x63,
	0x61,
	0x6e,
	0x20,
	0x61,
	0x70,
	0x70,
	0x6c,
	0x79,
	0x20,
	0x69,
	0x74,
	0x20,
	0x74,
	0x6f,
	0x0a,
	0x79,
	0x6f,
	0x75,
	0x72,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x67,
	0x72,
	0x61,
	0x6d,
	0x73,
	0x2c,
	0x20,
	0x74,
	0x6f,
	0x6f,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x57,
	0x68,
	0x65,
	0x6e,
	0x20,
	0x77,
	0x65,
	0x20,
	0x73,
	0x70,
	0x65,
	0x61,
	0x6b,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x66,
	0x72,
	0x65,
	0x65,
	0x20,
	0x73,
	0x6f,
	0x66,
	0x74,
	0x77,
	0x61,
	0x72,
	0x65,
	0x2c,
	0x20,
	0x77,
	0x65,
	0x20,
	0x61,
	0x72,
	0x65,
	0x20,
	0x72,
	0x65,
	0x66,
	0x65,
	0x72,
	0x72,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x66,
	0x72,
	0x65,
	0x65,
	0x64,
	0x6f,
	0x6d,
	0x2c,
	0x20,
	0x6e,
	0x6f,
	0x74,
	0x0a,
	0x70,
	0x72,
	0x69,
	0x63,
	0x65,
	0x2e,
	0x20,
	0x20,
	0x4f,
	0x75,
	0x72,
	0x20,
	0x47,
	0x65,
	0x6e,
	0x65,
	0x72,
	0x61,
	0x6c,
	0x20,
	0x50,
	0x75,
	0x62,
	0x6c,
	0x69,
	0x63,
	0x20,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x73,
	0x20,
	0x61,
	0x72,
	0x65,
	0x20,
	0x64,
	0x65,
	0x73,
	0x69,
	0x67,
	0x6e,
	0x65,
	0x64,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x6d,
	0x61,
	0x6b,
	0x65,
	0x20,
	0x73,
	0x75,
	0x72,
	0x65,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x0a,
	0x68,
	0x61,
	0x76,
	0x65,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x66,
	0x72,
	0x65,
	0x65,
	0x64,
	0x6f,
	0x6d,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x64,
	0x69,
	0x73,
	0x74,
	0x72,
	0x69,
	0x62,
	0x75,
	0x74,
	0x65,
	0x20,
	0x63,
	0x6f,
	0x70,
	0x69,
	0x65,
	0x73,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x66,
	0x72,
	0x65,
	0x65,
	0x20,
	0x73,
	0x6f,
	0x66,
	0x74,
	0x77,
	0x61,
	0x72,
	0x65,
	0x20,
	0x28,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x63,
	0x68,
	0x61,
	0x72,
	0x67,
	0x65,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x0a,
	0x74,
	0x68,
	0x65,
	0x6d,
	0x20,
	0x69,
	0x66,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x77,
	0x69,
	0x73,
	0x68,
	0x29,
	0x2c,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x72,
	0x65,
	0x63,
	0x65,
	0x69,
	0x76,
	0x65,
	0x20,
	0x73,
	0x6f,
	0x75,
	0x72,
	0x63,
	0x65,
	0x20,
	0x63,
	0x6f,
	0x64,
	0x65,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x63,
	0x61,
	0x6e,
	0x20,
	0x67,
	0x65,
	0x74,
	0x20,
	0x69,
	0x74,
	0x20,
	0x69,
	0x66,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x0a,
	0x77,
	0x61,
	0x6e,
	0x74,
	0x20,
	0x69,
	0x74,
	0x2c,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x63,
	0x61,
	0x6e,
	0x20,
	0x63,
	0x68,
	0x61,
	0x6e,
	0x67,
	0x65,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x73,
	0x6f,
	0x66,
	0x74,
	0x77,
	0x61,
	0x72,
	0x65,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x75,
	0x73,
	0x65,
	0x20,
	0x70,
	0x69,
	0x65,
	0x63,
	0x65,
	0x73,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x69,
	0x74,
	0x20,
	0x69,
	0x6e,
	0x20,
	0x6e,
	0x65,
	0x77,
	0x0a,
	0x66,
	0x72,
	0x65,
	0x65,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x67,
	0x72,
	0x61,
	0x6d,
	0x73,
	0x2c,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x6b,
	0x6e,
	0x6f,
	0x77,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x63,
	0x61,
	0x6e,
	0x20,
	0x64,
	0x6f,
	0x20,
	0x74,
	0x68,
	0x65,
	0x73,
	0x65,
	0x20,
	0x74,
	0x68,
	0x69,
	0x6e,
	0x67,
	0x73,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x54,
	0x6f,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x74,
	0x65,
	0x63,
	0x74,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x72,
	0x20,
	0x72,
	0x69,
	0x67,
	0x68,
	0x74,
	0x73,
	0x2c,
	0x20,
	0x77,
	0x65,
	0x20,
	0x6e,
	0x65,
	0x65,
	0x64,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x70,
	0x72,
	0x65,
	0x76,
	0x65,
	0x6e,
	0x74,
	0x20,
	0x6f,
	0x74,
	0x68,
	0x65,
	0x72,
	0x73,
	0x20,
	0x66,
	0x72,
	0x6f,
	0x6d,
	0x20,
	0x64,
	0x65,
	0x6e,
	0x79,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x0a,
	0x74,
	0x68,
	0x65,
	0x73,
	0x65,
	0x20,
	0x72,
	0x69,
	0x67,
	0x68,
	0x74,
	0x73,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x61,
	0x73,
	0x6b,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x73,
	0x75,
	0x72,
	0x72,
	0x65,
	0x6e,
	0x64,
	0x65,
	0x72,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x72,
	0x69,
	0x67,
	0x68,
	0x74,
	0x73,
	0x2e,
	0x20,
	0x20,
	0x54,
	0x68,
	0x65,
	0x72,
	0x65,
	0x66,
	0x6f,
	0x72,
	0x65,
	0x2c,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x68,
	0x61,
	0x76,
	0x65,
	0x0a,
	0x63,
	0x65,
	0x72,
	0x74,
	0x61,
	0x69,
	0x6e,
	0x20,
	0x72,
	0x65,
	0x73,
	0x70,
	0x6f,
	0x6e,
	0x73,
	0x69,
	0x62,
	0x69,
	0x6c,
	0x69,
	0x74,
	0x69,
	0x65,
	0x73,
	0x20,
	0x69,
	0x66,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x64,
	0x69,
	0x73,
	0x74,
	0x72,
	0x69,
	0x62,
	0x75,
	0x74,
	0x65,
	0x20,
	0x63,
	0x6f,
	0x70,
	0x69,
	0x65,
	0x73,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x73,
	0x6f,
	0x66,
	0x74,
	0x77,
	0x61,
	0x72,
	0x65,
	0x2c,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x69,
	0x66,
	0x0a,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x6d,
	0x6f,
	0x64,
	0x69,
	0x66,
	0x79,
	0x20,
	0x69,
	0x74,
	0x3a,
	0x20,
	0x72,
	0x65,
	0x73,
	0x70,
	0x6f,
	0x6e,
	0x73,
	0x69,
	0x62,
	0x69,
	0x6c,
	0x69,
	0x74,
	0x69,
	0x65,
	0x73,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x72,
	0x65,
	0x73,
	0x70,
	0x65,
	0x63,
	0x74,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x66,
	0x72,
	0x65,
	0x65,
	0x64,
	0x6f,
	0x6d,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x6f,
	0x74,
	0x68,
	0x65,
	0x72,
	0x73,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x46,
	0x6f,
	0x72,
	0x20,
	0x65,
	0x78,
	0x61,
	0x6d,
	0x70,
	0x6c,
	0x65,
	0x2c,
	0x20,
	0x69,
	0x66,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x64,
	0x69,
	0x73,
	0x74,
	0x72,
	0x69,
	0x62,
	0x75,
	0x74,
	0x65,
	0x20,
	0x63,
	0x6f,
	0x70,
	0x69,
	0x65,
	0x73,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x73,
	0x75,
	0x63,
	0x68,
	0x20,
	0x61,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x67,
	0x72,
	0x61,
	0x6d,
	0x2c,
	0x20,
	0x77,
	0x68,
	0x65,
	0x74,
	0x68,
	0x65,
	0x72,
	0x0a,
	0x67,
	0x72,
	0x61,
	0x74,
	0x69,
	0x73,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x20,
	0x61,
	0x20,
	0x66,
	0x65,
	0x65,
	0x2c,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x6d,
	0x75,
	0x73,
	0x74,
	0x20,
	0x70,
	0x61,
	0x73,
	0x73,
	0x20,
	0x6f,
	0x6e,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x72,
	0x65,
	0x63,
	0x69,
	0x70,
	0x69,
	0x65,
	0x6e,
	0x74,
	0x73,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x73,
	0x61,
	0x6d,
	0x65,
	0x0a,
	0x66,
	0x72,
	0x65,
	0x65,
	0x64,
	0x6f,
	0x6d,
	0x73,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x72,
	0x65,
	0x63,
	0x65,
	0x69,
	0x76,
	0x65,
	0x64,
	0x2e,
	0x20,
	0x20,
	0x59,
	0x6f,
	0x75,
	0x20,
	0x6d,
	0x75,
	0x73,
	0x74,
	0x20,
	0x6d,
	0x61,
	0x6b,
	0x65,
	0x20,
	0x73,
	0x75,
	0x72,
	0x65,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x74,
	0x68,
	0x65,
	0x79,
	0x2c,
	0x20,
	0x74,
	0x6f,
	0x6f,
	0x2c,
	0x20,
	0x72,
	0x65,
	0x63,
	0x65,
	0x69,
	0x76,
	0x65,
	0x0a,
	0x6f,
	0x72,
	0x20,
	0x63,
	0x61,
	0x6e,
	0x20,
	0x67,
	0x65,
	0x74,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x73,
	0x6f,
	0x75,
	0x72,
	0x63,
	0x65,
	0x20,
	0x63,
	0x6f,
	0x64,
	0x65,
	0x2e,
	0x20,
	0x20,
	0x41,
	0x6e,
	0x64,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x6d,
	0x75,
	0x73,
	0x74,
	0x20,
	0x73,
	0x68,
	0x6f,
	0x77,
	0x20,
	0x74,
	0x68,
	0x65,
	0x6d,
	0x20,
	0x74,
	0x68,
	0x65,
	0x73,
	0x65,
	0x20,
	0x74,
	0x65,
	0x72,
	0x6d,
	0x73,
	0x20,
	0x73,
	0x6f,
	0x20,
	0x74,
	0x68,
	0x65,
	0x79,
	0x0a,
	0x6b,
	0x6e,
	0x6f,
	0x77,
	0x20,
	0x74,
	0x68,
	0x65,
	0x69,
	0x72,
	0x20,
	0x72,
	0x69,
	0x67,
	0x68,
	0x74,
	0x73,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x44,
	0x65,
	0x76,
	0x65,
	0x6c,
	0x6f,
	0x70,
	0x65,
	0x72,
	0x73,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x75,
	0x73,
	0x65,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x47,
	0x4e,
	0x55,
	0x20,
	0x47,
	0x50,
	0x4c,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x74,
	0x65,
	0x63,
	0x74,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x72,
	0x20,
	0x72,
	0x69,
	0x67,
	0x68,
	0x74,
	0x73,
	0x20,
	0x77,
	0x69,
	0x74,
	0x68,
	0x20,
	0x74,
	0x77,
	0x6f,
	0x20,
	0x73,
	0x74,
	0x65,
	0x70,
	0x73,
	0x3a,
	0x0a,
	0x28,
	0x31,
	0x29,
	0x20,
	0x61,
	0x73,
	0x73,
	0x65,
	0x72,
	0x74,
	0x20,
	0x63,
	0x6f,
	0x70,
	0x79,
	0x72,
	0x69,
	0x67,
	0x68,
	0x74,
	0x20,
	0x6f,
	0x6e,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x73,
	0x6f,
	0x66,
	0x74,
	0x77,
	0x61,
	0x72,
	0x65,
	0x2c,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x28,
	0x32,
	0x29,
	0x20,
	0x6f,
	0x66,
	0x66,
	0x65,
	0x72,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x74,
	0x68,
	0x69,
	0x73,
	0x20,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x0a,
	0x67,
	0x69,
	0x76,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x6c,
	0x65,
	0x67,
	0x61,
	0x6c,
	0x20,
	0x70,
	0x65,
	0x72,
	0x6d,
	0x69,
	0x73,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x63,
	0x6f,
	0x70,
	0x79,
	0x2c,
	0x20,
	0x64,
	0x69,
	0x73,
	0x74,
	0x72,
	0x69,
	0x62,
	0x75,
	0x74,
	0x65,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x2f,
	0x6f,
	0x72,
	0x20,
	0x6d,
	0x6f,
	0x64,
	0x69,
	0x66,
	0x79,
	0x20,
	0x69,
	0x74,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x46,
	0x6f,
	0x72,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x64,
	0x65,
	0x76,
	0x65,
	0x6c,
	0x6f,
	0x70,
	0x65,
	0x72,
	0x73,
	0x27,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x61,
	0x75,
	0x74,
	0x68,
	0x6f,
	0x72,
	0x73,
	0x27,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x74,
	0x65,
	0x63,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x2c,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x47,
	0x50,
	0x4c,
	0x20,
	0x63,
	0x6c,
	0x65,
	0x61,
	0x72,
	0x6c,
	0x79,
	0x20,
	0x65,
	0x78,
	0x70,
	0x6c,
	0x61,
	0x69,
	0x6e,
	0x73,
	0x0a,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x74,
	0x68,
	0x65,
	0x72,
	0x65,
	0x20,
	0x69,
	0x73,
	0x20,
	0x6e,
	0x6f,
	0x20,
	0x77,
	0x61,
	0x72,
	0x72,
	0x61,
	0x6e,
	0x74,
	0x79,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x20,
	0x74,
	0x68,
	0x69,
	0x73,
	0x20,
	0x66,
	0x72,
	0x65,
	0x65,
	0x20,
	0x73,
	0x6f,
	0x66,
	0x74,
	0x77,
	0x61,
	0x72,
	0x65,
	0x2e,
	0x20,
	0x20,
	0x46,
	0x6f,
	0x72,
	0x20,
	0x62,
	0x6f,
	0x74,
	0x68,
	0x20,
	0x75,
	0x73,
	0x65,
	0x72,
	0x73,
	0x27,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x0a,
	0x61,
	0x75,
	0x74,
	0x68,
	0x6f,
	0x72,
	0x73,
	0x27,
	0x20,
	0x73,
	0x61,
	0x6b,
	0x65,
	0x2c,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x47,
	0x50,
	0x4c,
	0x20,
	0x72,
	0x65,
	0x71,
	0x75,
	0x69,
	0x72,
	0x65,
	0x73,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x6d,
	0x6f,
	0x64,
	0x69,
	0x66,
	0x69,
	0x65,
	0x64,
	0x20,
	0x76,
	0x65,
	0x72,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x73,
	0x20,
	0x62,
	0x65,
	0x20,
	0x6d,
	0x61,
	0x72,
	0x6b,
	0x65,
	0x64,
	0x20,
	0x61,
	0x73,
	0x0a,
	0x63,
	0x68,
	0x61,
	0x6e,
	0x67,
	0x65,
	0x64,
	0x2c,
	0x20,
	0x73,
	0x6f,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x74,
	0x68,
	0x65,
	0x69,
	0x72,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x62,
	0x6c,
	0x65,
	0x6d,
	0x73,
	0x20,
	0x77,
	0x69,
	0x6c,
	0x6c,
	0x20,
	0x6e,
	0x6f,
	0x74,
	0x20,
	0x62,
	0x65,
	0x20,
	0x61,
	0x74,
	0x74,
	0x72,
	0x69,
	0x62,
	0x75,
	0x74,
	0x65,
	0x64,
	0x20,
	0x65,
	0x72,
	0x72,
	0x6f,
	0x6e,
	0x65,
	0x6f,
	0x75,
	0x73,
	0x6c,
	0x79,
	0x20,
	0x74,
	0x6f,
	0x0a,
	0x61,
	0x75,
	0x74,
	0x68,
	0x6f,
	0x72,
	0x73,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x70,
	0x72,
	0x65,
	0x76,
	0x69,
	0x6f,
	0x75,
	0x73,
	0x20,
	0x76,
	0x65,
	0x72,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x73,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x53,
	0x6f,
	0x6d,
	0x65,
	0x20,
	0x64,
	0x65,
	0x76,
	0x69,
	0x63,
	0x65,
	0x73,
	0x20,
	0x61,
	0x72,
	0x65,
	0x20,
	0x64,
	0x65,
	0x73,
	0x69,
	0x67,
	0x6e,
	0x65,
	0x64,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x64,
	0x65,
	0x6e,
	0x79,
	0x20,
	0x75,
	0x73,
	0x65,
	0x72,
	0x73,
	0x20,
	0x61,
	0x63,
	0x63,
	0x65,
	0x73,
	0x73,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x69,
	0x6e,
	0x73,
	0x74,
	0x61,
	0x6c,
	0x6c,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x72,
	0x75,
	0x6e,
	0x0a,
	0x6d,
	0x6f,
	0x64,
	0x69,
	0x66,
	0x69,
	0x65,
	0x64,
	0x20,
	0x76,
	0x65,
	0x72,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x73,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x73,
	0x6f,
	0x66,
	0x74,
	0x77,
	0x61,
	0x72,
	0x65,
	0x20,
	0x69,
	0x6e,
	0x73,
	0x69,
	0x64,
	0x65,
	0x20,
	0x74,
	0x68,
	0x65,
	0x6d,
	0x2c,
	0x20,
	0x61,
	0x6c,
	0x74,
	0x68,
	0x6f,
	0x75,
	0x67,
	0x68,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x6d,
	0x61,
	0x6e,
	0x75,
	0x66,
	0x61,
	0x63,
	0x74,
	0x75,
	0x72,
	0x65,
	0x72,
	0x0a,
	0x63,
	0x61,
	0x6e,
	0x20,
	0x64,
	0x6f,
	0x20,
	0x73,
	0x6f,
	0x2e,
	0x20,
	0x20,
	0x54,
	0x68,
	0x69,
	0x73,
	0x20,
	0x69,
	0x73,
	0x20,
	0x66,
	0x75,
	0x6e,
	0x64,
	0x61,
	0x6d,
	0x65,
	0x6e,
	0x74,
	0x61,
	0x6c,
	0x6c,
	0x79,
	0x20,
	0x69,
	0x6e,
	0x63,
	0x6f,
	0x6d,
	0x70,
	0x61,
	0x74,
	0x69,
	0x62,
	0x6c,
	0x65,
	0x20,
	0x77,
	0x69,
	0x74,
	0x68,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x61,
	0x69,
	0x6d,
	0x20,
	0x6f,
	0x66,
	0x0a,
	0x70,
	0x72,
	0x6f,
	0x74,
	0x65,
	0x63,
	0x74,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x75,
	0x73,
	0x65,
	0x72,
	0x73,
	0x27,
	0x20,
	0x66,
	0x72,
	0x65,
	0x65,
	0x64,
	0x6f,
	0x6d,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x63,
	0x68,
	0x61,
	0x6e,
	0x67,
	0x65,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x73,
	0x6f,
	0x66,
	0x74,
	0x77,
	0x61,
	0x72,
	0x65,
	0x2e,
	0x20,
	0x20,
	0x54,
	0x68,
	0x65,
	0x20,
	0x73,
	0x79,
	0x73,
	0x74,
	0x65,
	0x6d,
	0x61,
	0x74,
	0x69,
	0x63,
	0x0a,
	0x70,
	0x61,
	0x74,
	0x74,
	0x65,
	0x72,
	0x6e,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x73,
	0x75,
	0x63,
	0x68,
	0x20,
	0x61,
	0x62,
	0x75,
	0x73,
	0x65,
	0x20,
	0x6f,
	0x63,
	0x63,
	0x75,
	0x72,
	0x73,
	0x20,
	0x69,
	0x6e,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x61,
	0x72,
	0x65,
	0x61,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x64,
	0x75,
	0x63,
	0x74,
	0x73,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x20,
	0x69,
	0x6e,
	0x64,
	0x69,
	0x76,
	0x69,
	0x64,
	0x75,
	0x61,
	0x6c,
	0x73,
	0x20,
	0x74,
	0x6f,
	0x0a,
	0x75,
	0x73,
	0x65,
	0x2c,
	0x20,
	0x77,
	0x68,
	0x69,
	0x63,
	0x68,
	0x20,
	0x69,
	0x73,
	0x20,
	0x70,
	0x72,
	0x65,
	0x63,
	0x69,
	0x73,
	0x65,
	0x6c,
	0x79,
	0x20,
	0x77,
	0x68,
	0x65,
	0x72,
	0x65,
	0x20,
	0x69,
	0x74,
	0x20,
	0x69,
	0x73,
	0x20,
	0x6d,
	0x6f,
	0x73,
	0x74,
	0x20,
	0x75,
	0x6e,
	0x61,
	0x63,
	0x63,
	0x65,
	0x70,
	0x74,
	0x61,
	0x62,
	0x6c,
	0x65,
	0x2e,
	0x20,
	0x20,
	0x54,
	0x68,
	0x65,
	0x72,
	0x65,
	0x66,
	0x6f,
	0x72,
	0x65,
	0x2c,
	0x20,
	0x77,
	0x65,
	0x0a,
	0x68,
	0x61,
	0x76,
	0x65,
	0x20,
	0x64,
	0x65,
	0x73,
	0x69,
	0x67,
	0x6e,
	0x65,
	0x64,
	0x20,
	0x74,
	0x68,
	0x69,
	0x73,
	0x20,
	0x76,
	0x65,
	0x72,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x47,
	0x50,
	0x4c,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x68,
	0x69,
	0x62,
	0x69,
	0x74,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x70,
	0x72,
	0x61,
	0x63,
	0x74,
	0x69,
	0x63,
	0x65,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x20,
	0x74,
	0x68,
	0x6f,
	0x73,
	0x65,
	0x0a,
	0x70,
	0x72,
	0x6f,
	0x64,
	0x75,
	0x63,
	0x74,
	0x73,
	0x2e,
	0x20,
	0x20,
	0x49,
	0x66,
	0x20,
	0x73,
	0x75,
	0x63,
	0x68,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x62,
	0x6c,
	0x65,
	0x6d,
	0x73,
	0x20,
	0x61,
	0x72,
	0x69,
	0x73,
	0x65,
	0x20,
	0x73,
	0x75,
	0x62,
	0x73,
	0x74,
	0x61,
	0x6e,
	0x74,
	0x69,
	0x61,
	0x6c,
	0x6c,
	0x79,
	0x20,
	0x69,
	0x6e,
	0x20,
	0x6f,
	0x74,
	0x68,
	0x65,
	0x72,
	0x20,
	0x64,
	0x6f,
	0x6d,
	0x61,
	0x69,
	0x6e,
	0x73,
	0x2c,
	0x20,
	0x77,
	0x65,
	0x0a,
	0x73,
	0x74,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x72,
	0x65,
	0x61,
	0x64,
	0x79,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x65,
	0x78,
	0x74,
	0x65,
	0x6e,
	0x64,
	0x20,
	0x74,
	0x68,
	0x69,
	0x73,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x76,
	0x69,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x74,
	0x68,
	0x6f,
	0x73,
	0x65,
	0x20,
	0x64,
	0x6f,
	0x6d,
	0x61,
	0x69,
	0x6e,
	0x73,
	0x20,
	0x69,
	0x6e,
	0x20,
	0x66,
	0x75,
	0x74,
	0x75,
	0x72,
	0x65,
	0x20,
	0x76,
	0x65,
	0x72,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x73,
	0x0a,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x47,
	0x50,
	0x4c,
	0x2c,
	0x20,
	0x61,
	0x73,
	0x20,
	0x6e,
	0x65,
	0x65,
	0x64,
	0x65,
	0x64,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x74,
	0x65,
	0x63,
	0x74,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x66,
	0x72,
	0x65,
	0x65,
	0x64,
	0x6f,
	0x6d,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x75,
	0x73,
	0x65,
	0x72,
	0x73,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x46,
	0x69,
	0x6e,
	0x61,
	0x6c,
	0x6c,
	0x79,
	0x2c,
	0x20,
	0x65,
	0x76,
	0x65,
	0x72,
	0x79,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x67,
	0x72,
	0x61,
	0x6d,
	0x20,
	0x69,
	0x73,
	0x20,
	0x74,
	0x68,
	0x72,
	0x65,
	0x61,
	0x74,
	0x65,
	0x6e,
	0x65,
	0x64,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x73,
	0x74,
	0x61,
	0x6e,
	0x74,
	0x6c,
	0x79,
	0x20,
	0x62,
	0x79,
	0x20,
	0x73,
	0x6f,
	0x66,
	0x74,
	0x77,
	0x61,
	0x72,
	0x65,
	0x20,
	0x70,
	0x61,
	0x74,
	0x65,
	0x6e,
	0x74,
	0x73,
	0x2e,
	0x0a,
	0x53,
	0x74,
	0x61,
	0x74,
	0x65,
	0x73,
	0x20,
	0x73,
	0x68,
	0x6f,
	0x75,
	0x6c,
	0x64,
	0x20,
	0x6e,
	0x6f,
	0x74,
	0x20,
	0x61,
	0x6c,
	0x6c,
	0x6f,
	0x77,
	0x20,
	0x70,
	0x61,
	0x74,
	0x65,
	0x6e,
	0x74,
	0x73,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x72,
	0x65,
	0x73,
	0x74,
	0x72,
	0x69,
	0x63,
	0x74,
	0x20,
	0x64,
	0x65,
	0x76,
	0x65,
	0x6c,
	0x6f,
	0x70,
	0x6d,
	0x65,
	0x6e,
	0x74,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x75,
	0x73,
	0x65,
	0x20,
	0x6f,
	0x66,
	0x0a,
	0x73,
	0x6f,
	0x66,
	0x74,
	0x77,
	0x61,
	0x72,
	0x65,
	0x20,
	0x6f,
	0x6e,
	0x20,
	0x67,
	0x65,
	0x6e,
	0x65,
	0x72,
	0x61,
	0x6c,
	0x2d,
	0x70,
	0x75,
	0x72,
	0x70,
	0x6f,
	0x73,
	0x65,
	0x20,
	0x63,
	0x6f,
	0x6d,
	0x70,
	0x75,
	0x74,
	0x65,
	0x72,
	0x73,
	0x2c,
	0x20,
	0x62,
	0x75,
	0x74,
	0x20,
	0x69,
	0x6e,
	0x20,
	0x74,
	0x68,
	0x6f,
	0x73,
	0x65,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x64,
	0x6f,
	0x2c,
	0x20,
	0x77,
	0x65,
	0x20,
	0x77,
	0x69,
	0x73,
	0x68,
	0x20,
	0x74,
	0x6f,
	0x0a,
	0x61,
	0x76,
	0x6f,
	0x69,
	0x64,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x73,
	0x70,
	0x65,
	0x63,
	0x69,
	0x61,
	0x6c,
	0x20,
	0x64,
	0x61,
	0x6e,
	0x67,
	0x65,
	0x72,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x70,
	0x61,
	0x74,
	0x65,
	0x6e,
	0x74,
	0x73,
	0x20,
	0x61,
	0x70,
	0x70,
	0x6c,
	0x69,
	0x65,
	0x64,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x61,
	0x20,
	0x66,
	0x72,
	0x65,
	0x65,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x67,
	0x72,
	0x61,
	0x6d,
	0x20,
	0x63,
	0x6f,
	0x75,
	0x6c,
	0x64,
	0x0a,
	0x6d,
	0x61,
	0x6b,
	0x65,
	0x20,
	0x69,
	0x74,
	0x20,
	0x65,
	0x66,
	0x66,
	0x65,
	0x63,
	0x74,
	0x69,
	0x76,
	0x65,
	0x6c,
	0x79,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x70,
	0x72,
	0x69,
	0x65,
	0x74,
	0x61,
	0x72,
	0x79,
	0x2e,
	0x20,
	0x20,
	0x54,
	0x6f,
	0x20,
	0x70,
	0x72,
	0x65,
	0x76,
	0x65,
	0x6e,
	0x74,
	0x20,
	0x74,
	0x68,
	0x69,
	0x73,
	0x2c,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x47,
	0x50,
	0x4c,
	0x20,
	0x61,
	0x73,
	0x73,
	0x75,
	0x72,
	0x65,
	0x73,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x0a,
	0x70,
	0x61,
	0x74,
	0x65,
	0x6e,
	0x74,
	0x73,
	0x20,
	0x63,
	0x61,
	0x6e,
	0x6e,
	0x6f,
	0x74,
	0x20,
	0x62,
	0x65,
	0x20,
	0x75,
	0x73,
	0x65,
	0x64,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x72,
	0x65,
	0x6e,
	0x64,
	0x65,
	0x72,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x67,
	0x72,
	0x61,
	0x6d,
	0x20,
	0x6e,
	0x6f,
	0x6e,
	0x2d,
	0x66,
	0x72,
	0x65,
	0x65,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x54,
	0x68,
	0x65,
	0x20,
	0x70,
	0x72,
	0x65,
	0x63,
	0x69,
	0x73,
	0x65,
	0x20,
	0x74,
	0x65,
	0x72,
	0x6d,
	0x73,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x64,
	0x69,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x73,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x20,
	0x63,
	0x6f,
	0x70,
	0x79,
	0x69,
	0x6e,
	0x67,
	0x2c,
	0x20,
	0x64,
	0x69,
	0x73,
	0x74,
	0x72,
	0x69,
	0x62,
	0x75,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x0a,
	0x6d,
	0x6f,
	0x64,
	0x69,
	0x66,
	0x69,
	0x63,
	0x61,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x66,
	0x6f,
	0x6c,
	0x6c,
	0x6f,
	0x77,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x54,
	0x45,
	0x52,
	0x4d,
	0x53,
	0x20,
	0x41,
	0x4e,
	0x44,
	0x20,
	0x43,
	0x4f,
	0x4e,
	0x44,
	0x49,
	0x54,
	0x49,
	0x4f,
	0x4e,
	0x53,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x30,
	0x2e,
	0x20,
	0x44,
	0x65,
	0x66,
	0x69,
	0x6e,
	0x69,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x73,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x22,
	0x54,
	0x68,
	0x69,
	0x73,
	0x20,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x22,
	0x20,
	0x72,
	0x65,
	0x66,
	0x65,
	0x72,
	0x73,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x76,
	0x65,
	0x72,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x33,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x47,
	0x4e,
	0x55,
	0x20,
	0x47,
	0x65,
	0x6e,
	0x65,
	0x72,
	0x61,
	0x6c,
	0x20,
	0x50,
	0x75,
	0x62,
	0x6c,
	0x69,
	0x63,
	0x20,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x22,
	0x43,
	0x6f,
	0x70,
	0x79,
	0x72,
	0x69,
	0x67,
	0x68,
	0x74,
	0x22,
	0x20,
	0x61,
	0x6c,
	0x73,
	0x6f,
	0x20,
	0x6d,
	0x65,
	0x61,
	0x6e,
	0x73,
	0x20,
	0x63,
	0x6f,
	0x70,
	0x79,
	0x72,
	0x69,
	0x67,
	0x68,
	0x74,
	0x2d,
	0x6c,
	0x69,
	0x6b,
	0x65,
	0x20,
	0x6c,
	0x61,
	0x77,
	0x73,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x61,
	0x70,
	0x70,
	0x6c,
	0x79,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x6f,
	0x74,
	0x68,
	0x65,
	0x72,
	0x20,
	0x6b,
	0x69,
	0x6e,
	0x64,
	0x73,
	0x20,
	0x6f,
	0x66,
	0x0a,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x73,
	0x2c,
	0x20,
	0x73,
	0x75,
	0x63,
	0x68,
	0x20,
	0x61,
	0x73,
	0x20,
	0x73,
	0x65,
	0x6d,
	0x69,
	0x63,
	0x6f,
	0x6e,
	0x64,
	0x75,
	0x63,
	0x74,
	0x6f,
	0x72,
	0x20,
	0x6d,
	0x61,
	0x73,
	0x6b,
	0x73,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x22,
	0x54,
	0x68,
	0x65,
	0x20,
	0x50,
	0x72,
	0x6f,
	0x67,
	0x72,
	0x61,
	0x6d,
	0x22,
	0x20,
	0x72,
	0x65,
	0x66,
	0x65,
	0x72,
	0x73,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x61,
	0x6e,
	0x79,
	0x20,
	0x63,
	0x6f,
	0x70,
	0x79,
	0x72,
	0x69,
	0x67,
	0x68,
	0x74,
	0x61,
	0x62,
	0x6c,
	0x65,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x20,
	0x6c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x64,
	0x20,
	0x75,
	0x6e,
	0x64,
	0x65,
	0x72,
	0x20,
	0x74,
	0x68,
	0x69,
	0x73,
	0x0a,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x2e,
	0x20,
	0x20,
	0x45,
	0x61,
	0x63,
	0x68,
	0x20,
	0x6c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x65,
	0x20,
	0x69,
	0x73,
	0x20,
	0x61,
	0x64,
	0x64,
	0x72,
	0x65,
	0x73,
	0x73,
	0x65,
	0x64,
	0x20,
	0x61,
	0x73,
	0x20,
	0x22,
	0x79,
	0x6f,
	0x75,
	0x22,
	0x2e,
	0x20,
	0x20,
	0x22,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x65,
	0x73,
	0x22,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x0a,
	0x22,
	0x72,
	0x65,
	0x63,
	0x69,
	0x70,
	0x69,
	0x65,
	0x6e,
	0x74,
	0x73,
	0x22,
	0x20,
	0x6d,
	0x61,
	0x79,
	0x20,
	0x62,
	0x65,
	0x20,
	0x69,
	0x6e,
	0x64,
	0x69,
	0x76,
	0x69,
	0x64,
	0x75,
	0x61,
	0x6c,
	0x73,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x6f,
	0x72,
	0x67,
	0x61,
	0x6e,
	0x69,
	0x7a,
	0x61,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x73,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x54,
	0x6f,
	0x20,
	0x22,
	0x6d,
	0x6f,
	0x64,
	0x69,
	0x66,
	0x79,
	0x22,
	0x20,
	0x61,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x20,
	0x6d,
	0x65,
	0x61,
	0x6e,
	0x73,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x63,
	0x6f,
	0x70,
	0x79,
	0x20,
	0x66,
	0x72,
	0x6f,
	0x6d,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x61,
	0x64,
	0x61,
	0x70,
	0x74,
	0x20,
	0x61,
	0x6c,
	0x6c,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x70,
	0x61,
	0x72,
	0x74,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x0a,
	0x69,
	0x6e,
	0x20,
	0x61,
	0x20,
	0x66,
	0x61,
	0x73,
	0x68,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x72,
	0x65,
	0x71,
	0x75,
	0x69,
	0x72,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x63,
	0x6f,
	0x70,
	0x79,
	0x72,
	0x69,
	0x67,
	0x68,
	0x74,
	0x20,
	0x70,
	0x65,
	0x72,
	0x6d,
	0x69,
	0x73,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x2c,
	0x20,
	0x6f,
	0x74,
	0x68,
	0x65,
	0x72,
	0x20,
	0x74,
	0x68,
	0x61,
	0x6e,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x6d,
	0x61,
	0x6b,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x61,
	0x6e,
	0x0a,
	0x65,
	0x78,
	0x61,
	0x63,
	0x74,
	0x20,
	0x63,
	0x6f,
	0x70,
	0x79,
	0x2e,
	0x20,
	0x20,
	0x54,
	0x68,
	0x65,
	0x20,
	0x72,
	0x65,
	0x73,
	0x75,
	0x6c,
	0x74,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x20,
	0x69,
	0x73,
	0x20,
	0x63,
	0x61,
	0x6c,
	0x6c,
	0x65,
	0x64,
	0x20,
	0x61,
	0x20,
	0x22,
	0x6d,
	0x6f,
	0x64,
	0x69,
	0x66,
	0x69,
	0x65,
	0x64,
	0x20,
	0x76,
	0x65,
	0x72,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x22,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x0a,
	0x65,
	0x61,
	0x72,
	0x6c,
	0x69,
	0x65,
	0x72,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x61,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x20,
	0x22,
	0x62,
	0x61,
	0x73,
	0x65,
	0x64,
	0x20,
	0x6f,
	0x6e,
	0x22,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x65,
	0x61,
	0x72,
	0x6c,
	0x69,
	0x65,
	0x72,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x41,
	0x20,
	0x22,
	0x63,
	0x6f,
	0x76,
	0x65,
	0x72,
	0x65,
	0x64,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x22,
	0x20,
	0x6d,
	0x65,
	0x61,
	0x6e,
	0x73,
	0x20,
	0x65,
	0x69,
	0x74,
	0x68,
	0x65,
	0x72,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x75,
	0x6e,
	0x6d,
	0x6f,
	0x64,
	0x69,
	0x66,
	0x69,
	0x65,
	0x64,
	0x20,
	0x50,
	0x72,
	0x6f,
	0x67,
	0x72,
	0x61,
	0x6d,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x61,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x20,
	0x62,
	0x61,
	0x73,
	0x65,
	0x64,
	0x0a,
	0x6f,
	0x6e,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x50,
	0x72,
	0x6f,
	0x67,
	0x72,
	0x61,
	0x6d,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x54,
	0x6f,
	0x20,
	0x22,
	0x70,
	0x72,
	0x6f,
	0x70,
	0x61,
	0x67,
	0x61,
	0x74,
	0x65,
	0x22,
	0x20,
	0x61,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x20,
	0x6d,
	0x65,
	0x61,
	0x6e,
	0x73,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x64,
	0x6f,
	0x20,
	0x61,
	0x6e,
	0x79,
	0x74,
	0x68,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x77,
	0x69,
	0x74,
	0x68,
	0x20,
	0x69,
	0x74,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x2c,
	0x20,
	0x77,
	0x69,
	0x74,
	0x68,
	0x6f,
	0x75,
	0x74,
	0x0a,
	0x70,
	0x65,
	0x72,
	0x6d,
	0x69,
	0x73,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x2c,
	0x20,
	0x77,
	0x6f,
	0x75,
	0x6c,
	0x64,
	0x20,
	0x6d,
	0x61,
	0x6b,
	0x65,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x64,
	0x69,
	0x72,
	0x65,
	0x63,
	0x74,
	0x6c,
	0x79,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x73,
	0x65,
	0x63,
	0x6f,
	0x6e,
	0x64,
	0x61,
	0x72,
	0x69,
	0x6c,
	0x79,
	0x20,
	0x6c,
	0x69,
	0x61,
	0x62,
	0x6c,
	0x65,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x0a,
	0x69,
	0x6e,
	0x66,
	0x72,
	0x69,
	0x6e,
	0x67,
	0x65,
	0x6d,
	0x65,
	0x6e,
	0x74,
	0x20,
	0x75,
	0x6e,
	0x64,
	0x65,
	0x72,
	0x20,
	0x61,
	0x70,
	0x70,
	0x6c,
	0x69,
	0x63,
	0x61,
	0x62,
	0x6c,
	0x65,
	0x20,
	0x63,
	0x6f,
	0x70,
	0x79,
	0x72,
	0x69,
	0x67,
	0x68,
	0x74,
	0x20,
	0x6c,
	0x61,
	0x77,
	0x2c,
	0x20,
	0x65,
	0x78,
	0x63,
	0x65,
	0x70,
	0x74,
	0x20,
	0x65,
	0x78,
	0x65,
	0x63,
	0x75,
	0x74,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x69,
	0x74,
	0x20,
	0x6f,
	0x6e,
	0x20,
	0x61,
	0x0a,
	0x63,
	0x6f,
	0x6d,
	0x70,
	0x75,
	0x74,
	0x65,
	0x72,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x6d,
	0x6f,
	0x64,
	0x69,
	0x66,
	0x79,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x61,
	0x20,
	0x70,
	0x72,
	0x69,
	0x76,
	0x61,
	0x74,
	0x65,
	0x20,
	0x63,
	0x6f,
	0x70,
	0x79,
	0x2e,
	0x20,
	0x20,
	0x50,
	0x72,
	0x6f,
	0x70,
	0x61,
	0x67,
	0x61,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x69,
	0x6e,
	0x63,
	0x6c,
	0x75,
	0x64,
	0x65,
	0x73,
	0x20,
	0x63,
	0x6f,
	0x70,
	0x79,
	0x69,
	0x6e,
	0x67,
	0x2c,
	0x0a,
	0x64,
	0x69,
	0x73,
	0x74,
	0x72,
	0x69,
	0x62,
	0x75,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x28,
	0x77,
	0x69,
	0x74,
	0x68,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x77,
	0x69,
	0x74,
	0x68,
	0x6f,
	0x75,
	0x74,
	0x20,
	0x6d,
	0x6f,
	0x64,
	0x69,
	0x66,
	0x69,
	0x63,
	0x61,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x29,
	0x2c,
	0x20,
	0x6d,
	0x61,
	0x6b,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x61,
	0x76,
	0x61,
	0x69,
	0x6c,
	0x61,
	0x62,
	0x6c,
	0x65,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x74,
	0x68,
	0x65,
	0x0a,
	0x70,
	0x75,
	0x62,
	0x6c,
	0x69,
	0x63,
	0x2c,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x69,
	0x6e,
	0x20,
	0x73,
	0x6f,
	0x6d,
	0x65,
	0x20,
	0x63,
	0x6f,
	0x75,
	0x6e,
	0x74,
	0x72,
	0x69,
	0x65,
	0x73,
	0x20,
	0x6f,
	0x74,
	0x68,
	0x65,
	0x72,
	0x20,
	0x61,
	0x63,
	0x74,
	0x69,
	0x76,
	0x69,
	0x74,
	0x69,
	0x65,
	0x73,
	0x20,
	0x61,
	0x73,
	0x20,
	0x77,
	0x65,
	0x6c,
	0x6c,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x54,
	0x6f,
	0x20,
	0x22,
	0x63,
	0x6f,
	0x6e,
	0x76,
	0x65,
	0x79,
	0x22,
	0x20,
	0x61,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x20,
	0x6d,
	0x65,
	0x61,
	0x6e,
	0x73,
	0x20,
	0x61,
	0x6e,
	0x79,
	0x20,
	0x6b,
	0x69,
	0x6e,
	0x64,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x70,
	0x61,
	0x67,
	0x61,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x65,
	0x6e,
	0x61,
	0x62,
	0x6c,
	0x65,
	0x73,
	0x20,
	0x6f,
	0x74,
	0x68,
	0x65,
	0x72,
	0x0a,
	0x70,
	0x61,
	0x72,
	0x74,
	0x69,
	0x65,
	0x73,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x6d,
	0x61,
	0x6b,
	0x65,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x72,
	0x65,
	0x63,
	0x65,
	0x69,
	0x76,
	0x65,
	0x20,
	0x63,
	0x6f,
	0x70,
	0x69,
	0x65,
	0x73,
	0x2e,
	0x20,
	0x20,
	0x4d,
	0x65,
	0x72,
	0x65,
	0x20,
	0x69,
	0x6e,
	0x74,
	0x65,
	0x72,
	0x61,
	0x63,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x77,
	0x69,
	0x74,
	0x68,
	0x20,
	0x61,
	0x20,
	0x75,
	0x73,
	0x65,
	0x72,
	0x20,
	0x74,
	0x68,
	0x72,
	0x6f,
	0x75,
	0x67,
	0x68,
	0x0a,
	0x61,
	0x20,
	0x63,
	0x6f,
	0x6d,
	0x70,
	0x75,
	0x74,
	0x65,
	0x72,
	0x20,
	0x6e,
	0x65,
	0x74,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x2c,
	0x20,
	0x77,
	0x69,
	0x74,
	0x68,
	0x20,
	0x6e,
	0x6f,
	0x20,
	0x74,
	0x72,
	0x61,
	0x6e,
	0x73,
	0x66,
	0x65,
	0x72,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x61,
	0x20,
	0x63,
	0x6f,
	0x70,
	0x79,
	0x2c,
	0x20,
	0x69,
	0x73,
	0x20,
	0x6e,
	0x6f,
	0x74,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x76,
	0x65,
	0x79,
	0x69,
	0x6e,
	0x67,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x41,
	0x6e,
	0x20,
	0x69,
	0x6e,
	0x74,
	0x65,
	0x72,
	0x61,
	0x63,
	0x74,
	0x69,
	0x76,
	0x65,
	0x20,
	0x75,
	0x73,
	0x65,
	0x72,
	0x20,
	0x69,
	0x6e,
	0x74,
	0x65,
	0x72,
	0x66,
	0x61,
	0x63,
	0x65,
	0x20,
	0x64,
	0x69,
	0x73,
	0x70,
	0x6c,
	0x61,
	0x79,
	0x73,
	0x20,
	0x22,
	0x41,
	0x70,
	0x70,
	0x72,
	0x6f,
	0x70,
	0x72,
	0x69,
	0x61,
	0x74,
	0x65,
	0x20,
	0x4c,
	0x65,
	0x67,
	0x61,
	0x6c,
	0x20,
	0x4e,
	0x6f,
	0x74,
	0x69,
	0x63,
	0x65,
	0x73,
	0x22,
	0x0a,
	0x74,
	0x6f,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x65,
	0x78,
	0x74,
	0x65,
	0x6e,
	0x74,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x69,
	0x74,
	0x20,
	0x69,
	0x6e,
	0x63,
	0x6c,
	0x75,
	0x64,
	0x65,
	0x73,
	0x20,
	0x61,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x76,
	0x65,
	0x6e,
	0x69,
	0x65,
	0x6e,
	0x74,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x6d,
	0x69,
	0x6e,
	0x65,
	0x6e,
	0x74,
	0x6c,
	0x79,
	0x20,
	0x76,
	0x69,
	0x73,
	0x69,
	0x62,
	0x6c,
	0x65,
	0x0a,
	0x66,
	0x65,
	0x61,
	0x74,
	0x75,
	0x72,
	0x65,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x28,
	0x31,
	0x29,
	0x20,
	0x64,
	0x69,
	0x73,
	0x70,
	0x6c,
	0x61,
	0x79,
	0x73,
	0x20,
	0x61,
	0x6e,
	0x20,
	0x61,
	0x70,
	0x70,
	0x72,
	0x6f,
	0x70,
	0x72,
	0x69,
	0x61,
	0x74,
	0x65,
	0x20,
	0x63,
	0x6f,
	0x70,
	0x79,
	0x72,
	0x69,
	0x67,
	0x68,
	0x74,
	0x20,
	0x6e,
	0x6f,
	0x74,
	0x69,
	0x63,
	0x65,
	0x2c,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x28,
	0x32,
	0x29,
	0x0a,
	0x74,
	0x65,
	0x6c,
	0x6c,
	0x73,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x75,
	0x73,
	0x65,
	0x72,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x74,
	0x68,
	0x65,
	0x72,
	0x65,
	0x20,
	0x69,
	0x73,
	0x20,
	0x6e,
	0x6f,
	0x20,
	0x77,
	0x61,
	0x72,
	0x72,
	0x61,
	0x6e,
	0x74,
	0x79,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x20,
	0x28,
	0x65,
	0x78,
	0x63,
	0x65,
	0x70,
	0x74,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x74,
	0x68,
	0x65,
	0x0a,
	0x65,
	0x78,
	0x74,
	0x65,
	0x6e,
	0x74,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x77,
	0x61,
	0x72,
	0x72,
	0x61,
	0x6e,
	0x74,
	0x69,
	0x65,
	0x73,
	0x20,
	0x61,
	0x72,
	0x65,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x76,
	0x69,
	0x64,
	0x65,
	0x64,
	0x29,
	0x2c,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x6c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x65,
	0x73,
	0x20,
	0x6d,
	0x61,
	0x79,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x76,
	0x65,
	0x79,
	0x20,
	0x74,
	0x68,
	0x65,
	0x0a,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x20,
	0x75,
	0x6e,
	0x64,
	0x65,
	0x72,
	0x20,
	0x74,
	0x68,
	0x69,
	0x73,
	0x20,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x2c,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x68,
	0x6f,
	0x77,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x76,
	0x69,
	0x65,
	0x77,
	0x20,
	0x61,
	0x20,
	0x63,
	0x6f,
	0x70,
	0x79,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x69,
	0x73,
	0x20,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x2e,
	0x20,
	0x20,
	0x49,
	0x66,
	0x0a,
	0x74,
	0x68,
	0x65,
	0x20,
	0x69,
	0x6e,
	0x74,
	0x65,
	0x72,
	0x66,
	0x61,
	0x63,
	0x65,
	0x20,
	0x70,
	0x72,
	0x65,
	0x73,
	0x65,
	0x6e,
	0x74,
	0x73,
	0x20,
	0x61,
	0x20,
	0x6c,
	0x69,
	0x73,
	0x74,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x75,
	0x73,
	0x65,
	0x72,
	0x20,
	0x63,
	0x6f,
	0x6d,
	0x6d,
	0x61,
	0x6e,
	0x64,
	0x73,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x6f,
	0x70,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x73,
	0x2c,
	0x20,
	0x73,
	0x75,
	0x63,
	0x68,
	0x20,
	0x61,
	0x73,
	0x20,
	0x61,
	0x0a,
	0x6d,
	0x65,
	0x6e,
	0x75,
	0x2c,
	0x20,
	0x61,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x6d,
	0x69,
	0x6e,
	0x65,
	0x6e,
	0x74,
	0x20,
	0x69,
	0x74,
	0x65,
	0x6d,
	0x20,
	0x69,
	0x6e,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x6c,
	0x69,
	0x73,
	0x74,
	0x20,
	0x6d,
	0x65,
	0x65,
	0x74,
	0x73,
	0x20,
	0x74,
	0x68,
	0x69,
	0x73,
	0x20,
	0x63,
	0x72,
	0x69,
	0x74,
	0x65,
	0x72,
	0x69,
	0x6f,
	0x6e,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x31,
	0x2e,
	0x20,
	0x53,
	0x6f,
	0x75,
	0x72,
	0x63,
	0x65,
	0x20,
	0x43,
	0x6f,
	0x64,
	0x65,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x54,
	0x68,
	0x65,
	0x20,
	0x22,
	0x73,
	0x6f,
	0x75,
	0x72,
	0x63,
	0x65,
	0x20,
	0x63,
	0x6f,
	0x64,
	0x65,
	0x22,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x20,
	0x61,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x20,
	0x6d,
	0x65,
	0x61,
	0x6e,
	0x73,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x70,
	0x72,
	0x65,
	0x66,
	0x65,
	0x72,
	0x72,
	0x65,
	0x64,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x6d,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x0a,
	0x66,
	0x6f,
	0x72,
	0x20,
	0x6d,
	0x61,
	0x6b,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x6d,
	0x6f,
	0x64,
	0x69,
	0x66,
	0x69,
	0x63,
	0x61,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x73,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x69,
	0x74,
	0x2e,
	0x20,
	0x20,
	0x22,
	0x4f,
	0x62,
	0x6a,
	0x65,
	0x63,
	0x74,
	0x20,
	0x63,
	0x6f,
	0x64,
	0x65,
	0x22,
	0x20,
	0x6d,
	0x65,
	0x61,
	0x6e,
	0x73,
	0x20,
	0x61,
	0x6e,
	0x79,
	0x20,
	0x6e,
	0x6f,
	0x6e,
	0x2d,
	0x73,
	0x6f,
	0x75,
	0x72,
	0x63,
	0x65,
	0x0a,
	0x66,
	0x6f,
	0x72,
	0x6d,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x61,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x41,
	0x20,
	0x22,
	0x53,
	0x74,
	0x61,
	0x6e,
	0x64,
	0x61,
	0x72,
	0x64,
	0x20,
	0x49,
	0x6e,
	0x74,
	0x65,
	0x72,
	0x66,
	0x61,
	0x63,
	0x65,
	0x22,
	0x20,
	0x6d,
	0x65,
	0x61,
	0x6e,
	0x73,
	0x20,
	0x61,
	0x6e,
	0x20,
	0x69,
	0x6e,
	0x74,
	0x65,
	0x72,
	0x66,
	0x61,
	0x63,
	0x65,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x65,
	0x69,
	0x74,
	0x68,
	0x65,
	0x72,
	0x20,
	0x69,
	0x73,
	0x20,
	0x61,
	0x6e,
	0x20,
	0x6f,
	0x66,
	0x66,
	0x69,
	0x63,
	0x69,
	0x61,
	0x6c,
	0x0a,
	0x73,
	0x74,
	0x61,
	0x6e,
	0x64,
	0x61,
	0x72,
	0x64,
	0x20,
	0x64,
	0x65,
	0x66,
	0x69,
	0x6e,
	0x65,
	0x64,
	0x20,
	0x62,
	0x79,
	0x20,
	0x61,
	0x20,
	0x72,
	0x65,
	0x63,
	0x6f,
	0x67,
	0x6e,
	0x69,
	0x7a,
	0x65,
	0x64,
	0x20,
	0x73,
	0x74,
	0x61,
	0x6e,
	0x64,
	0x61,
	0x72,
	0x64,
	0x73,
	0x20,
	0x62,
	0x6f,
	0x64,
	0x79,
	0x2c,
	0x20,
	0x6f,
	0x72,
	0x2c,
	0x20,
	0x69,
	0x6e,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x63,
	0x61,
	0x73,
	0x65,
	0x20,
	0x6f,
	0x66,
	0x0a,
	0x69,
	0x6e,
	0x74,
	0x65,
	0x72,
	0x66,
	0x61,
	0x63,
	0x65,
	0x73,
	0x20,
	0x73,
	0x70,
	0x65,
	0x63,
	0x69,
	0x66,
	0x69,
	0x65,
	0x64,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x20,
	0x61,
	0x20,
	0x70,
	0x61,
	0x72,
	0x74,
	0x69,
	0x63,
	0x75,
	0x6c,
	0x61,
	0x72,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x67,
	0x72,
	0x61,
	0x6d,
	0x6d,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x6c,
	0x61,
	0x6e,
	0x67,
	0x75,
	0x61,
	0x67,
	0x65,
	0x2c,
	0x20,
	0x6f,
	0x6e,
	0x65,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x0a,
	0x69,
	0x73,
	0x20,
	0x77,
	0x69,
	0x64,
	0x65,
	0x6c,
	0x79,
	0x20,
	0x75,
	0x73,
	0x65,
	0x64,
	0x20,
	0x61,
	0x6d,
	0x6f,
	0x6e,
	0x67,
	0x20,
	0x64,
	0x65,
	0x76,
	0x65,
	0x6c,
	0x6f,
	0x70,
	0x65,
	0x72,
	0x73,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x69,
	0x6e,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x6c,
	0x61,
	0x6e,
	0x67,
	0x75,
	0x61,
	0x67,
	0x65,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x54,
	0x68,
	0x65,
	0x20,
	0x22,
	0x53,
	0x79,
	0x73,
	0x74,
	0x65,
	0x6d,
	0x20,
	0x4c,
	0x69,
	0x62,
	0x72,
	0x61,
	0x72,
	0x69,
	0x65,
	0x73,
	0x22,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x61,
	0x6e,
	0x20,
	0x65,
	0x78,
	0x65,
	0x63,
	0x75,
	0x74,
	0x61,
	0x62,
	0x6c,
	0x65,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x20,
	0x69,
	0x6e,
	0x63,
	0x6c,
	0x75,
	0x64,
	0x65,
	0x20,
	0x61,
	0x6e,
	0x79,
	0x74,
	0x68,
	0x69,
	0x6e,
	0x67,
	0x2c,
	0x20,
	0x6f,
	0x74,
	0x68,
	0x65,
	0x72,
	0x0a,
	0x74,
	0x68,
	0x61,
	0x6e,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x20,
	0x61,
	0x73,
	0x20,
	0x61,
	0x20,
	0x77,
	0x68,
	0x6f,
	0x6c,
	0x65,
	0x2c,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x28,
	0x61,
	0x29,
	0x20,
	0x69,
	0x73,
	0x20,
	0x69,
	0x6e,
	0x63,
	0x6c,
	0x75,
	0x64,
	0x65,
	0x64,
	0x20,
	0x69,
	0x6e,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x6e,
	0x6f,
	0x72,
	0x6d,
	0x61,
	0x6c,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x6d,
	0x20,
	0x6f,
	0x66,
	0x0a,
	0x70,
	0x61,
	0x63,
	0x6b,
	0x61,
	0x67,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x61,
	0x20,
	0x4d,
	0x61,
	0x6a,
	0x6f,
	0x72,
	0x20,
	0x43,
	0x6f,
	0x6d,
	0x70,
	0x6f,
	0x6e,
	0x65,
	0x6e,
	0x74,
	0x2c,
	0x20,
	0x62,
	0x75,
	0x74,
	0x20,
	0x77,
	0x68,
	0x69,
	0x63,
	0x68,
	0x20,
	0x69,
	0x73,
	0x20,
	0x6e,
	0x6f,
	0x74,
	0x20,
	0x70,
	0x61,
	0x72,
	0x74,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x4d,
	0x61,
	0x6a,
	0x6f,
	0x72,
	0x0a,
	0x43,
	0x6f,
	0x6d,
	0x70,
	0x6f,
	0x6e,
	0x65,
	0x6e,
	0x74,
	0x2c,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x28,
	0x62,
	0x29,
	0x20,
	0x73,
	0x65,
	0x72,
	0x76,
	0x65,
	0x73,
	0x20,
	0x6f,
	0x6e,
	0x6c,
	0x79,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x65,
	0x6e,
	0x61,
	0x62,
	0x6c,
	0x65,
	0x20,
	0x75,
	0x73,
	0x65,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x20,
	0x77,
	0x69,
	0x74,
	0x68,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x0a,
	0x4d,
	0x61,
	0x6a,
	0x6f,
	0x72,
	0x20,
	0x43,
	0x6f,
	0x6d,
	0x70,
	0x6f,
	0x6e,
	0x65,
	0x6e,
	0x74,
	0x2c,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x69,
	0x6d,
	0x70,
	0x6c,
	0x65,
	0x6d,
	0x65,
	0x6e,
	0x74,
	0x20,
	0x61,
	0x20,
	0x53,
	0x74,
	0x61,
	0x6e,
	0x64,
	0x61,
	0x72,
	0x64,
	0x20,
	0x49,
	0x6e,
	0x74,
	0x65,
	0x72,
	0x66,
	0x61,
	0x63,
	0x65,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x20,
	0x77,
	0x68,
	0x69,
	0x63,
	0x68,
	0x20,
	0x61,
	0x6e,
	0x0a,
	0x69,
	0x6d,
	0x70,
	0x6c,
	0x65,
	0x6d,
	0x65,
	0x6e,
	0x74,
	0x61,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x69,
	0x73,
	0x20,
	0x61,
	0x76,
	0x61,
	0x69,
	0x6c,
	0x61,
	0x62,
	0x6c,
	0x65,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x70,
	0x75,
	0x62,
	0x6c,
	0x69,
	0x63,
	0x20,
	0x69,
	0x6e,
	0x20,
	0x73,
	0x6f,
	0x75,
	0x72,
	0x63,
	0x65,
	0x20,
	0x63,
	0x6f,
	0x64,
	0x65,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x6d,
	0x2e,
	0x20,
	0x20,
	0x41,
	0x0a,
	0x22,
	0x4d,
	0x61,
	0x6a,
	0x6f,
	0x72,
	0x20,
	0x43,
	0x6f,
	0x6d,
	0x70,
	0x6f,
	0x6e,
	0x65,
	0x6e,
	0x74,
	0x22,
	0x2c,
	0x20,
	0x69,
	0x6e,
	0x20,
	0x74,
	0x68,
	0x69,
	0x73,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x74,
	0x65,
	0x78,
	0x74,
	0x2c,
	0x20,
	0x6d,
	0x65,
	0x61,
	0x6e,
	0x73,
	0x20,
	0x61,
	0x20,
	0x6d,
	0x61,
	0x6a,
	0x6f,
	0x72,
	0x20,
	0x65,
	0x73,
	0x73,
	0x65,
	0x6e,
	0x74,
	0x69,
	0x61,
	0x6c,
	0x20,
	0x63,
	0x6f,
	0x6d,
	0x70,
	0x6f,
	0x6e,
	0x65,
	0x6e,
	0x74,
	0x0a,
	0x28,
	0x6b,
	0x65,
	0x72,
	0x6e,
	0x65,
	0x6c,
	0x2c,
	0x20,
	0x77,
	0x69,
	0x6e,
	0x64,
	0x6f,
	0x77,
	0x20,
	0x73,
	0x79,
	0x73,
	0x74,
	0x65,
	0x6d,
	0x2c,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x73,
	0x6f,
	0x20,
	0x6f,
	0x6e,
	0x29,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x73,
	0x70,
	0x65,
	0x63,
	0x69,
	0x66,
	0x69,
	0x63,
	0x20,
	0x6f,
	0x70,
	0x65,
	0x72,
	0x61,
	0x74,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x73,
	0x79,
	0x73,
	0x74,
	0x65,
	0x6d,
	0x0a,
	0x28,
	0x69,
	0x66,
	0x20,
	0x61,
	0x6e,
	0x79,
	0x29,
	0x20,
	0x6f,
	0x6e,
	0x20,
	0x77,
	0x68,
	0x69,
	0x63,
	0x68,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x65,
	0x78,
	0x65,
	0x63,
	0x75,
	0x74,
	0x61,
	0x62,
	0x6c,
	0x65,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x20,
	0x72,
	0x75,
	0x6e,
	0x73,
	0x2c,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x61,
	0x20,
	0x63,
	0x6f,
	0x6d,
	0x70,
	0x69,
	0x6c,
	0x65,
	0x72,
	0x20,
	0x75,
	0x73,
	0x65,
	0x64,
	0x20,
	0x74,
	0x6f,
	0x0a,
	0x70,
	0x72,
	0x6f,
	0x64,
	0x75,
	0x63,
	0x65,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x2c,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x61,
	0x6e,
	0x20,
	0x6f,
	0x62,
	0x6a,
	0x65,
	0x63,
	0x74,
	0x20,
	0x63,
	0x6f,
	0x64,
	0x65,
	0x20,
	0x69,
	0x6e,
	0x74,
	0x65,
	0x72,
	0x70,
	0x72,
	0x65,
	0x74,
	0x65,
	0x72,
	0x20,
	0x75,
	0x73,
	0x65,
	0x64,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x72,
	0x75,
	0x6e,
	0x20,
	0x69,
	0x74,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x54,
	0x68,
	0x65,
	0x20,
	0x22,
	0x43,
	0x6f,
	0x72,
	0x72,
	0x65,
	0x73,
	0x70,
	0x6f,
	0x6e,
	0x64,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x53,
	0x6f,
	0x75,
	0x72,
	0x63,
	0x65,
	0x22,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x20,
	0x61,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x20,
	0x69,
	0x6e,
	0x20,
	0x6f,
	0x62,
	0x6a,
	0x65,
	0x63,
	0x74,
	0x20,
	0x63,
	0x6f,
	0x64,
	0x65,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x6d,
	0x20,
	0x6d,
	0x65,
	0x61,
	0x6e,
	0x73,
	0x20,
	0x61,
	0x6c,
	0x6c,
	0x0a,
	0x74,
	0x68,
	0x65,
	0x20,
	0x73,
	0x6f,
	0x75,
	0x72,
	0x63,
	0x65,
	0x20,
	0x63,
	0x6f,
	0x64,
	0x65,
	0x20,
	0x6e,
	0x65,
	0x65,
	0x64,
	0x65,
	0x64,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x67,
	0x65,
	0x6e,
	0x65,
	0x72,
	0x61,
	0x74,
	0x65,
	0x2c,
	0x20,
	0x69,
	0x6e,
	0x73,
	0x74,
	0x61,
	0x6c,
	0x6c,
	0x2c,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x28,
	0x66,
	0x6f,
	0x72,
	0x20,
	0x61,
	0x6e,
	0x20,
	0x65,
	0x78,
	0x65,
	0x63,
	0x75,
	0x74,
	0x61,
	0x62,
	0x6c,
	0x65,
	0x0a,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x29,
	0x20,
	0x72,
	0x75,
	0x6e,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x6f,
	0x62,
	0x6a,
	0x65,
	0x63,
	0x74,
	0x20,
	0x63,
	0x6f,
	0x64,
	0x65,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x6d,
	0x6f,
	0x64,
	0x69,
	0x66,
	0x79,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x2c,
	0x20,
	0x69,
	0x6e,
	0x63,
	0x6c,
	0x75,
	0x64,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x73,
	0x63,
	0x72,
	0x69,
	0x70,
	0x74,
	0x73,
	0x20,
	0x74,
	0x6f,
	0x0a,
	0x63,
	0x6f,
	0x6e,
	0x74,
	0x72,
	0x6f,
	0x6c,
	0x20,
	0x74,
	0x68,
	0x6f,
	0x73,
	0x65,
	0x20,
	0x61,
	0x63,
	0x74,
	0x69,
	0x76,
	0x69,
	0x74,
	0x69,
	0x65,
	0x73,
	0x2e,
	0x20,
	0x20,
	0x48,
	0x6f,
	0x77,
	0x65,
	0x76,
	0x65,
	0x72,
	0x2c,
	0x20,
	0x69,
	0x74,
	0x20,
	0x64,
	0x6f,
	0x65,
	0x73,
	0x20,
	0x6e,
	0x6f,
	0x74,
	0x20,
	0x69,
	0x6e,
	0x63,
	0x6c,
	0x75,
	0x64,
	0x65,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x27,
	0x73,
	0x0a,
	0x53,
	0x79,
	0x73,
	0x74,
	0x65,
	0x6d,
	0x20,
	0x4c,
	0x69,
	0x62,
	0x72,
	0x61,
	0x72,
	0x69,
	0x65,
	0x73,
	0x2c,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x67,
	0x65,
	0x6e,
	0x65,
	0x72,
	0x61,
	0x6c,
	0x2d,
	0x70,
	0x75,
	0x72,
	0x70,
	0x6f,
	0x73,
	0x65,
	0x20,
	0x74,
	0x6f,
	0x6f,
	0x6c,
	0x73,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x67,
	0x65,
	0x6e,
	0x65,
	0x72,
	0x61,
	0x6c,
	0x6c,
	0x79,
	0x20,
	0x61,
	0x76,
	0x61,
	0x69,
	0x6c,
	0x61,
	0x62,
	0x6c,
	0x65,
	0x20,
	0x66,
	0x72,
	0x65,
	0x65,
	0x0a,
	0x70,
	0x72,
	0x6f,
	0x67,
	0x72,
	0x61,
	0x6d,
	0x73,
	0x20,
	0x77,
	0x68,
	0x69,
	0x63,
	0x68,
	0x20,
	0x61,
	0x72,
	0x65,
	0x20,
	0x75,
	0x73,
	0x65,
	0x64,
	0x20,
	0x75,
	0x6e,
	0x6d,
	0x6f,
	0x64,
	0x69,
	0x66,
	0x69,
	0x65,
	0x64,
	0x20,
	0x69,
	0x6e,
	0x20,
	0x70,
	0x65,
	0x72,
	0x66,
	0x6f,
	0x72,
	0x6d,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x74,
	0x68,
	0x6f,
	0x73,
	0x65,
	0x20,
	0x61,
	0x63,
	0x74,
	0x69,
	0x76,
	0x69,
	0x74,
	0x69,
	0x65,
	0x73,
	0x20,
	0x62,
	0x75,
	0x74,
	0x0a,
	0x77,
	0x68,
	0x69,
	0x63,
	0x68,
	0x20,
	0x61,
	0x72,
	0x65,
	0x20,
	0x6e,
	0x6f,
	0x74,
	0x20,
	0x70,
	0x61,
	0x72,
	0x74,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x2e,
	0x20,
	0x20,
	0x46,
	0x6f,
	0x72,
	0x20,
	0x65,
	0x78,
	0x61,
	0x6d,
	0x70,
	0x6c,
	0x65,
	0x2c,
	0x20,
	0x43,
	0x6f,
	0x72,
	0x72,
	0x65,
	0x73,
	0x70,
	0x6f,
	0x6e,
	0x64,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x53,
	0x6f,
	0x75,
	0x72,
	0x63,
	0x65,
	0x0a,
	0x69,
	0x6e,
	0x63,
	0x6c,
	0x75,
	0x64,
	0x65,
	0x73,
	0x20,
	0x69,
	0x6e,
	0x74,
	0x65,
	0x72,
	0x66,
	0x61,
	0x63,
	0x65,
	0x20,
	0x64,
	0x65,
	0x66,
	0x69,
	0x6e,
	0x69,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x66,
	0x69,
	0x6c,
	0x65,
	0x73,
	0x20,
	0x61,
	0x73,
	0x73,
	0x6f,
	0x63,
	0x69,
	0x61,
	0x74,
	0x65,
	0x64,
	0x20,
	0x77,
	0x69,
	0x74,
	0x68,
	0x20,
	0x73,
	0x6f,
	0x75,
	0x72,
	0x63,
	0x65,
	0x20,
	0x66,
	0x69,
	0x6c,
	0x65,
	0x73,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x0a,
	0x74,
	0x68,
	0x65,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x2c,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x73,
	0x6f,
	0x75,
	0x72,
	0x63,
	0x65,
	0x20,
	0x63,
	0x6f,
	0x64,
	0x65,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x20,
	0x73,
	0x68,
	0x61,
	0x72,
	0x65,
	0x64,
	0x20,
	0x6c,
	0x69,
	0x62,
	0x72,
	0x61,
	0x72,
	0x69,
	0x65,
	0x73,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x64,
	0x79,
	0x6e,
	0x61,
	0x6d,
	0x69,
	0x63,
	0x61,
	0x6c,
	0x6c,
	0x79,
	0x0a,
	0x6c,
	0x69,
	0x6e,
	0x6b,
	0x65,
	0x64,
	0x20,
	0x73,
	0x75,
	0x62,
	0x70,
	0x72,
	0x6f,
	0x67,
	0x72,
	0x61,
	0x6d,
	0x73,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x20,
	0x69,
	0x73,
	0x20,
	0x73,
	0x70,
	0x65,
	0x63,
	0x69,
	0x66,
	0x69,
	0x63,
	0x61,
	0x6c,
	0x6c,
	0x79,
	0x20,
	0x64,
	0x65,
	0x73,
	0x69,
	0x67,
	0x6e,
	0x65,
	0x64,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x72,
	0x65,
	0x71,
	0x75,
	0x69,
	0x72,
	0x65,
	0x2c,
	0x0a,
	0x73,
	0x75,
	0x63,
	0x68,
	0x20,
	0x61,
	0x73,
	0x20,
	0x62,
	0x79,
	0x20,
	0x69,
	0x6e,
	0x74,
	0x69,
	0x6d,
	0x61,
	0x74,
	0x65,
	0x20,
	0x64,
	0x61,
	0x74,
	0x61,
	0x20,
	0x63,
	0x6f,
	0x6d,
	0x6d,
	0x75,
	0x6e,
	0x69,
	0x63,
	0x61,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x74,
	0x72,
	0x6f,
	0x6c,
	0x20,
	0x66,
	0x6c,
	0x6f,
	0x77,
	0x20,
	0x62,
	0x65,
	0x74,
	0x77,
	0x65,
	0x65,
	0x6e,
	0x20,
	0x74,
	0x68,
	0x6f,
	0x73,
	0x65,
	0x0a,
	0x73,
	0x75,
	0x62,
	0x70,
	0x72,
	0x6f,
	0x67,
	0x72,
	0x61,
	0x6d,
	0x73,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x6f,
	0x74,
	0x68,
	0x65,
	0x72,
	0x20,
	0x70,
	0x61,
	0x72,
	0x74,
	0x73,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x54,
	0x68,
	0x65,
	0x20,
	0x43,
	0x6f,
	0x72,
	0x72,
	0x65,
	0x73,
	0x70,
	0x6f,
	0x6e,
	0x64,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x53,
	0x6f,
	0x75,
	0x72,
	0x63,
	0x65,
	0x20,
	0x6e,
	0x65,
	0x65,
	0x64,
	0x20,
	0x6e,
	0x6f,
	0x74,
	0x20,
	0x69,
	0x6e,
	0x63,
	0x6c,
	0x75,
	0x64,
	0x65,
	0x20,
	0x61,
	0x6e,
	0x79,
	0x74,
	0x68,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x75,
	0x73,
	0x65,
	0x72,
	0x73,
	0x0a,
	0x63,
	0x61,
	0x6e,
	0x20,
	0x72,
	0x65,
	0x67,
	0x65,
	0x6e,
	0x65,
	0x72,
	0x61,
	0x74,
	0x65,
	0x20,
	0x61,
	0x75,
	0x74,
	0x6f,
	0x6d,
	0x61,
	0x74,
	0x69,
	0x63,
	0x61,
	0x6c,
	0x6c,
	0x79,
	0x20,
	0x66,
	0x72,
	0x6f,
	0x6d,
	0x20,
	0x6f,
	0x74,
	0x68,
	0x65,
	0x72,
	0x20,
	0x70,
	0x61,
	0x72,
	0x74,
	0x73,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x43,
	0x6f,
	0x72,
	0x72,
	0x65,
	0x73,
	0x70,
	0x6f,
	0x6e,
	0x64,
	0x69,
	0x6e,
	0x67,
	0x0a,
	0x53,
	0x6f,
	0x75,
	0x72,
	0x63,
	0x65,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x54,
	0x68,
	0x65,
	0x20,
	0x43,
	0x6f,
	0x72,
	0x72,
	0x65,
	0x73,
	0x70,
	0x6f,
	0x6e,
	0x64,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x53,
	0x6f,
	0x75,
	0x72,
	0x63,
	0x65,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x20,
	0x61,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x20,
	0x69,
	0x6e,
	0x20,
	0x73,
	0x6f,
	0x75,
	0x72,
	0x63,
	0x65,
	0x20,
	0x63,
	0x6f,
	0x64,
	0x65,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x6d,
	0x20,
	0x69,
	0x73,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x0a,
	0x73,
	0x61,
	0x6d,
	0x65,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x32,
	0x2e,
	0x20,
	0x42,
	0x61,
	0x73,
	0x69,
	0x63,
	0x20,
	0x50,
	0x65,
	0x72,
	0x6d,
	0x69,
	0x73,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x73,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x41,
	0x6c,
	0x6c,
	0x20,
	0x72,
	0x69,
	0x67,
	0x68,
	0x74,
	0x73,
	0x20,
	0x67,
	0x72,
	0x61,
	0x6e,
	0x74,
	0x65,
	0x64,
	0x20,
	0x75,
	0x6e,
	0x64,
	0x65,
	0x72,
	0x20,
	0x74,
	0x68,
	0x69,
	0x73,
	0x20,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x20,
	0x61,
	0x72,
	0x65,
	0x20,
	0x67,
	0x72,
	0x61,
	0x6e,
	0x74,
	0x65,
	0x64,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x74,
	0x65,
	0x72,
	0x6d,
	0x20,
	0x6f,
	0x66,
	0x0a,
	0x63,
	0x6f,
	0x70,
	0x79,
	0x72,
	0x69,
	0x67,
	0x68,
	0x74,
	0x20,
	0x6f,
	0x6e,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x50,
	0x72,
	0x6f,
	0x67,
	0x72,
	0x61,
	0x6d,
	0x2c,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x61,
	0x72,
	0x65,
	0x20,
	0x69,
	0x72,
	0x72,
	0x65,
	0x76,
	0x6f,
	0x63,
	0x61,
	0x62,
	0x6c,
	0x65,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x76,
	0x69,
	0x64,
	0x65,
	0x64,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x73,
	0x74,
	0x61,
	0x74,
	0x65,
	0x64,
	0x0a,
	0x63,
	0x6f,
	0x6e,
	0x64,
	0x69,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x73,
	0x20,
	0x61,
	0x72,
	0x65,
	0x20,
	0x6d,
	0x65,
	0x74,
	0x2e,
	0x20,
	0x20,
	0x54,
	0x68,
	0x69,
	0x73,
	0x20,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x20,
	0x65,
	0x78,
	0x70,
	0x6c,
	0x69,
	0x63,
	0x69,
	0x74,
	0x6c,
	0x79,
	0x20,
	0x61,
	0x66,
	0x66,
	0x69,
	0x72,
	0x6d,
	0x73,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x72,
	0x20,
	0x75,
	0x6e,
	0x6c,
	0x69,
	0x6d,
	0x69,
	0x74,
	0x65,
	0x64,
	0x0a,
	0x70,
	0x65,
	0x72,
	0x6d,
	0x69,
	0x73,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x72,
	0x75,
	0x6e,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x75,
	0x6e,
	0x6d,
	0x6f,
	0x64,
	0x69,
	0x66,
	0x69,
	0x65,
	0x64,
	0x20,
	0x50,
	0x72,
	0x6f,
	0x67,
	0x72,
	0x61,
	0x6d,
	0x2e,
	0x20,
	0x20,
	0x54,
	0x68,
	0x65,
	0x20,
	0x6f,
	0x75,
	0x74,
	0x70,
	0x75,
	0x74,
	0x20,
	0x66,
	0x72,
	0x6f,
	0x6d,
	0x20,
	0x72,
	0x75,
	0x6e,
	0x6e,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x61,
	0x0a,
	0x63,
	0x6f,
	0x76,
	0x65,
	0x72,
	0x65,
	0x64,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x20,
	0x69,
	0x73,
	0x20,
	0x63,
	0x6f,
	0x76,
	0x65,
	0x72,
	0x65,
	0x64,
	0x20,
	0x62,
	0x79,
	0x20,
	0x74,
	0x68,
	0x69,
	0x73,
	0x20,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x20,
	0x6f,
	0x6e,
	0x6c,
	0x79,
	0x20,
	0x69,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x6f,
	0x75,
	0x74,
	0x70,
	0x75,
	0x74,
	0x2c,
	0x20,
	0x67,
	0x69,
	0x76,
	0x65,
	0x6e,
	0x20,
	0x69,
	0x74,
	0x73,
	0x0a,
	0x63,
	0x6f,
	0x6e,
	0x74,
	0x65,
	0x6e,
	0x74,
	0x2c,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x73,
	0x74,
	0x69,
	0x74,
	0x75,
	0x74,
	0x65,
	0x73,
	0x20,
	0x61,
	0x20,
	0x63,
	0x6f,
	0x76,
	0x65,
	0x72,
	0x65,
	0x64,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x2e,
	0x20,
	0x20,
	0x54,
	0x68,
	0x69,
	0x73,
	0x20,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x20,
	0x61,
	0x63,
	0x6b,
	0x6e,
	0x6f,
	0x77,
	0x6c,
	0x65,
	0x64,
	0x67,
	0x65,
	0x73,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x72,
	0x0a,
	0x72,
	0x69,
	0x67,
	0x68,
	0x74,
	0x73,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x66,
	0x61,
	0x69,
	0x72,
	0x20,
	0x75,
	0x73,
	0x65,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x6f,
	0x74,
	0x68,
	0x65,
	0x72,
	0x20,
	0x65,
	0x71,
	0x75,
	0x69,
	0x76,
	0x61,
	0x6c,
	0x65,
	0x6e,
	0x74,
	0x2c,
	0x20,
	0x61,
	0x73,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x76,
	0x69,
	0x64,
	0x65,
	0x64,
	0x20,
	0x62,
	0x79,
	0x20,
	0x63,
	0x6f,
	0x70,
	0x79,
	0x72,
	0x69,
	0x67,
	0x68,
	0x74,
	0x20,
	0x6c,
	0x61,
	0x77,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x59,
	0x6f,
	0x75,
	0x20,
	0x6d,
	0x61,
	0x79,
	0x20,
	0x6d,
	0x61,
	0x6b,
	0x65,
	0x2c,
	0x20,
	0x72,
	0x75,
	0x6e,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x70,
	0x61,
	0x67,
	0x61,
	0x74,
	0x65,
	0x20,
	0x63,
	0x6f,
	0x76,
	0x65,
	0x72,
	0x65,
	0x64,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x73,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x64,
	0x6f,
	0x20,
	0x6e,
	0x6f,
	0x74,
	0x0a,
	0x63,
	0x6f,
	0x6e,
	0x76,
	0x65,
	0x79,
	0x2c,
	0x20,
	0x77,
	0x69,
	0x74,
	0x68,
	0x6f,
	0x75,
	0x74,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x64,
	0x69,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x73,
	0x20,
	0x73,
	0x6f,
	0x20,
	0x6c,
	0x6f,
	0x6e,
	0x67,
	0x20,
	0x61,
	0x73,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x72,
	0x20,
	0x6c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x20,
	0x6f,
	0x74,
	0x68,
	0x65,
	0x72,
	0x77,
	0x69,
	0x73,
	0x65,
	0x20,
	0x72,
	0x65,
	0x6d,
	0x61,
	0x69,
	0x6e,
	0x73,
	0x0a,
	0x69,
	0x6e,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x63,
	0x65,
	0x2e,
	0x20,
	0x20,
	0x59,
	0x6f,
	0x75,
	0x20,
	0x6d,
	0x61,
	0x79,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x76,
	0x65,
	0x79,
	0x20,
	0x63,
	0x6f,
	0x76,
	0x65,
	0x72,
	0x65,
	0x64,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x73,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x6f,
	0x74,
	0x68,
	0x65,
	0x72,
	0x73,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x73,
	0x6f,
	0x6c,
	0x65,
	0x20,
	0x70,
	0x75,
	0x72,
	0x70,
	0x6f,
	0x73,
	0x65,
	0x0a,
	0x6f,
	0x66,
	0x20,
	0x68,
	0x61,
	0x76,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x74,
	0x68,
	0x65,
	0x6d,
	0x20,
	0x6d,
	0x61,
	0x6b,
	0x65,
	0x20,
	0x6d,
	0x6f,
	0x64,
	0x69,
	0x66,
	0x69,
	0x63,
	0x61,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x73,
	0x20,
	0x65,
	0x78,
	0x63,
	0x6c,
	0x75,
	0x73,
	0x69,
	0x76,
	0x65,
	0x6c,
	0x79,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x2c,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x76,
	0x69,
	0x64,
	0x65,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x0a,
	0x77,
	0x69,
	0x74,
	0x68,
	0x20,
	0x66,
	0x61,
	0x63,
	0x69,
	0x6c,
	0x69,
	0x74,
	0x69,
	0x65,
	0x73,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x20,
	0x72,
	0x75,
	0x6e,
	0x6e,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x74,
	0x68,
	0x6f,
	0x73,
	0x65,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x73,
	0x2c,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x76,
	0x69,
	0x64,
	0x65,
	0x64,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x63,
	0x6f,
	0x6d,
	0x70,
	0x6c,
	0x79,
	0x20,
	0x77,
	0x69,
	0x74,
	0x68,
	0x0a,
	0x74,
	0x68,
	0x65,
	0x20,
	0x74,
	0x65,
	0x72,
	0x6d,
	0x73,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x69,
	0x73,
	0x20,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x20,
	0x69,
	0x6e,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x76,
	0x65,
	0x79,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x61,
	0x6c,
	0x6c,
	0x20,
	0x6d,
	0x61,
	0x74,
	0x65,
	0x72,
	0x69,
	0x61,
	0x6c,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x20,
	0x77,
	0x68,
	0x69,
	0x63,
	0x68,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x64,
	0x6f,
	0x0a,
	0x6e,
	0x6f,
	0x74,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x74,
	0x72,
	0x6f,
	0x6c,
	0x20,
	0x63,
	0x6f,
	0x70,
	0x79,
	0x72,
	0x69,
	0x67,
	0x68,
	0x74,
	0x2e,
	0x20,
	0x20,
	0x54,
	0x68,
	0x6f,
	0x73,
	0x65,
	0x20,
	0x74,
	0x68,
	0x75,
	0x73,
	0x20,
	0x6d,
	0x61,
	0x6b,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x72,
	0x75,
	0x6e,
	0x6e,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x63,
	0x6f,
	0x76,
	0x65,
	0x72,
	0x65,
	0x64,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x73,
	0x0a,
	0x66,
	0x6f,
	0x72,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x6d,
	0x75,
	0x73,
	0x74,
	0x20,
	0x64,
	0x6f,
	0x20,
	0x73,
	0x6f,
	0x20,
	0x65,
	0x78,
	0x63,
	0x6c,
	0x75,
	0x73,
	0x69,
	0x76,
	0x65,
	0x6c,
	0x79,
	0x20,
	0x6f,
	0x6e,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x72,
	0x20,
	0x62,
	0x65,
	0x68,
	0x61,
	0x6c,
	0x66,
	0x2c,
	0x20,
	0x75,
	0x6e,
	0x64,
	0x65,
	0x72,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x72,
	0x20,
	0x64,
	0x69,
	0x72,
	0x65,
	0x63,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x0a,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x74,
	0x72,
	0x6f,
	0x6c,
	0x2c,
	0x20,
	0x6f,
	0x6e,
	0x20,
	0x74,
	0x65,
	0x72,
	0x6d,
	0x73,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x68,
	0x69,
	0x62,
	0x69,
	0x74,
	0x20,
	0x74,
	0x68,
	0x65,
	0x6d,
	0x20,
	0x66,
	0x72,
	0x6f,
	0x6d,
	0x20,
	0x6d,
	0x61,
	0x6b,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x61,
	0x6e,
	0x79,
	0x20,
	0x63,
	0x6f,
	0x70,
	0x69,
	0x65,
	0x73,
	0x20,
	0x6f,
	0x66,
	0x0a,
	0x79,
	0x6f,
	0x75,
	0x72,
	0x20,
	0x63,
	0x6f,
	0x70,
	0x79,
	0x72,
	0x69,
	0x67,
	0x68,
	0x74,
	0x65,
	0x64,
	0x20,
	0x6d,
	0x61,
	0x74,
	0x65,
	0x72,
	0x69,
	0x61,
	0x6c,
	0x20,
	0x6f,
	0x75,
	0x74,
	0x73,
	0x69,
	0x64,
	0x65,
	0x20,
	0x74,
	0x68,
	0x65,
	0x69,
	0x72,
	0x20,
	0x72,
	0x65,
	0x6c,
	0x61,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x73,
	0x68,
	0x69,
	0x70,
	0x20,
	0x77,
	0x69,
	0x74,
	0x68,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x43,
	0x6f,
	0x6e,
	0x76,
	0x65,
	0x79,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x75,
	0x6e,
	0x64,
	0x65,
	0x72,
	0x20,
	0x61,
	0x6e,
	0x79,
	0x20,
	0x6f,
	0x74,
	0x68,
	0x65,
	0x72,
	0x20,
	0x63,
	0x69,
	0x72,
	0x63,
	0x75,
	0x6d,
	0x73,
	0x74,
	0x61,
	0x6e,
	0x63,
	0x65,
	0x73,
	0x20,
	0x69,
	0x73,
	0x20,
	0x70,
	0x65,
	0x72,
	0x6d,
	0x69,
	0x74,
	0x74,
	0x65,
	0x64,
	0x20,
	0x73,
	0x6f,
	0x6c,
	0x65,
	0x6c,
	0x79,
	0x20,
	0x75,
	0x6e,
	0x64,
	0x65,
	0x72,
	0x0a,
	0x74,
	0x68,
	0x65,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x64,
	0x69,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x73,
	0x20,
	0x73,
	0x74,
	0x61,
	0x74,
	0x65,
	0x64,
	0x20,
	0x62,
	0x65,
	0x6c,
	0x6f,
	0x77,
	0x2e,
	0x20,
	0x20,
	0x53,
	0x75,
	0x62,
	0x6c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x69,
	0x73,
	0x20,
	0x6e,
	0x6f,
	0x74,
	0x20,
	0x61,
	0x6c,
	0x6c,
	0x6f,
	0x77,
	0x65,
	0x64,
	0x3b,
	0x20,
	0x73,
	0x65,
	0x63,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x31,
	0x30,
	0x0a,
	0x6d,
	0x61,
	0x6b,
	0x65,
	0x73,
	0x20,
	0x69,
	0x74,
	0x20,
	0x75,
	0x6e,
	0x6e,
	0x65,
	0x63,
	0x65,
	0x73,
	0x73,
	0x61,
	0x72,
	0x79,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x33,
	0x2e,
	0x20,
	0x50,
	0x72,
	0x6f,
	0x74,
	0x65,
	0x63,
	0x74,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x55,
	0x73,
	0x65,
	0x72,
	0x73,
	0x27,
	0x20,
	0x4c,
	0x65,
	0x67,
	0x61,
	0x6c,
	0x20,
	0x52,
	0x69,
	0x67,
	0x68,
	0x74,
	0x73,
	0x20,
	0x46,
	0x72,
	0x6f,
	0x6d,
	0x20,
	0x41,
	0x6e,
	0x74,
	0x69,
	0x2d,
	0x43,
	0x69,
	0x72,
	0x63,
	0x75,
	0x6d,
	0x76,
	0x65,
	0x6e,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x4c,
	0x61,
	0x77,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x4e,
	0x6f,
	0x20,
	0x63,
	0x6f,
	0x76,
	0x65,
	0x72,
	0x65,
	0x64,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x20,
	0x73,
	0x68,
	0x61,
	0x6c,
	0x6c,
	0x20,
	0x62,
	0x65,
	0x20,
	0x64,
	0x65,
	0x65,
	0x6d,
	0x65,
	0x64,
	0x20,
	0x70,
	0x61,
	0x72,
	0x74,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x61,
	0x6e,
	0x20,
	0x65,
	0x66,
	0x66,
	0x65,
	0x63,
	0x74,
	0x69,
	0x76,
	0x65,
	0x20,
	0x74,
	0x65,
	0x63,
	0x68,
	0x6e,
	0x6f,
	0x6c,
	0x6f,
	0x67,
	0x69,
	0x63,
	0x61,
	0x6c,
	0x0a,
	0x6d,
	0x65,
	0x61,
	0x73,
	0x75,
	0x72,
	0x65,
	0x20,
	0x75,
	0x6e,
	0x64,
	0x65,
	0x72,
	0x20,
	0x61,
	0x6e,
	0x79,
	0x20,
	0x61,
	0x70,
	0x70,
	0x6c,
	0x69,
	0x63,
	0x61,
	0x62,
	0x6c,
	0x65,
	0x20,
	0x6c,
	0x61,
	0x77,
	0x20,
	0x66,
	0x75,
	0x6c,
	0x66,
	0x69,
	0x6c,
	0x6c,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x6f,
	0x62,
	0x6c,
	0x69,
	0x67,
	0x61,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x73,
	0x20,
	0x75,
	0x6e,
	0x64,
	0x65,
	0x72,
	0x20,
	0x61,
	0x72,
	0x74,
	0x69,
	0x63,
	0x6c,
	0x65,
	0x0a,
	0x31,
	0x31,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x57,
	0x49,
	0x50,
	0x4f,
	0x20,
	0x63,
	0x6f,
	0x70,
	0x79,
	0x72,
	0x69,
	0x67,
	0x68,
	0x74,
	0x20,
	0x74,
	0x72,
	0x65,
	0x61,
	0x74,
	0x79,
	0x20,
	0x61,
	0x64,
	0x6f,
	0x70,
	0x74,
	0x65,
	0x64,
	0x20,
	0x6f,
	0x6e,
	0x20,
	0x32,
	0x30,
	0x20,
	0x44,
	0x65,
	0x63,
	0x65,
	0x6d,
	0x62,
	0x65,
	0x72,
	0x20,
	0x31,
	0x39,
	0x39,
	0x36,
	0x2c,
	0x20,
	0x6f,
	0x72,
	0x0a,
	0x73,
	0x69,
	0x6d,
	0x69,
	0x6c,
	0x61,
	0x72,
	0x20,
	0x6c,
	0x61,
	0x77,
	0x73,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x68,
	0x69,
	0x62,
	0x69,
	0x74,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x72,
	0x65,
	0x73,
	0x74,
	0x72,
	0x69,
	0x63,
	0x74,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x63,
	0x69,
	0x72,
	0x63,
	0x75,
	0x6d,
	0x76,
	0x65,
	0x6e,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x73,
	0x75,
	0x63,
	0x68,
	0x0a,
	0x6d,
	0x65,
	0x61,
	0x73,
	0x75,
	0x72,
	0x65,
	0x73,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x57,
	0x68,
	0x65,
	0x6e,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x76,
	0x65,
	0x79,
	0x20,
	0x61,
	0x20,
	0x63,
	0x6f,
	0x76,
	0x65,
	0x72,
	0x65,
	0x64,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x2c,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x77,
	0x61,
	0x69,
	0x76,
	0x65,
	0x20,
	0x61,
	0x6e,
	0x79,
	0x20,
	0x6c,
	0x65,
	0x67,
	0x61,
	0x6c,
	0x20,
	0x70,
	0x6f,
	0x77,
	0x65,
	0x72,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x62,
	0x69,
	0x64,
	0x0a,
	0x63,
	0x69,
	0x72,
	0x63,
	0x75,
	0x6d,
	0x76,
	0x65,
	0x6e,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x65,
	0x63,
	0x68,
	0x6e,
	0x6f,
	0x6c,
	0x6f,
	0x67,
	0x69,
	0x63,
	0x61,
	0x6c,
	0x20,
	0x6d,
	0x65,
	0x61,
	0x73,
	0x75,
	0x72,
	0x65,
	0x73,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x65,
	0x78,
	0x74,
	0x65,
	0x6e,
	0x74,
	0x20,
	0x73,
	0x75,
	0x63,
	0x68,
	0x20,
	0x63,
	0x69,
	0x72,
	0x63,
	0x75,
	0x6d,
	0x76,
	0x65,
	0x6e,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x0a,
	0x69,
	0x73,
	0x20,
	0x65,
	0x66,
	0x66,
	0x65,
	0x63,
	0x74,
	0x65,
	0x64,
	0x20,
	0x62,
	0x79,
	0x20,
	0x65,
	0x78,
	0x65,
	0x72,
	0x63,
	0x69,
	0x73,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x72,
	0x69,
	0x67,
	0x68,
	0x74,
	0x73,
	0x20,
	0x75,
	0x6e,
	0x64,
	0x65,
	0x72,
	0x20,
	0x74,
	0x68,
	0x69,
	0x73,
	0x20,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x20,
	0x77,
	0x69,
	0x74,
	0x68,
	0x20,
	0x72,
	0x65,
	0x73,
	0x70,
	0x65,
	0x63,
	0x74,
	0x20,
	0x74,
	0x6f,
	0x0a,
	0x74,
	0x68,
	0x65,
	0x20,
	0x63,
	0x6f,
	0x76,
	0x65,
	0x72,
	0x65,
	0x64,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x2c,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x64,
	0x69,
	0x73,
	0x63,
	0x6c,
	0x61,
	0x69,
	0x6d,
	0x20,
	0x61,
	0x6e,
	0x79,
	0x20,
	0x69,
	0x6e,
	0x74,
	0x65,
	0x6e,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x6c,
	0x69,
	0x6d,
	0x69,
	0x74,
	0x20,
	0x6f,
	0x70,
	0x65,
	0x72,
	0x61,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x6f,
	0x72,
	0x0a,
	0x6d,
	0x6f,
	0x64,
	0x69,
	0x66,
	0x69,
	0x63,
	0x61,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x20,
	0x61,
	0x73,
	0x20,
	0x61,
	0x20,
	0x6d,
	0x65,
	0x61,
	0x6e,
	0x73,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x65,
	0x6e,
	0x66,
	0x6f,
	0x72,
	0x63,
	0x69,
	0x6e,
	0x67,
	0x2c,
	0x20,
	0x61,
	0x67,
	0x61,
	0x69,
	0x6e,
	0x73,
	0x74,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x27,
	0x73,
	0x0a,
	0x75,
	0x73,
	0x65,
	0x72,
	0x73,
	0x2c,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x72,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x74,
	0x68,
	0x69,
	0x72,
	0x64,
	0x20,
	0x70,
	0x61,
	0x72,
	0x74,
	0x69,
	0x65,
	0x73,
	0x27,
	0x20,
	0x6c,
	0x65,
	0x67,
	0x61,
	0x6c,
	0x20,
	0x72,
	0x69,
	0x67,
	0x68,
	0x74,
	0x73,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x62,
	0x69,
	0x64,
	0x20,
	0x63,
	0x69,
	0x72,
	0x63,
	0x75,
	0x6d,
	0x76,
	0x65,
	0x6e,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x6f,
	0x66,
	0x0a,
	0x74,
	0x65,
	0x63,
	0x68,
	0x6e,
	0x6f,
	0x6c,
	0x6f,
	0x67,
	0x69,
	0x63,
	0x61,
	0x6c,
	0x20,
	0x6d,
	0x65,
	0x61,
	0x73,
	0x75,
	0x72,
	0x65,
	0x73,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x34,
	0x2e,
	0x20,
	0x43,
	0x6f,
	0x6e,
	0x76,
	0x65,
	0x79,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x56,
	0x65,
	0x72,
	0x62,
	0x61,
	0x74,
	0x69,
	0x6d,
	0x20,
	0x43,
	0x6f,
	0x70,
	0x69,
	0x65,
	0x73,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x59,
	0x6f,
	0x75,
	0x20,
	0x6d,
	0x61,
	0x79,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x76,
	0x65,
	0x79,
	0x20,
	0x76,
	0x65,
	0x72,
	0x62,
	0x61,
	0x74,
	0x69,
	0x6d,
	0x20,
	0x63,
	0x6f,
	0x70,
	0x69,
	0x65,
	0x73,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x50,
	0x72,
	0x6f,
	0x67,
	0x72,
	0x61,
	0x6d,
	0x27,
	0x73,
	0x20,
	0x73,
	0x6f,
	0x75,
	0x72,
	0x63,
	0x65,
	0x20,
	0x63,
	0x6f,
	0x64,
	0x65,
	0x20,
	0x61,
	0x73,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x0a,
	0x72,
	0x65,
	0x63,
	0x65,
	0x69,
	0x76,
	0x65,
	0x20,
	0x69,
	0x74,
	0x2c,
	0x20,
	0x69,
	0x6e,
	0x20,
	0x61,
	0x6e,
	0x79,
	0x20,
	0x6d,
	0x65,
	0x64,
	0x69,
	0x75,
	0x6d,
	0x2c,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x76,
	0x69,
	0x64,
	0x65,
	0x64,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x73,
	0x70,
	0x69,
	0x63,
	0x75,
	0x6f,
	0x75,
	0x73,
	0x6c,
	0x79,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x0a,
	0x61,
	0x70,
	0x70,
	0x72,
	0x6f,
	0x70,
	0x72,
	0x69,
	0x61,
	0x74,
	0x65,
	0x6c,
	0x79,
	0x20,
	0x70,
	0x75,
	0x62,
	0x6c,
	0x69,
	0x73,
	0x68,
	0x20,
	0x6f,
	0x6e,
	0x20,
	0x65,
	0x61,
	0x63,
	0x68,
	0x20,
	0x63,
	0x6f,
	0x70,
	0x79,
	0x20,
	0x61,
	0x6e,
	0x20,
	0x61,
	0x70,
	0x70,
	0x72,
	0x6f,
	0x70,
	0x72,
	0x69,
	0x61,
	0x74,
	0x65,
	0x20,
	0x63,
	0x6f,
	0x70,
	0x79,
	0x72,
	0x69,
	0x67,
	0x68,
	0x74,
	0x20,
	0x6e,
	0x6f,
	0x74,
	0x69,
	0x63,
	0x65,
	0x3b,
	0x0a,
	0x6b,
	0x65,
	0x65,
	0x70,
	0x20,
	0x69,
	0x6e,
	0x74,
	0x61,
	0x63,
	0x74,
	0x20,
	0x61,
	0x6c,
	0x6c,
	0x20,
	0x6e,
	0x6f,
	0x74,
	0x69,
	0x63,
	0x65,
	0x73,
	0x20,
	0x73,
	0x74,
	0x61,
	0x74,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x74,
	0x68,
	0x69,
	0x73,
	0x20,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x61,
	0x6e,
	0x79,
	0x0a,
	0x6e,
	0x6f,
	0x6e,
	0x2d,
	0x70,
	0x65,
	0x72,
	0x6d,
	0x69,
	0x73,
	0x73,
	0x69,
	0x76,
	0x65,
	0x20,
	0x74,
	0x65,
	0x72,
	0x6d,
	0x73,
	0x20,
	0x61,
	0x64,
	0x64,
	0x65,
	0x64,
	0x20,
	0x69,
	0x6e,
	0x20,
	0x61,
	0x63,
	0x63,
	0x6f,
	0x72,
	0x64,
	0x20,
	0x77,
	0x69,
	0x74,
	0x68,
	0x20,
	0x73,
	0x65,
	0x63,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x37,
	0x20,
	0x61,
	0x70,
	0x70,
	0x6c,
	0x79,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x63,
	0x6f,
	0x64,
	0x65,
	0x3b,
	0x0a,
	0x6b,
	0x65,
	0x65,
	0x70,
	0x20,
	0x69,
	0x6e,
	0x74,
	0x61,
	0x63,
	0x74,
	0x20,
	0x61,
	0x6c,
	0x6c,
	0x20,
	0x6e,
	0x6f,
	0x74,
	0x69,
	0x63,
	0x65,
	0x73,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x61,
	0x62,
	0x73,
	0x65,
	0x6e,
	0x63,
	0x65,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x61,
	0x6e,
	0x79,
	0x20,
	0x77,
	0x61,
	0x72,
	0x72,
	0x61,
	0x6e,
	0x74,
	0x79,
	0x3b,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x67,
	0x69,
	0x76,
	0x65,
	0x20,
	0x61,
	0x6c,
	0x6c,
	0x0a,
	0x72,
	0x65,
	0x63,
	0x69,
	0x70,
	0x69,
	0x65,
	0x6e,
	0x74,
	0x73,
	0x20,
	0x61,
	0x20,
	0x63,
	0x6f,
	0x70,
	0x79,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x69,
	0x73,
	0x20,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x20,
	0x61,
	0x6c,
	0x6f,
	0x6e,
	0x67,
	0x20,
	0x77,
	0x69,
	0x74,
	0x68,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x50,
	0x72,
	0x6f,
	0x67,
	0x72,
	0x61,
	0x6d,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x59,
	0x6f,
	0x75,
	0x20,
	0x6d,
	0x61,
	0x79,
	0x20,
	0x63,
	0x68,
	0x61,
	0x72,
	0x67,
	0x65,
	0x20,
	0x61,
	0x6e,
	0x79,
	0x20,
	0x70,
	0x72,
	0x69,
	0x63,
	0x65,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x6e,
	0x6f,
	0x20,
	0x70,
	0x72,
	0x69,
	0x63,
	0x65,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x20,
	0x65,
	0x61,
	0x63,
	0x68,
	0x20,
	0x63,
	0x6f,
	0x70,
	0x79,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x76,
	0x65,
	0x79,
	0x2c,
	0x0a,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x6d,
	0x61,
	0x79,
	0x20,
	0x6f,
	0x66,
	0x66,
	0x65,
	0x72,
	0x20,
	0x73,
	0x75,
	0x70,
	0x70,
	0x6f,
	0x72,
	0x74,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x77,
	0x61,
	0x72,
	0x72,
	0x61,
	0x6e,
	0x74,
	0x79,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x74,
	0x65,
	0x63,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x20,
	0x61,
	0x20,
	0x66,
	0x65,
	0x65,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x35,
	0x2e,
	0x20,
	0x43,
	0x6f,
	0x6e,
	0x76,
	0x65,
	0x79,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x4d,
	0x6f,
	0x64,
	0x69,
	0x66,
	0x69,
	0x65,
	0x64,
	0x20,
	0x53,
	0x6f,
	0x75,
	0x72,
	0x63,
	0x65,
	0x20,
	0x56,
	0x65,
	0x72,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x73,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x59,
	0x6f,
	0x75,
	0x20,
	0x6d,
	0x61,
	0x79,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x76,
	0x65,
	0x79,
	0x20,
	0x61,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x20,
	0x62,
	0x61,
	0x73,
	0x65,
	0x64,
	0x20,
	0x6f,
	0x6e,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x50,
	0x72,
	0x6f,
	0x67,
	0x72,
	0x61,
	0x6d,
	0x2c,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x6d,
	0x6f,
	0x64,
	0x69,
	0x66,
	0x69,
	0x63,
	0x61,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x73,
	0x20,
	0x74,
	0x6f,
	0x0a,
	0x70,
	0x72,
	0x6f,
	0x64,
	0x75,
	0x63,
	0x65,
	0x20,
	0x69,
	0x74,
	0x20,
	0x66,
	0x72,
	0x6f,
	0x6d,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x50,
	0x72,
	0x6f,
	0x67,
	0x72,
	0x61,
	0x6d,
	0x2c,
	0x20,
	0x69,
	0x6e,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x6d,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x73,
	0x6f,
	0x75,
	0x72,
	0x63,
	0x65,
	0x20,
	0x63,
	0x6f,
	0x64,
	0x65,
	0x20,
	0x75,
	0x6e,
	0x64,
	0x65,
	0x72,
	0x20,
	0x74,
	0x68,
	0x65,
	0x0a,
	0x74,
	0x65,
	0x72,
	0x6d,
	0x73,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x73,
	0x65,
	0x63,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x34,
	0x2c,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x76,
	0x69,
	0x64,
	0x65,
	0x64,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x61,
	0x6c,
	0x73,
	0x6f,
	0x20,
	0x6d,
	0x65,
	0x65,
	0x74,
	0x20,
	0x61,
	0x6c,
	0x6c,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x73,
	0x65,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x64,
	0x69,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x73,
	0x3a,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x61,
	0x29,
	0x20,
	0x54,
	0x68,
	0x65,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x20,
	0x6d,
	0x75,
	0x73,
	0x74,
	0x20,
	0x63,
	0x61,
	0x72,
	0x72,
	0x79,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x6d,
	0x69,
	0x6e,
	0x65,
	0x6e,
	0x74,
	0x20,
	0x6e,
	0x6f,
	0x74,
	0x69,
	0x63,
	0x65,
	0x73,
	0x20,
	0x73,
	0x74,
	0x61,
	0x74,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x6d,
	0x6f,
	0x64,
	0x69,
	0x66,
	0x69,
	0x65,
	0x64,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x69,
	0x74,
	0x2c,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x67,
	0x69,
	0x76,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x61,
	0x20,
	0x72,
	0x65,
	0x6c,
	0x65,
	0x76,
	0x61,
	0x6e,
	0x74,
	0x20,
	0x64,
	0x61,
	0x74,
	0x65,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x62,
	0x29,
	0x20,
	0x54,
	0x68,
	0x65,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x20,
	0x6d,
	0x75,
	0x73,
	0x74,
	0x20,
	0x63,
	0x61,
	0x72,
	0x72,
	0x79,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x6d,
	0x69,
	0x6e,
	0x65,
	0x6e,
	0x74,
	0x20,
	0x6e,
	0x6f,
	0x74,
	0x69,
	0x63,
	0x65,
	0x73,
	0x20,
	0x73,
	0x74,
	0x61,
	0x74,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x69,
	0x74,
	0x20,
	0x69,
	0x73,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x72,
	0x65,
	0x6c,
	0x65,
	0x61,
	0x73,
	0x65,
	0x64,
	0x20,
	0x75,
	0x6e,
	0x64,
	0x65,
	0x72,
	0x20,
	0x74,
	0x68,
	0x69,
	0x73,
	0x20,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x61,
	0x6e,
	0x79,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x64,
	0x69,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x73,
	0x20,
	0x61,
	0x64,
	0x64,
	0x65,
	0x64,
	0x20,
	0x75,
	0x6e,
	0x64,
	0x65,
	0x72,
	0x20,
	0x73,
	0x65,
	0x63,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x37,
	0x2e,
	0x20,
	0x20,
	0x54,
	0x68,
	0x69,
	0x73,
	0x20,
	0x72,
	0x65,
	0x71,
	0x75,
	0x69,
	0x72,
	0x65,
	0x6d,
	0x65,
	0x6e,
	0x74,
	0x20,
	0x6d,
	0x6f,
	0x64,
	0x69,
	0x66,
	0x69,
	0x65,
	0x73,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x72,
	0x65,
	0x71,
	0x75,
	0x69,
	0x72,
	0x65,
	0x6d,
	0x65,
	0x6e,
	0x74,
	0x20,
	0x69,
	0x6e,
	0x20,
	0x73,
	0x65,
	0x63,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x34,
	0x20,
	0x74,
	0x6f,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x22,
	0x6b,
	0x65,
	0x65,
	0x70,
	0x20,
	0x69,
	0x6e,
	0x74,
	0x61,
	0x63,
	0x74,
	0x20,
	0x61,
	0x6c,
	0x6c,
	0x20,
	0x6e,
	0x6f,
	0x74,
	0x69,
	0x63,
	0x65,
	0x73,
	0x22,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x63,
	0x29,
	0x20,
	0x59,
	0x6f,
	0x75,
	0x20,
	0x6d,
	0x75,
	0x73,
	0x74,
	0x20,
	0x6c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x65,
	0x6e,
	0x74,
	0x69,
	0x72,
	0x65,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x2c,
	0x20,
	0x61,
	0x73,
	0x20,
	0x61,
	0x20,
	0x77,
	0x68,
	0x6f,
	0x6c,
	0x65,
	0x2c,
	0x20,
	0x75,
	0x6e,
	0x64,
	0x65,
	0x72,
	0x20,
	0x74,
	0x68,
	0x69,
	0x73,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x61,
	0x6e,
	0x79,
	0x6f,
	0x6e,
	0x65,
	0x20,
	0x77,
	0x68,
	0x6f,
	0x20,
	0x63,
	0x6f,
	0x6d,
	0x65,
	0x73,
	0x20,
	0x69,
	0x6e,
	0x74,
	0x6f,
	0x20,
	0x70,
	0x6f,
	0x73,
	0x73,
	0x65,
	0x73,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x61,
	0x20,
	0x63,
	0x6f,
	0x70,
	0x79,
	0x2e,
	0x20,
	0x20,
	0x54,
	0x68,
	0x69,
	0x73,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x20,
	0x77,
	0x69,
	0x6c,
	0x6c,
	0x20,
	0x74,
	0x68,
	0x65,
	0x72,
	0x65,
	0x66,
	0x6f,
	0x72,
	0x65,
	0x20,
	0x61,
	0x70,
	0x70,
	0x6c,
	0x79,
	0x2c,
	0x20,
	0x61,
	0x6c,
	0x6f,
	0x6e,
	0x67,
	0x20,
	0x77,
	0x69,
	0x74,
	0x68,
	0x20,
	0x61,
	0x6e,
	0x79,
	0x20,
	0x61,
	0x70,
	0x70,
	0x6c,
	0x69,
	0x63,
	0x61,
	0x62,
	0x6c,
	0x65,
	0x20,
	0x73,
	0x65,
	0x63,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x37,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x61,
	0x64,
	0x64,
	0x69,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x61,
	0x6c,
	0x20,
	0x74,
	0x65,
	0x72,
	0x6d,
	0x73,
	0x2c,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x77,
	0x68,
	0x6f,
	0x6c,
	0x65,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x2c,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x61,
	0x6c,
	0x6c,
	0x20,
	0x69,
	0x74,
	0x73,
	0x20,
	0x70,
	0x61,
	0x72,
	0x74,
	0x73,
	0x2c,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x72,
	0x65,
	0x67,
	0x61,
	0x72,
	0x64,
	0x6c,
	0x65,
	0x73,
	0x73,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x68,
	0x6f,
	0x77,
	0x20,
	0x74,
	0x68,
	0x65,
	0x79,
	0x20,
	0x61,
	0x72,
	0x65,
	0x20,
	0x70,
	0x61,
	0x63,
	0x6b,
	0x61,
	0x67,
	0x65,
	0x64,
	0x2e,
	0x20,
	0x20,
	0x54,
	0x68,
	0x69,
	0x73,
	0x20,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x20,
	0x67,
	0x69,
	0x76,
	0x65,
	0x73,
	0x20,
	0x6e,
	0x6f,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x70,
	0x65,
	0x72,
	0x6d,
	0x69,
	0x73,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x6c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x20,
	0x69,
	0x6e,
	0x20,
	0x61,
	0x6e,
	0x79,
	0x20,
	0x6f,
	0x74,
	0x68,
	0x65,
	0x72,
	0x20,
	0x77,
	0x61,
	0x79,
	0x2c,
	0x20,
	0x62,
	0x75,
	0x74,
	0x20,
	0x69,
	0x74,
	0x20,
	0x64,
	0x6f,
	0x65,
	0x73,
	0x20,
	0x6e,
	0x6f,
	0x74,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x69,
	0x6e,
	0x76,
	0x61,
	0x6c,
	0x69,
	0x64,
	0x61,
	0x74,
	0x65,
	0x20,
	0x73,
	0x75,
	0x63,
	0x68,
	0x20,
	0x70,
	0x65,
	0x72,
	0x6d,
	0x69,
	0x73,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x69,
	0x66,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x68,
	0x61,
	0x76,
	0x65,
	0x20,
	0x73,
	0x65,
	0x70,
	0x61,
	0x72,
	0x61,
	0x74,
	0x65,
	0x6c,
	0x79,
	0x20,
	0x72,
	0x65,
	0x63,
	0x65,
	0x69,
	0x76,
	0x65,
	0x64,
	0x20,
	0x69,
	0x74,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x64,
	0x29,
	0x20,
	0x49,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x20,
	0x68,
	0x61,
	0x73,
	0x20,
	0x69,
	0x6e,
	0x74,
	0x65,
	0x72,
	0x61,
	0x63,
	0x74,
	0x69,
	0x76,
	0x65,
	0x20,
	0x75,
	0x73,
	0x65,
	0x72,
	0x20,
	0x69,
	0x6e,
	0x74,
	0x65,
	0x72,
	0x66,
	0x61,
	0x63,
	0x65,
	0x73,
	0x2c,
	0x20,
	0x65,
	0x61,
	0x63,
	0x68,
	0x20,
	0x6d,
	0x75,
	0x73,
	0x74,
	0x20,
	0x64,
	0x69,
	0x73,
	0x70,
	0x6c,
	0x61,
	0x79,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x41,
	0x70,
	0x70,
	0x72,
	0x6f,
	0x70,
	0x72,
	0x69,
	0x61,
	0x74,
	0x65,
	0x20,
	0x4c,
	0x65,
	0x67,
	0x61,
	0x6c,
	0x20,
	0x4e,
	0x6f,
	0x74,
	0x69,
	0x63,
	0x65,
	0x73,
	0x3b,
	0x20,
	0x68,
	0x6f,
	0x77,
	0x65,
	0x76,
	0x65,
	0x72,
	0x2c,
	0x20,
	0x69,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x50,
	0x72,
	0x6f,
	0x67,
	0x72,
	0x61,
	0x6d,
	0x20,
	0x68,
	0x61,
	0x73,
	0x20,
	0x69,
	0x6e,
	0x74,
	0x65,
	0x72,
	0x61,
	0x63,
	0x74,
	0x69,
	0x76,
	0x65,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x69,
	0x6e,
	0x74,
	0x65,
	0x72,
	0x66,
	0x61,
	0x63,
	0x65,
	0x73,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x64,
	0x6f,
	0x20,
	0x6e,
	0x6f,
	0x74,
	0x20,
	0x64,
	0x69,
	0x73,
	0x70,
	0x6c,
	0x61,
	0x79,
	0x20,
	0x41,
	0x70,
	0x70,
	0x72,
	0x6f,
	0x70,
	0x72,
	0x69,
	0x61,
	0x74,
	0x65,
	0x20,
	0x4c,
	0x65,
	0x67,
	0x61,
	0x6c,
	0x20,
	0x4e,
	0x6f,
	0x74,
	0x69,
	0x63,
	0x65,
	0x73,
	0x2c,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x72,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x20,
	0x6e,
	0x65,
	0x65,
	0x64,
	0x20,
	0x6e,
	0x6f,
	0x74,
	0x20,
	0x6d,
	0x61,
	0x6b,
	0x65,
	0x20,
	0x74,
	0x68,
	0x65,
	0x6d,
	0x20,
	0x64,
	0x6f,
	0x20,
	0x73,
	0x6f,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x41,
	0x20,
	0x63,
	0x6f,
	0x6d,
	0x70,
	0x69,
	0x6c,
	0x61,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x61,
	0x20,
	0x63,
	0x6f,
	0x76,
	0x65,
	0x72,
	0x65,
	0x64,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x20,
	0x77,
	0x69,
	0x74,
	0x68,
	0x20,
	0x6f,
	0x74,
	0x68,
	0x65,
	0x72,
	0x20,
	0x73,
	0x65,
	0x70,
	0x61,
	0x72,
	0x61,
	0x74,
	0x65,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x69,
	0x6e,
	0x64,
	0x65,
	0x70,
	0x65,
	0x6e,
	0x64,
	0x65,
	0x6e,
	0x74,
	0x0a,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x73,
	0x2c,
	0x20,
	0x77,
	0x68,
	0x69,
	0x63,
	0x68,
	0x20,
	0x61,
	0x72,
	0x65,
	0x20,
	0x6e,
	0x6f,
	0x74,
	0x20,
	0x62,
	0x79,
	0x20,
	0x74,
	0x68,
	0x65,
	0x69,
	0x72,
	0x20,
	0x6e,
	0x61,
	0x74,
	0x75,
	0x72,
	0x65,
	0x20,
	0x65,
	0x78,
	0x74,
	0x65,
	0x6e,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x73,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x63,
	0x6f,
	0x76,
	0x65,
	0x72,
	0x65,
	0x64,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x2c,
	0x0a,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x77,
	0x68,
	0x69,
	0x63,
	0x68,
	0x20,
	0x61,
	0x72,
	0x65,
	0x20,
	0x6e,
	0x6f,
	0x74,
	0x20,
	0x63,
	0x6f,
	0x6d,
	0x62,
	0x69,
	0x6e,
	0x65,
	0x64,
	0x20,
	0x77,
	0x69,
	0x74,
	0x68,
	0x20,
	0x69,
	0x74,
	0x20,
	0x73,
	0x75,
	0x63,
	0x68,
	0x20,
	0x61,
	0x73,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x6d,
	0x20,
	0x61,
	0x20,
	0x6c,
	0x61,
	0x72,
	0x67,
	0x65,
	0x72,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x67,
	0x72,
	0x61,
	0x6d,
	0x2c,
	0x0a,
	0x69,
	0x6e,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x6f,
	0x6e,
	0x20,
	0x61,
	0x20,
	0x76,
	0x6f,
	0x6c,
	0x75,
	0x6d,
	0x65,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x61,
	0x20,
	0x73,
	0x74,
	0x6f,
	0x72,
	0x61,
	0x67,
	0x65,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x64,
	0x69,
	0x73,
	0x74,
	0x72,
	0x69,
	0x62,
	0x75,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x6d,
	0x65,
	0x64,
	0x69,
	0x75,
	0x6d,
	0x2c,
	0x20,
	0x69,
	0x73,
	0x20,
	0x63,
	0x61,
	0x6c,
	0x6c,
	0x65,
	0x64,
	0x20,
	0x61,
	0x6e,
	0x0a,
	0x22,
	0x61,
	0x67,
	0x67,
	0x72,
	0x65,
	0x67,
	0x61,
	0x74,
	0x65,
	0x22,
	0x20,
	0x69,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x63,
	0x6f,
	0x6d,
	0x70,
	0x69,
	0x6c,
	0x61,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x69,
	0x74,
	0x73,
	0x20,
	0x72,
	0x65,
	0x73,
	0x75,
	0x6c,
	0x74,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x63,
	0x6f,
	0x70,
	0x79,
	0x72,
	0x69,
	0x67,
	0x68,
	0x74,
	0x20,
	0x61,
	0x72,
	0x65,
	0x20,
	0x6e,
	0x6f,
	0x74,
	0x0a,
	0x75,
	0x73,
	0x65,
	0x64,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x6c,
	0x69,
	0x6d,
	0x69,
	0x74,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x61,
	0x63,
	0x63,
	0x65,
	0x73,
	0x73,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x6c,
	0x65,
	0x67,
	0x61,
	0x6c,
	0x20,
	0x72,
	0x69,
	0x67,
	0x68,
	0x74,
	0x73,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x63,
	0x6f,
	0x6d,
	0x70,
	0x69,
	0x6c,
	0x61,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x27,
	0x73,
	0x20,
	0x75,
	0x73,
	0x65,
	0x72,
	0x73,
	0x0a,
	0x62,
	0x65,
	0x79,
	0x6f,
	0x6e,
	0x64,
	0x20,
	0x77,
	0x68,
	0x61,
	0x74,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x69,
	0x6e,
	0x64,
	0x69,
	0x76,
	0x69,
	0x64,
	0x75,
	0x61,
	0x6c,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x73,
	0x20,
	0x70,
	0x65,
	0x72,
	0x6d,
	0x69,
	0x74,
	0x2e,
	0x20,
	0x20,
	0x49,
	0x6e,
	0x63,
	0x6c,
	0x75,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x61,
	0x20,
	0x63,
	0x6f,
	0x76,
	0x65,
	0x72,
	0x65,
	0x64,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x0a,
	0x69,
	0x6e,
	0x20,
	0x61,
	0x6e,
	0x20,
	0x61,
	0x67,
	0x67,
	0x72,
	0x65,
	0x67,
	0x61,
	0x74,
	0x65,
	0x20,
	0x64,
	0x6f,
	0x65,
	0x73,
	0x20,
	0x6e,
	0x6f,
	0x74,
	0x20,
	0x63,
	0x61,
	0x75,
	0x73,
	0x65,
	0x20,
	0x74,
	0x68,
	0x69,
	0x73,
	0x20,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x61,
	0x70,
	0x70,
	0x6c,
	0x79,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x6f,
	0x74,
	0x68,
	0x65,
	0x72,
	0x0a,
	0x70,
	0x61,
	0x72,
	0x74,
	0x73,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x61,
	0x67,
	0x67,
	0x72,
	0x65,
	0x67,
	0x61,
	0x74,
	0x65,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x36,
	0x2e,
	0x20,
	0x43,
	0x6f,
	0x6e,
	0x76,
	0x65,
	0x79,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x4e,
	0x6f,
	0x6e,
	0x2d,
	0x53,
	0x6f,
	0x75,
	0x72,
	0x63,
	0x65,
	0x20,
	0x46,
	0x6f,
	0x72,
	0x6d,
	0x73,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x59,
	0x6f,
	0x75,
	0x20,
	0x6d,
	0x61,
	0x79,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x76,
	0x65,
	0x79,
	0x20,
	0x61,
	0x20,
	0x63,
	0x6f,
	0x76,
	0x65,
	0x72,
	0x65,
	0x64,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x20,
	0x69,
	0x6e,
	0x20,
	0x6f,
	0x62,
	0x6a,
	0x65,
	0x63,
	0x74,
	0x20,
	0x63,
	0x6f,
	0x64,
	0x65,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x6d,
	0x20,
	0x75,
	0x6e,
	0x64,
	0x65,
	0x72,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x74,
	0x65,
	0x72,
	0x6d,
	0x73,
	0x0a,
	0x6f,
	0x66,
	0x20,
	0x73,
	0x65,
	0x63,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x73,
	0x20,
	0x34,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x35,
	0x2c,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x76,
	0x69,
	0x64,
	0x65,
	0x64,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x61,
	0x6c,
	0x73,
	0x6f,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x76,
	0x65,
	0x79,
	0x20,
	0x74,
	0x68,
	0x65,
	0x0a,
	0x6d,
	0x61,
	0x63,
	0x68,
	0x69,
	0x6e,
	0x65,
	0x2d,
	0x72,
	0x65,
	0x61,
	0x64,
	0x61,
	0x62,
	0x6c,
	0x65,
	0x20,
	0x43,
	0x6f,
	0x72,
	0x72,
	0x65,
	0x73,
	0x70,
	0x6f,
	0x6e,
	0x64,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x53,
	0x6f,
	0x75,
	0x72,
	0x63,
	0x65,
	0x20,
	0x75,
	0x6e,
	0x64,
	0x65,
	0x72,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x74,
	0x65,
	0x72,
	0x6d,
	0x73,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x69,
	0x73,
	0x20,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x2c,
	0x0a,
	0x69,
	0x6e,
	0x20,
	0x6f,
	0x6e,
	0x65,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x73,
	0x65,
	0x20,
	0x77,
	0x61,
	0x79,
	0x73,
	0x3a,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x61,
	0x29,
	0x20,
	0x43,
	0x6f,
	0x6e,
	0x76,
	0x65,
	0x79,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x6f,
	0x62,
	0x6a,
	0x65,
	0x63,
	0x74,
	0x20,
	0x63,
	0x6f,
	0x64,
	0x65,
	0x20,
	0x69,
	0x6e,
	0x2c,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x65,
	0x6d,
	0x62,
	0x6f,
	0x64,
	0x69,
	0x65,
	0x64,
	0x20,
	0x69,
	0x6e,
	0x2c,
	0x20,
	0x61,
	0x20,
	0x70,
	0x68,
	0x79,
	0x73,
	0x69,
	0x63,
	0x61,
	0x6c,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x64,
	0x75,
	0x63,
	0x74,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x28,
	0x69,
	0x6e,
	0x63,
	0x6c,
	0x75,
	0x64,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x61,
	0x20,
	0x70,
	0x68,
	0x79,
	0x73,
	0x69,
	0x63,
	0x61,
	0x6c,
	0x20,
	0x64,
	0x69,
	0x73,
	0x74,
	0x72,
	0x69,
	0x62,
	0x75,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x6d,
	0x65,
	0x64,
	0x69,
	0x75,
	0x6d,
	0x29,
	0x2c,
	0x20,
	0x61,
	0x63,
	0x63,
	0x6f,
	0x6d,
	0x70,
	0x61,
	0x6e,
	0x69,
	0x65,
	0x64,
	0x20,
	0x62,
	0x79,
	0x20,
	0x74,
	0x68,
	0x65,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x43,
	0x6f,
	0x72,
	0x72,
	0x65,
	0x73,
	0x70,
	0x6f,
	0x6e,
	0x64,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x53,
	0x6f,
	0x75,
	0x72,
	0x63,
	0x65,
	0x20,
	0x66,
	0x69,
	0x78,
	0x65,
	0x64,
	0x20,
	0x6f,
	0x6e,
	0x20,
	0x61,
	0x20,
	0x64,
	0x75,
	0x72,
	0x61,
	0x62,
	0x6c,
	0x65,
	0x20,
	0x70,
	0x68,
	0x79,
	0x73,
	0x69,
	0x63,
	0x61,
	0x6c,
	0x20,
	0x6d,
	0x65,
	0x64,
	0x69,
	0x75,
	0x6d,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x63,
	0x75,
	0x73,
	0x74,
	0x6f,
	0x6d,
	0x61,
	0x72,
	0x69,
	0x6c,
	0x79,
	0x20,
	0x75,
	0x73,
	0x65,
	0x64,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x20,
	0x73,
	0x6f,
	0x66,
	0x74,
	0x77,
	0x61,
	0x72,
	0x65,
	0x20,
	0x69,
	0x6e,
	0x74,
	0x65,
	0x72,
	0x63,
	0x68,
	0x61,
	0x6e,
	0x67,
	0x65,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x62,
	0x29,
	0x20,
	0x43,
	0x6f,
	0x6e,
	0x76,
	0x65,
	0x79,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x6f,
	0x62,
	0x6a,
	0x65,
	0x63,
	0x74,
	0x20,
	0x63,
	0x6f,
	0x64,
	0x65,
	0x20,
	0x69,
	0x6e,
	0x2c,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x65,
	0x6d,
	0x62,
	0x6f,
	0x64,
	0x69,
	0x65,
	0x64,
	0x20,
	0x69,
	0x6e,
	0x2c,
	0x20,
	0x61,
	0x20,
	0x70,
	0x68,
	0x79,
	0x73,
	0x69,
	0x63,
	0x61,
	0x6c,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x64,
	0x75,
	0x63,
	0x74,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x28,
	0x69,
	0x6e,
	0x63,
	0x6c,
	0x75,
	0x64,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x61,
	0x20,
	0x70,
	0x68,
	0x79,
	0x73,
	0x69,
	0x63,
	0x61,
	0x6c,
	0x20,
	0x64,
	0x69,
	0x73,
	0x74,
	0x72,
	0x69,
	0x62,
	0x75,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x6d,
	0x65,
	0x64,
	0x69,
	0x75,
	0x6d,
	0x29,
	0x2c,
	0x20,
	0x61,
	0x63,
	0x63,
	0x6f,
	0x6d,
	0x70,
	0x61,
	0x6e,
	0x69,
	0x65,
	0x64,
	0x20,
	0x62,
	0x79,
	0x20,
	0x61,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x77,
	0x72,
	0x69,
	0x74,
	0x74,
	0x65,
	0x6e,
	0x20,
	0x6f,
	0x66,
	0x66,
	0x65,
	0x72,
	0x2c,
	0x20,
	0x76,
	0x61,
	0x6c,
	0x69,
	0x64,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x20,
	0x61,
	0x74,
	0x20,
	0x6c,
	0x65,
	0x61,
	0x73,
	0x74,
	0x20,
	0x74,
	0x68,
	0x72,
	0x65,
	0x65,
	0x20,
	0x79,
	0x65,
	0x61,
	0x72,
	0x73,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x76,
	0x61,
	0x6c,
	0x69,
	0x64,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x20,
	0x61,
	0x73,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x6c,
	0x6f,
	0x6e,
	0x67,
	0x20,
	0x61,
	0x73,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x6f,
	0x66,
	0x66,
	0x65,
	0x72,
	0x20,
	0x73,
	0x70,
	0x61,
	0x72,
	0x65,
	0x20,
	0x70,
	0x61,
	0x72,
	0x74,
	0x73,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x63,
	0x75,
	0x73,
	0x74,
	0x6f,
	0x6d,
	0x65,
	0x72,
	0x20,
	0x73,
	0x75,
	0x70,
	0x70,
	0x6f,
	0x72,
	0x74,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x64,
	0x75,
	0x63,
	0x74,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x6d,
	0x6f,
	0x64,
	0x65,
	0x6c,
	0x2c,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x67,
	0x69,
	0x76,
	0x65,
	0x20,
	0x61,
	0x6e,
	0x79,
	0x6f,
	0x6e,
	0x65,
	0x20,
	0x77,
	0x68,
	0x6f,
	0x20,
	0x70,
	0x6f,
	0x73,
	0x73,
	0x65,
	0x73,
	0x73,
	0x65,
	0x73,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x6f,
	0x62,
	0x6a,
	0x65,
	0x63,
	0x74,
	0x20,
	0x63,
	0x6f,
	0x64,
	0x65,
	0x20,
	0x65,
	0x69,
	0x74,
	0x68,
	0x65,
	0x72,
	0x20,
	0x28,
	0x31,
	0x29,
	0x20,
	0x61,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x63,
	0x6f,
	0x70,
	0x79,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x43,
	0x6f,
	0x72,
	0x72,
	0x65,
	0x73,
	0x70,
	0x6f,
	0x6e,
	0x64,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x53,
	0x6f,
	0x75,
	0x72,
	0x63,
	0x65,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x20,
	0x61,
	0x6c,
	0x6c,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x73,
	0x6f,
	0x66,
	0x74,
	0x77,
	0x61,
	0x72,
	0x65,
	0x20,
	0x69,
	0x6e,
	0x20,
	0x74,
	0x68,
	0x65,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x64,
	0x75,
	0x63,
	0x74,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x69,
	0x73,
	0x20,
	0x63,
	0x6f,
	0x76,
	0x65,
	0x72,
	0x65,
	0x64,
	0x20,
	0x62,
	0x79,
	0x20,
	0x74,
	0x68,
	0x69,
	0x73,
	0x20,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x2c,
	0x20,
	0x6f,
	0x6e,
	0x20,
	0x61,
	0x20,
	0x64,
	0x75,
	0x72,
	0x61,
	0x62,
	0x6c,
	0x65,
	0x20,
	0x70,
	0x68,
	0x79,
	0x73,
	0x69,
	0x63,
	0x61,
	0x6c,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x6d,
	0x65,
	0x64,
	0x69,
	0x75,
	0x6d,
	0x20,
	0x63,
	0x75,
	0x73,
	0x74,
	0x6f,
	0x6d,
	0x61,
	0x72,
	0x69,
	0x6c,
	0x79,
	0x20,
	0x75,
	0x73,
	0x65,
	0x64,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x20,
	0x73,
	0x6f,
	0x66,
	0x74,
	0x77,
	0x61,
	0x72,
	0x65,
	0x20,
	0x69,
	0x6e,
	0x74,
	0x65,
	0x72,
	0x63,
	0x68,
	0x61,
	0x6e,
	0x67,
	0x65,
	0x2c,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x20,
	0x61,
	0x20,
	0x70,
	0x72,
	0x69,
	0x63,
	0x65,
	0x20,
	0x6e,
	0x6f,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x6d,
	0x6f,
	0x72,
	0x65,
	0x20,
	0x74,
	0x68,
	0x61,
	0x6e,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x72,
	0x20,
	0x72,
	0x65,
	0x61,
	0x73,
	0x6f,
	0x6e,
	0x61,
	0x62,
	0x6c,
	0x65,
	0x20,
	0x63,
	0x6f,
	0x73,
	0x74,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x70,
	0x68,
	0x79,
	0x73,
	0x69,
	0x63,
	0x61,
	0x6c,
	0x6c,
	0x79,
	0x20,
	0x70,
	0x65,
	0x72,
	0x66,
	0x6f,
	0x72,
	0x6d,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x74,
	0x68,
	0x69,
	0x73,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x76,
	0x65,
	0x79,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x73,
	0x6f,
	0x75,
	0x72,
	0x63,
	0x65,
	0x2c,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x28,
	0x32,
	0x29,
	0x20,
	0x61,
	0x63,
	0x63,
	0x65,
	0x73,
	0x73,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x63,
	0x6f,
	0x70,
	0x79,
	0x20,
	0x74,
	0x68,
	0x65,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x43,
	0x6f,
	0x72,
	0x72,
	0x65,
	0x73,
	0x70,
	0x6f,
	0x6e,
	0x64,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x53,
	0x6f,
	0x75,
	0x72,
	0x63,
	0x65,
	0x20,
	0x66,
	0x72,
	0x6f,
	0x6d,
	0x20,
	0x61,
	0x20,
	0x6e,
	0x65,
	0x74,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x20,
	0x73,
	0x65,
	0x72,
	0x76,
	0x65,
	0x72,
	0x20,
	0x61,
	0x74,
	0x20,
	0x6e,
	0x6f,
	0x20,
	0x63,
	0x68,
	0x61,
	0x72,
	0x67,
	0x65,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x63,
	0x29,
	0x20,
	0x43,
	0x6f,
	0x6e,
	0x76,
	0x65,
	0x79,
	0x20,
	0x69,
	0x6e,
	0x64,
	0x69,
	0x76,
	0x69,
	0x64,
	0x75,
	0x61,
	0x6c,
	0x20,
	0x63,
	0x6f,
	0x70,
	0x69,
	0x65,
	0x73,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x6f,
	0x62,
	0x6a,
	0x65,
	0x63,
	0x74,
	0x20,
	0x63,
	0x6f,
	0x64,
	0x65,
	0x20,
	0x77,
	0x69,
	0x74,
	0x68,
	0x20,
	0x61,
	0x20,
	0x63,
	0x6f,
	0x70,
	0x79,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x77,
	0x72,
	0x69,
	0x74,
	0x74,
	0x65,
	0x6e,
	0x20,
	0x6f,
	0x66,
	0x66,
	0x65,
	0x72,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x76,
	0x69,
	0x64,
	0x65,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x43,
	0x6f,
	0x72,
	0x72,
	0x65,
	0x73,
	0x70,
	0x6f,
	0x6e,
	0x64,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x53,
	0x6f,
	0x75,
	0x72,
	0x63,
	0x65,
	0x2e,
	0x20,
	0x20,
	0x54,
	0x68,
	0x69,
	0x73,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x61,
	0x6c,
	0x74,
	0x65,
	0x72,
	0x6e,
	0x61,
	0x74,
	0x69,
	0x76,
	0x65,
	0x20,
	0x69,
	0x73,
	0x20,
	0x61,
	0x6c,
	0x6c,
	0x6f,
	0x77,
	0x65,
	0x64,
	0x20,
	0x6f,
	0x6e,
	0x6c,
	0x79,
	0x20,
	0x6f,
	0x63,
	0x63,
	0x61,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x61,
	0x6c,
	0x6c,
	0x79,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x6e,
	0x6f,
	0x6e,
	0x63,
	0x6f,
	0x6d,
	0x6d,
	0x65,
	0x72,
	0x63,
	0x69,
	0x61,
	0x6c,
	0x6c,
	0x79,
	0x2c,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x6f,
	0x6e,
	0x6c,
	0x79,
	0x20,
	0x69,
	0x66,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x72,
	0x65,
	0x63,
	0x65,
	0x69,
	0x76,
	0x65,
	0x64,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x6f,
	0x62,
	0x6a,
	0x65,
	0x63,
	0x74,
	0x20,
	0x63,
	0x6f,
	0x64,
	0x65,
	0x20,
	0x77,
	0x69,
	0x74,
	0x68,
	0x20,
	0x73,
	0x75,
	0x63,
	0x68,
	0x20,
	0x61,
	0x6e,
	0x20,
	0x6f,
	0x66,
	0x66,
	0x65,
	0x72,
	0x2c,
	0x20,
	0x69,
	0x6e,
	0x20,
	0x61,
	0x63,
	0x63,
	0x6f,
	0x72,
	0x64,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x77,
	0x69,
	0x74,
	0x68,
	0x20,
	0x73,
	0x75,
	0x62,
	0x73,
	0x65,
	0x63,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x36,
	0x62,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x64,
	0x29,
	0x20,
	0x43,
	0x6f,
	0x6e,
	0x76,
	0x65,
	0x79,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x6f,
	0x62,
	0x6a,
	0x65,
	0x63,
	0x74,
	0x20,
	0x63,
	0x6f,
	0x64,
	0x65,
	0x20,
	0x62,
	0x79,
	0x20,
	0x6f,
	0x66,
	0x66,
	0x65,
	0x72,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x61,
	0x63,
	0x63,
	0x65,
	0x73,
	0x73,
	0x20,
	0x66,
	0x72,
	0x6f,
	0x6d,
	0x20,
	0x61,
	0x20,
	0x64,
	0x65,
	0x73,
	0x69,
	0x67,
	0x6e,
	0x61,
	0x74,
	0x65,
	0x64,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x70,
	0x6c,
	0x61,
	0x63,
	0x65,
	0x20,
	0x28,
	0x67,
	0x72,
	0x61,
	0x74,
	0x69,
	0x73,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x20,
	0x61,
	0x20,
	0x63,
	0x68,
	0x61,
	0x72,
	0x67,
	0x65,
	0x29,
	0x2c,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x6f,
	0x66,
	0x66,
	0x65,
	0x72,
	0x20,
	0x65,
	0x71,
	0x75,
	0x69,
	0x76,
	0x61,
	0x6c,
	0x65,
	0x6e,
	0x74,
	0x20,
	0x61,
	0x63,
	0x63,
	0x65,
	0x73,
	0x73,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x74,
	0x68,
	0x65,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x43,
	0x6f,
	0x72,
	0x72,
	0x65,
	0x73,
	0x70,
	0x6f,
	0x6e,
	0x64,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x53,
	0x6f,
	0x75,
	0x72,
	0x63,
	0x65,
	0x20,
	0x69,
	0x6e,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x73,
	0x61,
	0x6d,
	0x65,
	0x20,
	0x77,
	0x61,
	0x79,
	0x20,
	0x74,
	0x68,
	0x72,
	0x6f,
	0x75,
	0x67,
	0x68,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x73,
	0x61,
	0x6d,
	0x65,
	0x20,
	0x70,
	0x6c,
	0x61,
	0x63,
	0x65,
	0x20,
	0x61,
	0x74,
	0x20,
	0x6e,
	0x6f,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x66,
	0x75,
	0x72,
	0x74,
	0x68,
	0x65,
	0x72,
	0x20,
	0x63,
	0x68,
	0x61,
	0x72,
	0x67,
	0x65,
	0x2e,
	0x20,
	0x20,
	0x59,
	0x6f,
	0x75,
	0x20,
	0x6e,
	0x65,
	0x65,
	0x64,
	0x20,
	0x6e,
	0x6f,
	0x74,
	0x20,
	0x72,
	0x65,
	0x71,
	0x75,
	0x69,
	0x72,
	0x65,
	0x20,
	0x72,
	0x65,
	0x63,
	0x69,
	0x70,
	0x69,
	0x65,
	0x6e,
	0x74,
	0x73,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x63,
	0x6f,
	0x70,
	0x79,
	0x20,
	0x74,
	0x68,
	0x65,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x43,
	0x6f,
	0x72,
	0x72,
	0x65,
	0x73,
	0x70,
	0x6f,
	0x6e,
	0x64,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x53,
	0x6f,
	0x75,
	0x72,
	0x63,
	0x65,
	0x20,
	0x61,
	0x6c,
	0x6f,
	0x6e,
	0x67,
	0x20,
	0x77,
	0x69,
	0x74,
	0x68,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x6f,
	0x62,
	0x6a,
	0x65,
	0x63,
	0x74,
	0x20,
	0x63,
	0x6f,
	0x64,
	0x65,
	0x2e,
	0x20,
	0x20,
	0x49,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x70,
	0x6c,
	0x61,
	0x63,
	0x65,
	0x20,
	0x74,
	0x6f,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x63,
	0x6f,
	0x70,
	0x79,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x6f,
	0x62,
	0x6a,
	0x65,
	0x63,
	0x74,
	0x20,
	0x63,
	0x6f,
	0x64,
	0x65,
	0x20,
	0x69,
	0x73,
	0x20,
	0x61,
	0x20,
	0x6e,
	0x65,
	0x74,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x20,
	0x73,
	0x65,
	0x72,
	0x76,
	0x65,
	0x72,
	0x2c,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x43,
	0x6f,
	0x72,
	0x72,
	0x65,
	0x73,
	0x70,
	0x6f,
	0x6e,
	0x64,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x53,
	0x6f,
	0x75,
	0x72,
	0x63,
	0x65,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x6d,
	0x61,
	0x79,
	0x20,
	0x62,
	0x65,
	0x20,
	0x6f,
	0x6e,
	0x20,
	0x61,
	0x20,
	0x64,
	0x69,
	0x66,
	0x66,
	0x65,
	0x72,
	0x65,
	0x6e,
	0x74,
	0x20,
	0x73,
	0x65,
	0x72,
	0x76,
	0x65,
	0x72,
	0x20,
	0x28,
	0x6f,
	0x70,
	0x65,
	0x72,
	0x61,
	0x74,
	0x65,
	0x64,
	0x20,
	0x62,
	0x79,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x61,
	0x20,
	0x74,
	0x68,
	0x69,
	0x72,
	0x64,
	0x20,
	0x70,
	0x61,
	0x72,
	0x74,
	0x79,
	0x29,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x73,
	0x75,
	0x70,
	0x70,
	0x6f,
	0x72,
	0x74,
	0x73,
	0x20,
	0x65,
	0x71,
	0x75,
	0x69,
	0x76,
	0x61,
	0x6c,
	0x65,
	0x6e,
	0x74,
	0x20,
	0x63,
	0x6f,
	0x70,
	0x79,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x66,
	0x61,
	0x63,
	0x69,
	0x6c,
	0x69,
	0x74,
	0x69,
	0x65,
	0x73,
	0x2c,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x76,
	0x69,
	0x64,
	0x65,
	0x64,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x6d,
	0x61,
	0x69,
	0x6e,
	0x74,
	0x61,
	0x69,
	0x6e,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x63,
	0x6c,
	0x65,
	0x61,
	0x72,
	0x20,
	0x64,
	0x69,
	0x72,
	0x65,
	0x63,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x73,
	0x20,
	0x6e,
	0x65,
	0x78,
	0x74,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x6f,
	0x62,
	0x6a,
	0x65,
	0x63,
	0x74,
	0x20,
	0x63,
	0x6f,
	0x64,
	0x65,
	0x20,
	0x73,
	0x61,
	0x79,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x77,
	0x68,
	0x65,
	0x72,
	0x65,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x66,
	0x69,
	0x6e,
	0x64,
	0x20,
	0x74,
	0x68,
	0x65,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x43,
	0x6f,
	0x72,
	0x72,
	0x65,
	0x73,
	0x70,
	0x6f,
	0x6e,
	0x64,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x53,
	0x6f,
	0x75,
	0x72,
	0x63,
	0x65,
	0x2e,
	0x20,
	0x20,
	0x52,
	0x65,
	0x67,
	0x61,
	0x72,
	0x64,
	0x6c,
	0x65,
	0x73,
	0x73,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x77,
	0x68,
	0x61,
	0x74,
	0x20,
	0x73,
	0x65,
	0x72,
	0x76,
	0x65,
	0x72,
	0x20,
	0x68,
	0x6f,
	0x73,
	0x74,
	0x73,
	0x20,
	0x74,
	0x68,
	0x65,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x43,
	0x6f,
	0x72,
	0x72,
	0x65,
	0x73,
	0x70,
	0x6f,
	0x6e,
	0x64,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x53,
	0x6f,
	0x75,
	0x72,
	0x63,
	0x65,
	0x2c,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x72,
	0x65,
	0x6d,
	0x61,
	0x69,
	0x6e,
	0x20,
	0x6f,
	0x62,
	0x6c,
	0x69,
	0x67,
	0x61,
	0x74,
	0x65,
	0x64,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x65,
	0x6e,
	0x73,
	0x75,
	0x72,
	0x65,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x69,
	0x74,
	0x20,
	0x69,
	0x73,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x61,
	0x76,
	0x61,
	0x69,
	0x6c,
	0x61,
	0x62,
	0x6c,
	0x65,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x20,
	0x61,
	0x73,
	0x20,
	0x6c,
	0x6f,
	0x6e,
	0x67,
	0x20,
	0x61,
	0x73,
	0x20,
	0x6e,
	0x65,
	0x65,
	0x64,
	0x65,
	0x64,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x73,
	0x61,
	0x74,
	0x69,
	0x73,
	0x66,
	0x79,
	0x20,
	0x74,
	0x68,
	0x65,
	0x73,
	0x65,
	0x20,
	0x72,
	0x65,
	0x71,
	0x75,
	0x69,
	0x72,
	0x65,
	0x6d,
	0x65,
	0x6e,
	0x74,
	0x73,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x65,
	0x29,
	0x20,
	0x43,
	0x6f,
	0x6e,
	0x76,
	0x65,
	0x79,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x6f,
	0x62,
	0x6a,
	0x65,
	0x63,
	0x74,
	0x20,
	0x63,
	0x6f,
	0x64,
	0x65,
	0x20,
	0x75,
	0x73,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x70,
	0x65,
	0x65,
	0x72,
	0x2d,
	0x74,
	0x6f,
	0x2d,
	0x70,
	0x65,
	0x65,
	0x72,
	0x20,
	0x74,
	0x72,
	0x61,
	0x6e,
	0x73,
	0x6d,
	0x69,
	0x73,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x2c,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x76,
	0x69,
	0x64,
	0x65,
	0x64,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x69,
	0x6e,
	0x66,
	0x6f,
	0x72,
	0x6d,
	0x20,
	0x6f,
	0x74,
	0x68,
	0x65,
	0x72,
	0x20,
	0x70,
	0x65,
	0x65,
	0x72,
	0x73,
	0x20,
	0x77,
	0x68,
	0x65,
	0x72,
	0x65,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x6f,
	0x62,
	0x6a,
	0x65,
	0x63,
	0x74,
	0x20,
	0x63,
	0x6f,
	0x64,
	0x65,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x43,
	0x6f,
	0x72,
	0x72,
	0x65,
	0x73,
	0x70,
	0x6f,
	0x6e,
	0x64,
	0x69,
	0x6e,
	0x67,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x53,
	0x6f,
	0x75,
	0x72,
	0x63,
	0x65,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x20,
	0x61,
	0x72,
	0x65,
	0x20,
	0x62,
	0x65,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x6f,
	0x66,
	0x66,
	0x65,
	0x72,
	0x65,
	0x64,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x67,
	0x65,
	0x6e,
	0x65,
	0x72,
	0x61,
	0x6c,
	0x20,
	0x70,
	0x75,
	0x62,
	0x6c,
	0x69,
	0x63,
	0x20,
	0x61,
	0x74,
	0x20,
	0x6e,
	0x6f,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x63,
	0x68,
	0x61,
	0x72,
	0x67,
	0x65,
	0x20,
	0x75,
	0x6e,
	0x64,
	0x65,
	0x72,
	0x20,
	0x73,
	0x75,
	0x62,
	0x73,
	0x65,
	0x63,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x36,
	0x64,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x41,
	0x20,
	0x73,
	0x65,
	0x70,
	0x61,
	0x72,
	0x61,
	0x62,
	0x6c,
	0x65,
	0x20,
	0x70,
	0x6f,
	0x72,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x6f,
	0x62,
	0x6a,
	0x65,
	0x63,
	0x74,
	0x20,
	0x63,
	0x6f,
	0x64,
	0x65,
	0x2c,
	0x20,
	0x77,
	0x68,
	0x6f,
	0x73,
	0x65,
	0x20,
	0x73,
	0x6f,
	0x75,
	0x72,
	0x63,
	0x65,
	0x20,
	0x63,
	0x6f,
	0x64,
	0x65,
	0x20,
	0x69,
	0x73,
	0x20,
	0x65,
	0x78,
	0x63,
	0x6c,
	0x75,
	0x64,
	0x65,
	0x64,
	0x0a,
	0x66,
	0x72,
	0x6f,
	0x6d,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x43,
	0x6f,
	0x72,
	0x72,
	0x65,
	0x73,
	0x70,
	0x6f,
	0x6e,
	0x64,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x53,
	0x6f,
	0x75,
	0x72,
	0x63,
	0x65,
	0x20,
	0x61,
	0x73,
	0x20,
	0x61,
	0x20,
	0x53,
	0x79,
	0x73,
	0x74,
	0x65,
	0x6d,
	0x20,
	0x4c,
	0x69,
	0x62,
	0x72,
	0x61,
	0x72,
	0x79,
	0x2c,
	0x20,
	0x6e,
	0x65,
	0x65,
	0x64,
	0x20,
	0x6e,
	0x6f,
	0x74,
	0x20,
	0x62,
	0x65,
	0x0a,
	0x69,
	0x6e,
	0x63,
	0x6c,
	0x75,
	0x64,
	0x65,
	0x64,
	0x20,
	0x69,
	0x6e,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x76,
	0x65,
	0x79,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x6f,
	0x62,
	0x6a,
	0x65,
	0x63,
	0x74,
	0x20,
	0x63,
	0x6f,
	0x64,
	0x65,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x41,
	0x20,
	0x22,
	0x55,
	0x73,
	0x65,
	0x72,
	0x20,
	0x50,
	0x72,
	0x6f,
	0x64,
	0x75,
	0x63,
	0x74,
	0x22,
	0x20,
	0x69,
	0x73,
	0x20,
	0x65,
	0x69,
	0x74,
	0x68,
	0x65,
	0x72,
	0x20,
	0x28,
	0x31,
	0x29,
	0x20,
	0x61,
	0x20,
	0x22,
	0x63,
	0x6f,
	0x6e,
	0x73,
	0x75,
	0x6d,
	0x65,
	0x72,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x64,
	0x75,
	0x63,
	0x74,
	0x22,
	0x2c,
	0x20,
	0x77,
	0x68,
	0x69,
	0x63,
	0x68,
	0x20,
	0x6d,
	0x65,
	0x61,
	0x6e,
	0x73,
	0x20,
	0x61,
	0x6e,
	0x79,
	0x0a,
	0x74,
	0x61,
	0x6e,
	0x67,
	0x69,
	0x62,
	0x6c,
	0x65,
	0x20,
	0x70,
	0x65,
	0x72,
	0x73,
	0x6f,
	0x6e,
	0x61,
	0x6c,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x70,
	0x65,
	0x72,
	0x74,
	0x79,
	0x20,
	0x77,
	0x68,
	0x69,
	0x63,
	0x68,
	0x20,
	0x69,
	0x73,
	0x20,
	0x6e,
	0x6f,
	0x72,
	0x6d,
	0x61,
	0x6c,
	0x6c,
	0x79,
	0x20,
	0x75,
	0x73,
	0x65,
	0x64,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x20,
	0x70,
	0x65,
	0x72,
	0x73,
	0x6f,
	0x6e,
	0x61,
	0x6c,
	0x2c,
	0x20,
	0x66,
	0x61,
	0x6d,
	0x69,
	0x6c,
	0x79,
	0x2c,
	0x0a,
	0x6f,
	0x72,
	0x20,
	0x68,
	0x6f,
	0x75,
	0x73,
	0x65,
	0x68,
	0x6f,
	0x6c,
	0x64,
	0x20,
	0x70,
	0x75,
	0x72,
	0x70,
	0x6f,
	0x73,
	0x65,
	0x73,
	0x2c,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x28,
	0x32,
	0x29,
	0x20,
	0x61,
	0x6e,
	0x79,
	0x74,
	0x68,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x64,
	0x65,
	0x73,
	0x69,
	0x67,
	0x6e,
	0x65,
	0x64,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x73,
	0x6f,
	0x6c,
	0x64,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x20,
	0x69,
	0x6e,
	0x63,
	0x6f,
	0x72,
	0x70,
	0x6f,
	0x72,
	0x61,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x0a,
	0x69,
	0x6e,
	0x74,
	0x6f,
	0x20,
	0x61,
	0x20,
	0x64,
	0x77,
	0x65,
	0x6c,
	0x6c,
	0x69,
	0x6e,
	0x67,
	0x2e,
	0x20,
	0x20,
	0x49,
	0x6e,
	0x20,
	0x64,
	0x65,
	0x74,
	0x65,
	0x72,
	0x6d,
	0x69,
	0x6e,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x77,
	0x68,
	0x65,
	0x74,
	0x68,
	0x65,
	0x72,
	0x20,
	0x61,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x64,
	0x75,
	0x63,
	0x74,
	0x20,
	0x69,
	0x73,
	0x20,
	0x61,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x73,
	0x75,
	0x6d,
	0x65,
	0x72,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x64,
	0x75,
	0x63,
	0x74,
	0x2c,
	0x0a,
	0x64,
	0x6f,
	0x75,
	0x62,
	0x74,
	0x66,
	0x75,
	0x6c,
	0x20,
	0x63,
	0x61,
	0x73,
	0x65,
	0x73,
	0x20,
	0x73,
	0x68,
	0x61,
	0x6c,
	0x6c,
	0x20,
	0x62,
	0x65,
	0x20,
	0x72,
	0x65,
	0x73,
	0x6f,
	0x6c,
	0x76,
	0x65,
	0x64,
	0x20,
	0x69,
	0x6e,
	0x20,
	0x66,
	0x61,
	0x76,
	0x6f,
	0x72,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x63,
	0x6f,
	0x76,
	0x65,
	0x72,
	0x61,
	0x67,
	0x65,
	0x2e,
	0x20,
	0x20,
	0x46,
	0x6f,
	0x72,
	0x20,
	0x61,
	0x20,
	0x70,
	0x61,
	0x72,
	0x74,
	0x69,
	0x63,
	0x75,
	0x6c,
	0x61,
	0x72,
	0x0a,
	0x70,
	0x72,
	0x6f,
	0x64,
	0x75,
	0x63,
	0x74,
	0x20,
	0x72,
	0x65,
	0x63,
	0x65,
	0x69,
	0x76,
	0x65,
	0x64,
	0x20,
	0x62,
	0x79,
	0x20,
	0x61,
	0x20,
	0x70,
	0x61,
	0x72,
	0x74,
	0x69,
	0x63,
	0x75,
	0x6c,
	0x61,
	0x72,
	0x20,
	0x75,
	0x73,
	0x65,
	0x72,
	0x2c,
	0x20,
	0x22,
	0x6e,
	0x6f,
	0x72,
	0x6d,
	0x61,
	0x6c,
	0x6c,
	0x79,
	0x20,
	0x75,
	0x73,
	0x65,
	0x64,
	0x22,
	0x20,
	0x72,
	0x65,
	0x66,
	0x65,
	0x72,
	0x73,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x61,
	0x0a,
	0x74,
	0x79,
	0x70,
	0x69,
	0x63,
	0x61,
	0x6c,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x63,
	0x6f,
	0x6d,
	0x6d,
	0x6f,
	0x6e,
	0x20,
	0x75,
	0x73,
	0x65,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x63,
	0x6c,
	0x61,
	0x73,
	0x73,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x64,
	0x75,
	0x63,
	0x74,
	0x2c,
	0x20,
	0x72,
	0x65,
	0x67,
	0x61,
	0x72,
	0x64,
	0x6c,
	0x65,
	0x73,
	0x73,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x73,
	0x74,
	0x61,
	0x74,
	0x75,
	0x73,
	0x0a,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x70,
	0x61,
	0x72,
	0x74,
	0x69,
	0x63,
	0x75,
	0x6c,
	0x61,
	0x72,
	0x20,
	0x75,
	0x73,
	0x65,
	0x72,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x77,
	0x61,
	0x79,
	0x20,
	0x69,
	0x6e,
	0x20,
	0x77,
	0x68,
	0x69,
	0x63,
	0x68,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x70,
	0x61,
	0x72,
	0x74,
	0x69,
	0x63,
	0x75,
	0x6c,
	0x61,
	0x72,
	0x20,
	0x75,
	0x73,
	0x65,
	0x72,
	0x0a,
	0x61,
	0x63,
	0x74,
	0x75,
	0x61,
	0x6c,
	0x6c,
	0x79,
	0x20,
	0x75,
	0x73,
	0x65,
	0x73,
	0x2c,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x65,
	0x78,
	0x70,
	0x65,
	0x63,
	0x74,
	0x73,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x69,
	0x73,
	0x20,
	0x65,
	0x78,
	0x70,
	0x65,
	0x63,
	0x74,
	0x65,
	0x64,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x75,
	0x73,
	0x65,
	0x2c,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x64,
	0x75,
	0x63,
	0x74,
	0x2e,
	0x20,
	0x20,
	0x41,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x64,
	0x75,
	0x63,
	0x74,
	0x0a,
	0x69,
	0x73,
	0x20,
	0x61,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x73,
	0x75,
	0x6d,
	0x65,
	0x72,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x64,
	0x75,
	0x63,
	0x74,
	0x20,
	0x72,
	0x65,
	0x67,
	0x61,
	0x72,
	0x64,
	0x6c,
	0x65,
	0x73,
	0x73,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x77,
	0x68,
	0x65,
	0x74,
	0x68,
	0x65,
	0x72,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x64,
	0x75,
	0x63,
	0x74,
	0x20,
	0x68,
	0x61,
	0x73,
	0x20,
	0x73,
	0x75,
	0x62,
	0x73,
	0x74,
	0x61,
	0x6e,
	0x74,
	0x69,
	0x61,
	0x6c,
	0x0a,
	0x63,
	0x6f,
	0x6d,
	0x6d,
	0x65,
	0x72,
	0x63,
	0x69,
	0x61,
	0x6c,
	0x2c,
	0x20,
	0x69,
	0x6e,
	0x64,
	0x75,
	0x73,
	0x74,
	0x72,
	0x69,
	0x61,
	0x6c,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x6e,
	0x6f,
	0x6e,
	0x2d,
	0x63,
	0x6f,
	0x6e,
	0x73,
	0x75,
	0x6d,
	0x65,
	0x72,
	0x20,
	0x75,
	0x73,
	0x65,
	0x73,
	0x2c,
	0x20,
	0x75,
	0x6e,
	0x6c,
	0x65,
	0x73,
	0x73,
	0x20,
	0x73,
	0x75,
	0x63,
	0x68,
	0x20,
	0x75,
	0x73,
	0x65,
	0x73,
	0x20,
	0x72,
	0x65,
	0x70,
	0x72,
	0x65,
	0x73,
	0x65,
	0x6e,
	0x74,
	0x0a,
	0x74,
	0x68,
	0x65,
	0x20,
	0x6f,
	0x6e,
	0x6c,
	0x79,
	0x20,
	0x73,
	0x69,
	0x67,
	0x6e,
	0x69,
	0x66,
	0x69,
	0x63,
	0x61,
	0x6e,
	0x74,
	0x20,
	0x6d,
	0x6f,
	0x64,
	0x65,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x75,
	0x73,
	0x65,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x64,
	0x75,
	0x63,
	0x74,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x22,
	0x49,
	0x6e,
	0x73,
	0x74,
	0x61,
	0x6c,
	0x6c,
	0x61,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x49,
	0x6e,
	0x66,
	0x6f,
	0x72,
	0x6d,
	0x61,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x22,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x20,
	0x61,
	0x20,
	0x55,
	0x73,
	0x65,
	0x72,
	0x20,
	0x50,
	0x72,
	0x6f,
	0x64,
	0x75,
	0x63,
	0x74,
	0x20,
	0x6d,
	0x65,
	0x61,
	0x6e,
	0x73,
	0x20,
	0x61,
	0x6e,
	0x79,
	0x20,
	0x6d,
	0x65,
	0x74,
	0x68,
	0x6f,
	0x64,
	0x73,
	0x2c,
	0x0a,
	0x70,
	0x72,
	0x6f,
	0x63,
	0x65,
	0x64,
	0x75,
	0x72,
	0x65,
	0x73,
	0x2c,
	0x20,
	0x61,
	0x75,
	0x74,
	0x68,
	0x6f,
	0x72,
	0x69,
	0x7a,
	0x61,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x6b,
	0x65,
	0x79,
	0x73,
	0x2c,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x6f,
	0x74,
	0x68,
	0x65,
	0x72,
	0x20,
	0x69,
	0x6e,
	0x66,
	0x6f,
	0x72,
	0x6d,
	0x61,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x72,
	0x65,
	0x71,
	0x75,
	0x69,
	0x72,
	0x65,
	0x64,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x69,
	0x6e,
	0x73,
	0x74,
	0x61,
	0x6c,
	0x6c,
	0x0a,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x65,
	0x78,
	0x65,
	0x63,
	0x75,
	0x74,
	0x65,
	0x20,
	0x6d,
	0x6f,
	0x64,
	0x69,
	0x66,
	0x69,
	0x65,
	0x64,
	0x20,
	0x76,
	0x65,
	0x72,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x73,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x61,
	0x20,
	0x63,
	0x6f,
	0x76,
	0x65,
	0x72,
	0x65,
	0x64,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x20,
	0x69,
	0x6e,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x55,
	0x73,
	0x65,
	0x72,
	0x20,
	0x50,
	0x72,
	0x6f,
	0x64,
	0x75,
	0x63,
	0x74,
	0x20,
	0x66,
	0x72,
	0x6f,
	0x6d,
	0x0a,
	0x61,
	0x20,
	0x6d,
	0x6f,
	0x64,
	0x69,
	0x66,
	0x69,
	0x65,
	0x64,
	0x20,
	0x76,
	0x65,
	0x72,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x69,
	0x74,
	0x73,
	0x20,
	0x43,
	0x6f,
	0x72,
	0x72,
	0x65,
	0x73,
	0x70,
	0x6f,
	0x6e,
	0x64,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x53,
	0x6f,
	0x75,
	0x72,
	0x63,
	0x65,
	0x2e,
	0x20,
	0x20,
	0x54,
	0x68,
	0x65,
	0x20,
	0x69,
	0x6e,
	0x66,
	0x6f,
	0x72,
	0x6d,
	0x61,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x6d,
	0x75,
	0x73,
	0x74,
	0x0a,
	0x73,
	0x75,
	0x66,
	0x66,
	0x69,
	0x63,
	0x65,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x65,
	0x6e,
	0x73,
	0x75,
	0x72,
	0x65,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x74,
	0x69,
	0x6e,
	0x75,
	0x65,
	0x64,
	0x20,
	0x66,
	0x75,
	0x6e,
	0x63,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x6d,
	0x6f,
	0x64,
	0x69,
	0x66,
	0x69,
	0x65,
	0x64,
	0x20,
	0x6f,
	0x62,
	0x6a,
	0x65,
	0x63,
	0x74,
	0x0a,
	0x63,
	0x6f,
	0x64,
	0x65,
	0x20,
	0x69,
	0x73,
	0x20,
	0x69,
	0x6e,
	0x20,
	0x6e,
	0x6f,
	0x20,
	0x63,
	0x61,
	0x73,
	0x65,
	0x20,
	0x70,
	0x72,
	0x65,
	0x76,
	0x65,
	0x6e,
	0x74,
	0x65,
	0x64,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x69,
	0x6e,
	0x74,
	0x65,
	0x72,
	0x66,
	0x65,
	0x72,
	0x65,
	0x64,
	0x20,
	0x77,
	0x69,
	0x74,
	0x68,
	0x20,
	0x73,
	0x6f,
	0x6c,
	0x65,
	0x6c,
	0x79,
	0x20,
	0x62,
	0x65,
	0x63,
	0x61,
	0x75,
	0x73,
	0x65,
	0x0a,
	0x6d,
	0x6f,
	0x64,
	0x69,
	0x66,
	0x69,
	0x63,
	0x61,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x68,
	0x61,
	0x73,
	0x20,
	0x62,
	0x65,
	0x65,
	0x6e,
	0x20,
	0x6d,
	0x61,
	0x64,
	0x65,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x49,
	0x66,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x76,
	0x65,
	0x79,
	0x20,
	0x61,
	0x6e,
	0x20,
	0x6f,
	0x62,
	0x6a,
	0x65,
	0x63,
	0x74,
	0x20,
	0x63,
	0x6f,
	0x64,
	0x65,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x20,
	0x75,
	0x6e,
	0x64,
	0x65,
	0x72,
	0x20,
	0x74,
	0x68,
	0x69,
	0x73,
	0x20,
	0x73,
	0x65,
	0x63,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x69,
	0x6e,
	0x2c,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x77,
	0x69,
	0x74,
	0x68,
	0x2c,
	0x20,
	0x6f,
	0x72,
	0x0a,
	0x73,
	0x70,
	0x65,
	0x63,
	0x69,
	0x66,
	0x69,
	0x63,
	0x61,
	0x6c,
	0x6c,
	0x79,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x20,
	0x75,
	0x73,
	0x65,
	0x20,
	0x69,
	0x6e,
	0x2c,
	0x20,
	0x61,
	0x20,
	0x55,
	0x73,
	0x65,
	0x72,
	0x20,
	0x50,
	0x72,
	0x6f,
	0x64,
	0x75,
	0x63,
	0x74,
	0x2c,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x76,
	0x65,
	0x79,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x6f,
	0x63,
	0x63,
	0x75,
	0x72,
	0x73,
	0x20,
	0x61,
	0x73,
	0x0a,
	0x70,
	0x61,
	0x72,
	0x74,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x61,
	0x20,
	0x74,
	0x72,
	0x61,
	0x6e,
	0x73,
	0x61,
	0x63,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x69,
	0x6e,
	0x20,
	0x77,
	0x68,
	0x69,
	0x63,
	0x68,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x72,
	0x69,
	0x67,
	0x68,
	0x74,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x70,
	0x6f,
	0x73,
	0x73,
	0x65,
	0x73,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x75,
	0x73,
	0x65,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x0a,
	0x55,
	0x73,
	0x65,
	0x72,
	0x20,
	0x50,
	0x72,
	0x6f,
	0x64,
	0x75,
	0x63,
	0x74,
	0x20,
	0x69,
	0x73,
	0x20,
	0x74,
	0x72,
	0x61,
	0x6e,
	0x73,
	0x66,
	0x65,
	0x72,
	0x72,
	0x65,
	0x64,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x72,
	0x65,
	0x63,
	0x69,
	0x70,
	0x69,
	0x65,
	0x6e,
	0x74,
	0x20,
	0x69,
	0x6e,
	0x20,
	0x70,
	0x65,
	0x72,
	0x70,
	0x65,
	0x74,
	0x75,
	0x69,
	0x74,
	0x79,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x20,
	0x61,
	0x0a,
	0x66,
	0x69,
	0x78,
	0x65,
	0x64,
	0x20,
	0x74,
	0x65,
	0x72,
	0x6d,
	0x20,
	0x28,
	0x72,
	0x65,
	0x67,
	0x61,
	0x72,
	0x64,
	0x6c,
	0x65,
	0x73,
	0x73,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x68,
	0x6f,
	0x77,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x74,
	0x72,
	0x61,
	0x6e,
	0x73,
	0x61,
	0x63,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x69,
	0x73,
	0x20,
	0x63,
	0x68,
	0x61,
	0x72,
	0x61,
	0x63,
	0x74,
	0x65,
	0x72,
	0x69,
	0x7a,
	0x65,
	0x64,
	0x29,
	0x2c,
	0x20,
	0x74,
	0x68,
	0x65,
	0x0a,
	0x43,
	0x6f,
	0x72,
	0x72,
	0x65,
	0x73,
	0x70,
	0x6f,
	0x6e,
	0x64,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x53,
	0x6f,
	0x75,
	0x72,
	0x63,
	0x65,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x76,
	0x65,
	0x79,
	0x65,
	0x64,
	0x20,
	0x75,
	0x6e,
	0x64,
	0x65,
	0x72,
	0x20,
	0x74,
	0x68,
	0x69,
	0x73,
	0x20,
	0x73,
	0x65,
	0x63,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x6d,
	0x75,
	0x73,
	0x74,
	0x20,
	0x62,
	0x65,
	0x20,
	0x61,
	0x63,
	0x63,
	0x6f,
	0x6d,
	0x70,
	0x61,
	0x6e,
	0x69,
	0x65,
	0x64,
	0x0a,
	0x62,
	0x79,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x49,
	0x6e,
	0x73,
	0x74,
	0x61,
	0x6c,
	0x6c,
	0x61,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x49,
	0x6e,
	0x66,
	0x6f,
	0x72,
	0x6d,
	0x61,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x2e,
	0x20,
	0x20,
	0x42,
	0x75,
	0x74,
	0x20,
	0x74,
	0x68,
	0x69,
	0x73,
	0x20,
	0x72,
	0x65,
	0x71,
	0x75,
	0x69,
	0x72,
	0x65,
	0x6d,
	0x65,
	0x6e,
	0x74,
	0x20,
	0x64,
	0x6f,
	0x65,
	0x73,
	0x20,
	0x6e,
	0x6f,
	0x74,
	0x20,
	0x61,
	0x70,
	0x70,
	0x6c,
	0x79,
	0x0a,
	0x69,
	0x66,
	0x20,
	0x6e,
	0x65,
	0x69,
	0x74,
	0x68,
	0x65,
	0x72,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x6e,
	0x6f,
	0x72,
	0x20,
	0x61,
	0x6e,
	0x79,
	0x20,
	0x74,
	0x68,
	0x69,
	0x72,
	0x64,
	0x20,
	0x70,
	0x61,
	0x72,
	0x74,
	0x79,
	0x20,
	0x72,
	0x65,
	0x74,
	0x61,
	0x69,
	0x6e,
	0x73,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x61,
	0x62,
	0x69,
	0x6c,
	0x69,
	0x74,
	0x79,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x69,
	0x6e,
	0x73,
	0x74,
	0x61,
	0x6c,
	0x6c,
	0x0a,
	0x6d,
	0x6f,
	0x64,
	0x69,
	0x66,
	0x69,
	0x65,
	0x64,
	0x20,
	0x6f,
	0x62,
	0x6a,
	0x65,
	0x63,
	0x74,
	0x20,
	0x63,
	0x6f,
	0x64,
	0x65,
	0x20,
	0x6f,
	0x6e,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x55,
	0x73,
	0x65,
	0x72,
	0x20,
	0x50,
	0x72,
	0x6f,
	0x64,
	0x75,
	0x63,
	0x74,
	0x20,
	0x28,
	0x66,
	0x6f,
	0x72,
	0x20,
	0x65,
	0x78,
	0x61,
	0x6d,
	0x70,
	0x6c,
	0x65,
	0x2c,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x20,
	0x68,
	0x61,
	0x73,
	0x0a,
	0x62,
	0x65,
	0x65,
	0x6e,
	0x20,
	0x69,
	0x6e,
	0x73,
	0x74,
	0x61,
	0x6c,
	0x6c,
	0x65,
	0x64,
	0x20,
	0x69,
	0x6e,
	0x20,
	0x52,
	0x4f,
	0x4d,
	0x29,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x54,
	0x68,
	0x65,
	0x20,
	0x72,
	0x65,
	0x71,
	0x75,
	0x69,
	0x72,
	0x65,
	0x6d,
	0x65,
	0x6e,
	0x74,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x76,
	0x69,
	0x64,
	0x65,
	0x20,
	0x49,
	0x6e,
	0x73,
	0x74,
	0x61,
	0x6c,
	0x6c,
	0x61,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x49,
	0x6e,
	0x66,
	0x6f,
	0x72,
	0x6d,
	0x61,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x64,
	0x6f,
	0x65,
	0x73,
	0x20,
	0x6e,
	0x6f,
	0x74,
	0x20,
	0x69,
	0x6e,
	0x63,
	0x6c,
	0x75,
	0x64,
	0x65,
	0x20,
	0x61,
	0x0a,
	0x72,
	0x65,
	0x71,
	0x75,
	0x69,
	0x72,
	0x65,
	0x6d,
	0x65,
	0x6e,
	0x74,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x74,
	0x69,
	0x6e,
	0x75,
	0x65,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x76,
	0x69,
	0x64,
	0x65,
	0x20,
	0x73,
	0x75,
	0x70,
	0x70,
	0x6f,
	0x72,
	0x74,
	0x20,
	0x73,
	0x65,
	0x72,
	0x76,
	0x69,
	0x63,
	0x65,
	0x2c,
	0x20,
	0x77,
	0x61,
	0x72,
	0x72,
	0x61,
	0x6e,
	0x74,
	0x79,
	0x2c,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x75,
	0x70,
	0x64,
	0x61,
	0x74,
	0x65,
	0x73,
	0x0a,
	0x66,
	0x6f,
	0x72,
	0x20,
	0x61,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x68,
	0x61,
	0x73,
	0x20,
	0x62,
	0x65,
	0x65,
	0x6e,
	0x20,
	0x6d,
	0x6f,
	0x64,
	0x69,
	0x66,
	0x69,
	0x65,
	0x64,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x69,
	0x6e,
	0x73,
	0x74,
	0x61,
	0x6c,
	0x6c,
	0x65,
	0x64,
	0x20,
	0x62,
	0x79,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x72,
	0x65,
	0x63,
	0x69,
	0x70,
	0x69,
	0x65,
	0x6e,
	0x74,
	0x2c,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x0a,
	0x74,
	0x68,
	0x65,
	0x20,
	0x55,
	0x73,
	0x65,
	0x72,
	0x20,
	0x50,
	0x72,
	0x6f,
	0x64,
	0x75,
	0x63,
	0x74,
	0x20,
	0x69,
	0x6e,
	0x20,
	0x77,
	0x68,
	0x69,
	0x63,
	0x68,
	0x20,
	0x69,
	0x74,
	0x20,
	0x68,
	0x61,
	0x73,
	0x20,
	0x62,
	0x65,
	0x65,
	0x6e,
	0x20,
	0x6d,
	0x6f,
	0x64,
	0x69,
	0x66,
	0x69,
	0x65,
	0x64,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x69,
	0x6e,
	0x73,
	0x74,
	0x61,
	0x6c,
	0x6c,
	0x65,
	0x64,
	0x2e,
	0x20,
	0x20,
	0x41,
	0x63,
	0x63,
	0x65,
	0x73,
	0x73,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x61,
	0x0a,
	0x6e,
	0x65,
	0x74,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x20,
	0x6d,
	0x61,
	0x79,
	0x20,
	0x62,
	0x65,
	0x20,
	0x64,
	0x65,
	0x6e,
	0x69,
	0x65,
	0x64,
	0x20,
	0x77,
	0x68,
	0x65,
	0x6e,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x6d,
	0x6f,
	0x64,
	0x69,
	0x66,
	0x69,
	0x63,
	0x61,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x69,
	0x74,
	0x73,
	0x65,
	0x6c,
	0x66,
	0x20,
	0x6d,
	0x61,
	0x74,
	0x65,
	0x72,
	0x69,
	0x61,
	0x6c,
	0x6c,
	0x79,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x0a,
	0x61,
	0x64,
	0x76,
	0x65,
	0x72,
	0x73,
	0x65,
	0x6c,
	0x79,
	0x20,
	0x61,
	0x66,
	0x66,
	0x65,
	0x63,
	0x74,
	0x73,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x6f,
	0x70,
	0x65,
	0x72,
	0x61,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x6e,
	0x65,
	0x74,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x76,
	0x69,
	0x6f,
	0x6c,
	0x61,
	0x74,
	0x65,
	0x73,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x72,
	0x75,
	0x6c,
	0x65,
	0x73,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x0a,
	0x70,
	0x72,
	0x6f,
	0x74,
	0x6f,
	0x63,
	0x6f,
	0x6c,
	0x73,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x20,
	0x63,
	0x6f,
	0x6d,
	0x6d,
	0x75,
	0x6e,
	0x69,
	0x63,
	0x61,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x61,
	0x63,
	0x72,
	0x6f,
	0x73,
	0x73,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x6e,
	0x65,
	0x74,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x43,
	0x6f,
	0x72,
	0x72,
	0x65,
	0x73,
	0x70,
	0x6f,
	0x6e,
	0x64,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x53,
	0x6f,
	0x75,
	0x72,
	0x63,
	0x65,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x76,
	0x65,
	0x79,
	0x65,
	0x64,
	0x2c,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x49,
	0x6e,
	0x73,
	0x74,
	0x61,
	0x6c,
	0x6c,
	0x61,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x49,
	0x6e,
	0x66,
	0x6f,
	0x72,
	0x6d,
	0x61,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x76,
	0x69,
	0x64,
	0x65,
	0x64,
	0x2c,
	0x0a,
	0x69,
	0x6e,
	0x20,
	0x61,
	0x63,
	0x63,
	0x6f,
	0x72,
	0x64,
	0x20,
	0x77,
	0x69,
	0x74,
	0x68,
	0x20,
	0x74,
	0x68,
	0x69,
	0x73,
	0x20,
	0x73,
	0x65,
	0x63,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x6d,
	0x75,
	0x73,
	0x74,
	0x20,
	0x62,
	0x65,
	0x20,
	0x69,
	0x6e,
	0x20,
	0x61,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x6d,
	0x61,
	0x74,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x69,
	0x73,
	0x20,
	0x70,
	0x75,
	0x62,
	0x6c,
	0x69,
	0x63,
	0x6c,
	0x79,
	0x0a,
	0x64,
	0x6f,
	0x63,
	0x75,
	0x6d,
	0x65,
	0x6e,
	0x74,
	0x65,
	0x64,
	0x20,
	0x28,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x77,
	0x69,
	0x74,
	0x68,
	0x20,
	0x61,
	0x6e,
	0x20,
	0x69,
	0x6d,
	0x70,
	0x6c,
	0x65,
	0x6d,
	0x65,
	0x6e,
	0x74,
	0x61,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x61,
	0x76,
	0x61,
	0x69,
	0x6c,
	0x61,
	0x62,
	0x6c,
	0x65,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x70,
	0x75,
	0x62,
	0x6c,
	0x69,
	0x63,
	0x20,
	0x69,
	0x6e,
	0x0a,
	0x73,
	0x6f,
	0x75,
	0x72,
	0x63,
	0x65,
	0x20,
	0x63,
	0x6f,
	0x64,
	0x65,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x6d,
	0x29,
	0x2c,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x6d,
	0x75,
	0x73,
	0x74,
	0x20,
	0x72,
	0x65,
	0x71,
	0x75,
	0x69,
	0x72,
	0x65,
	0x20,
	0x6e,
	0x6f,
	0x20,
	0x73,
	0x70,
	0x65,
	0x63,
	0x69,
	0x61,
	0x6c,
	0x20,
	0x70,
	0x61,
	0x73,
	0x73,
	0x77,
	0x6f,
	0x72,
	0x64,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x6b,
	0x65,
	0x79,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x0a,
	0x75,
	0x6e,
	0x70,
	0x61,
	0x63,
	0x6b,
	0x69,
	0x6e,
	0x67,
	0x2c,
	0x20,
	0x72,
	0x65,
	0x61,
	0x64,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x63,
	0x6f,
	0x70,
	0x79,
	0x69,
	0x6e,
	0x67,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x37,
	0x2e,
	0x20,
	0x41,
	0x64,
	0x64,
	0x69,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x61,
	0x6c,
	0x20,
	0x54,
	0x65,
	0x72,
	0x6d,
	0x73,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x22,
	0x41,
	0x64,
	0x64,
	0x69,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x61,
	0x6c,
	0x20,
	0x70,
	0x65,
	0x72,
	0x6d,
	0x69,
	0x73,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x73,
	0x22,
	0x20,
	0x61,
	0x72,
	0x65,
	0x20,
	0x74,
	0x65,
	0x72,
	0x6d,
	0x73,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x73,
	0x75,
	0x70,
	0x70,
	0x6c,
	0x65,
	0x6d,
	0x65,
	0x6e,
	0x74,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x74,
	0x65,
	0x72,
	0x6d,
	0x73,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x69,
	0x73,
	0x0a,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x20,
	0x62,
	0x79,
	0x20,
	0x6d,
	0x61,
	0x6b,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x65,
	0x78,
	0x63,
	0x65,
	0x70,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x73,
	0x20,
	0x66,
	0x72,
	0x6f,
	0x6d,
	0x20,
	0x6f,
	0x6e,
	0x65,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x6d,
	0x6f,
	0x72,
	0x65,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x69,
	0x74,
	0x73,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x64,
	0x69,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x73,
	0x2e,
	0x0a,
	0x41,
	0x64,
	0x64,
	0x69,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x61,
	0x6c,
	0x20,
	0x70,
	0x65,
	0x72,
	0x6d,
	0x69,
	0x73,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x73,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x61,
	0x72,
	0x65,
	0x20,
	0x61,
	0x70,
	0x70,
	0x6c,
	0x69,
	0x63,
	0x61,
	0x62,
	0x6c,
	0x65,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x65,
	0x6e,
	0x74,
	0x69,
	0x72,
	0x65,
	0x20,
	0x50,
	0x72,
	0x6f,
	0x67,
	0x72,
	0x61,
	0x6d,
	0x20,
	0x73,
	0x68,
	0x61,
	0x6c,
	0x6c,
	0x0a,
	0x62,
	0x65,
	0x20,
	0x74,
	0x72,
	0x65,
	0x61,
	0x74,
	0x65,
	0x64,
	0x20,
	0x61,
	0x73,
	0x20,
	0x74,
	0x68,
	0x6f,
	0x75,
	0x67,
	0x68,
	0x20,
	0x74,
	0x68,
	0x65,
	0x79,
	0x20,
	0x77,
	0x65,
	0x72,
	0x65,
	0x20,
	0x69,
	0x6e,
	0x63,
	0x6c,
	0x75,
	0x64,
	0x65,
	0x64,
	0x20,
	0x69,
	0x6e,
	0x20,
	0x74,
	0x68,
	0x69,
	0x73,
	0x20,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x2c,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x65,
	0x78,
	0x74,
	0x65,
	0x6e,
	0x74,
	0x0a,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x74,
	0x68,
	0x65,
	0x79,
	0x20,
	0x61,
	0x72,
	0x65,
	0x20,
	0x76,
	0x61,
	0x6c,
	0x69,
	0x64,
	0x20,
	0x75,
	0x6e,
	0x64,
	0x65,
	0x72,
	0x20,
	0x61,
	0x70,
	0x70,
	0x6c,
	0x69,
	0x63,
	0x61,
	0x62,
	0x6c,
	0x65,
	0x20,
	0x6c,
	0x61,
	0x77,
	0x2e,
	0x20,
	0x20,
	0x49,
	0x66,
	0x20,
	0x61,
	0x64,
	0x64,
	0x69,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x61,
	0x6c,
	0x20,
	0x70,
	0x65,
	0x72,
	0x6d,
	0x69,
	0x73,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x73,
	0x0a,
	0x61,
	0x70,
	0x70,
	0x6c,
	0x79,
	0x20,
	0x6f,
	0x6e,
	0x6c,
	0x79,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x70,
	0x61,
	0x72,
	0x74,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x50,
	0x72,
	0x6f,
	0x67,
	0x72,
	0x61,
	0x6d,
	0x2c,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x70,
	0x61,
	0x72,
	0x74,
	0x20,
	0x6d,
	0x61,
	0x79,
	0x20,
	0x62,
	0x65,
	0x20,
	0x75,
	0x73,
	0x65,
	0x64,
	0x20,
	0x73,
	0x65,
	0x70,
	0x61,
	0x72,
	0x61,
	0x74,
	0x65,
	0x6c,
	0x79,
	0x0a,
	0x75,
	0x6e,
	0x64,
	0x65,
	0x72,
	0x20,
	0x74,
	0x68,
	0x6f,
	0x73,
	0x65,
	0x20,
	0x70,
	0x65,
	0x72,
	0x6d,
	0x69,
	0x73,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x73,
	0x2c,
	0x20,
	0x62,
	0x75,
	0x74,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x65,
	0x6e,
	0x74,
	0x69,
	0x72,
	0x65,
	0x20,
	0x50,
	0x72,
	0x6f,
	0x67,
	0x72,
	0x61,
	0x6d,
	0x20,
	0x72,
	0x65,
	0x6d,
	0x61,
	0x69,
	0x6e,
	0x73,
	0x20,
	0x67,
	0x6f,
	0x76,
	0x65,
	0x72,
	0x6e,
	0x65,
	0x64,
	0x20,
	0x62,
	0x79,
	0x0a,
	0x74,
	0x68,
	0x69,
	0x73,
	0x20,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x20,
	0x77,
	0x69,
	0x74,
	0x68,
	0x6f,
	0x75,
	0x74,
	0x20,
	0x72,
	0x65,
	0x67,
	0x61,
	0x72,
	0x64,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x61,
	0x64,
	0x64,
	0x69,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x61,
	0x6c,
	0x20,
	0x70,
	0x65,
	0x72,
	0x6d,
	0x69,
	0x73,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x73,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x57,
	0x68,
	0x65,
	0x6e,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x76,
	0x65,
	0x79,
	0x20,
	0x61,
	0x20,
	0x63,
	0x6f,
	0x70,
	0x79,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x61,
	0x20,
	0x63,
	0x6f,
	0x76,
	0x65,
	0x72,
	0x65,
	0x64,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x2c,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x6d,
	0x61,
	0x79,
	0x20,
	0x61,
	0x74,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x72,
	0x20,
	0x6f,
	0x70,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x0a,
	0x72,
	0x65,
	0x6d,
	0x6f,
	0x76,
	0x65,
	0x20,
	0x61,
	0x6e,
	0x79,
	0x20,
	0x61,
	0x64,
	0x64,
	0x69,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x61,
	0x6c,
	0x20,
	0x70,
	0x65,
	0x72,
	0x6d,
	0x69,
	0x73,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x73,
	0x20,
	0x66,
	0x72,
	0x6f,
	0x6d,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x63,
	0x6f,
	0x70,
	0x79,
	0x2c,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x66,
	0x72,
	0x6f,
	0x6d,
	0x20,
	0x61,
	0x6e,
	0x79,
	0x20,
	0x70,
	0x61,
	0x72,
	0x74,
	0x20,
	0x6f,
	0x66,
	0x0a,
	0x69,
	0x74,
	0x2e,
	0x20,
	0x20,
	0x28,
	0x41,
	0x64,
	0x64,
	0x69,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x61,
	0x6c,
	0x20,
	0x70,
	0x65,
	0x72,
	0x6d,
	0x69,
	0x73,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x73,
	0x20,
	0x6d,
	0x61,
	0x79,
	0x20,
	0x62,
	0x65,
	0x20,
	0x77,
	0x72,
	0x69,
	0x74,
	0x74,
	0x65,
	0x6e,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x72,
	0x65,
	0x71,
	0x75,
	0x69,
	0x72,
	0x65,
	0x20,
	0x74,
	0x68,
	0x65,
	0x69,
	0x72,
	0x20,
	0x6f,
	0x77,
	0x6e,
	0x0a,
	0x72,
	0x65,
	0x6d,
	0x6f,
	0x76,
	0x61,
	0x6c,
	0x20,
	0x69,
	0x6e,
	0x20,
	0x63,
	0x65,
	0x72,
	0x74,
	0x61,
	0x69,
	0x6e,
	0x20,
	0x63,
	0x61,
	0x73,
	0x65,
	0x73,
	0x20,
	0x77,
	0x68,
	0x65,
	0x6e,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x6d,
	0x6f,
	0x64,
	0x69,
	0x66,
	0x79,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x2e,
	0x29,
	0x20,
	0x20,
	0x59,
	0x6f,
	0x75,
	0x20,
	0x6d,
	0x61,
	0x79,
	0x20,
	0x70,
	0x6c,
	0x61,
	0x63,
	0x65,
	0x0a,
	0x61,
	0x64,
	0x64,
	0x69,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x61,
	0x6c,
	0x20,
	0x70,
	0x65,
	0x72,
	0x6d,
	0x69,
	0x73,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x73,
	0x20,
	0x6f,
	0x6e,
	0x20,
	0x6d,
	0x61,
	0x74,
	0x65,
	0x72,
	0x69,
	0x61,
	0x6c,
	0x2c,
	0x20,
	0x61,
	0x64,
	0x64,
	0x65,
	0x64,
	0x20,
	0x62,
	0x79,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x61,
	0x20,
	0x63,
	0x6f,
	0x76,
	0x65,
	0x72,
	0x65,
	0x64,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x2c,
	0x0a,
	0x66,
	0x6f,
	0x72,
	0x20,
	0x77,
	0x68,
	0x69,
	0x63,
	0x68,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x68,
	0x61,
	0x76,
	0x65,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x63,
	0x61,
	0x6e,
	0x20,
	0x67,
	0x69,
	0x76,
	0x65,
	0x20,
	0x61,
	0x70,
	0x70,
	0x72,
	0x6f,
	0x70,
	0x72,
	0x69,
	0x61,
	0x74,
	0x65,
	0x20,
	0x63,
	0x6f,
	0x70,
	0x79,
	0x72,
	0x69,
	0x67,
	0x68,
	0x74,
	0x20,
	0x70,
	0x65,
	0x72,
	0x6d,
	0x69,
	0x73,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x4e,
	0x6f,
	0x74,
	0x77,
	0x69,
	0x74,
	0x68,
	0x73,
	0x74,
	0x61,
	0x6e,
	0x64,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x61,
	0x6e,
	0x79,
	0x20,
	0x6f,
	0x74,
	0x68,
	0x65,
	0x72,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x76,
	0x69,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x69,
	0x73,
	0x20,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x2c,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x20,
	0x6d,
	0x61,
	0x74,
	0x65,
	0x72,
	0x69,
	0x61,
	0x6c,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x0a,
	0x61,
	0x64,
	0x64,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x61,
	0x20,
	0x63,
	0x6f,
	0x76,
	0x65,
	0x72,
	0x65,
	0x64,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x2c,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x6d,
	0x61,
	0x79,
	0x20,
	0x28,
	0x69,
	0x66,
	0x20,
	0x61,
	0x75,
	0x74,
	0x68,
	0x6f,
	0x72,
	0x69,
	0x7a,
	0x65,
	0x64,
	0x20,
	0x62,
	0x79,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x63,
	0x6f,
	0x70,
	0x79,
	0x72,
	0x69,
	0x67,
	0x68,
	0x74,
	0x20,
	0x68,
	0x6f,
	0x6c,
	0x64,
	0x65,
	0x72,
	0x73,
	0x20,
	0x6f,
	0x66,
	0x0a,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x6d,
	0x61,
	0x74,
	0x65,
	0x72,
	0x69,
	0x61,
	0x6c,
	0x29,
	0x20,
	0x73,
	0x75,
	0x70,
	0x70,
	0x6c,
	0x65,
	0x6d,
	0x65,
	0x6e,
	0x74,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x74,
	0x65,
	0x72,
	0x6d,
	0x73,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x69,
	0x73,
	0x20,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x20,
	0x77,
	0x69,
	0x74,
	0x68,
	0x20,
	0x74,
	0x65,
	0x72,
	0x6d,
	0x73,
	0x3a,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x61,
	0x29,
	0x20,
	0x44,
	0x69,
	0x73,
	0x63,
	0x6c,
	0x61,
	0x69,
	0x6d,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x77,
	0x61,
	0x72,
	0x72,
	0x61,
	0x6e,
	0x74,
	0x79,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x6c,
	0x69,
	0x6d,
	0x69,
	0x74,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x6c,
	0x69,
	0x61,
	0x62,
	0x69,
	0x6c,
	0x69,
	0x74,
	0x79,
	0x20,
	0x64,
	0x69,
	0x66,
	0x66,
	0x65,
	0x72,
	0x65,
	0x6e,
	0x74,
	0x6c,
	0x79,
	0x20,
	0x66,
	0x72,
	0x6f,
	0x6d,
	0x20,
	0x74,
	0x68,
	0x65,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x74,
	0x65,
	0x72,
	0x6d,
	0x73,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x73,
	0x65,
	0x63,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x73,
	0x20,
	0x31,
	0x35,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x31,
	0x36,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x69,
	0x73,
	0x20,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x3b,
	0x20,
	0x6f,
	0x72,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x62,
	0x29,
	0x20,
	0x52,
	0x65,
	0x71,
	0x75,
	0x69,
	0x72,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x70,
	0x72,
	0x65,
	0x73,
	0x65,
	0x72,
	0x76,
	0x61,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x73,
	0x70,
	0x65,
	0x63,
	0x69,
	0x66,
	0x69,
	0x65,
	0x64,
	0x20,
	0x72,
	0x65,
	0x61,
	0x73,
	0x6f,
	0x6e,
	0x61,
	0x62,
	0x6c,
	0x65,
	0x20,
	0x6c,
	0x65,
	0x67,
	0x61,
	0x6c,
	0x20,
	0x6e,
	0x6f,
	0x74,
	0x69,
	0x63,
	0x65,
	0x73,
	0x20,
	0x6f,
	0x72,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x61,
	0x75,
	0x74,
	0x68,
	0x6f,
	0x72,
	0x20,
	0x61,
	0x74,
	0x74,
	0x72,
	0x69,
	0x62,
	0x75,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x73,
	0x20,
	0x69,
	0x6e,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x6d,
	0x61,
	0x74,
	0x65,
	0x72,
	0x69,
	0x61,
	0x6c,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x69,
	0x6e,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x41,
	0x70,
	0x70,
	0x72,
	0x6f,
	0x70,
	0x72,
	0x69,
	0x61,
	0x74,
	0x65,
	0x20,
	0x4c,
	0x65,
	0x67,
	0x61,
	0x6c,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x4e,
	0x6f,
	0x74,
	0x69,
	0x63,
	0x65,
	0x73,
	0x20,
	0x64,
	0x69,
	0x73,
	0x70,
	0x6c,
	0x61,
	0x79,
	0x65,
	0x64,
	0x20,
	0x62,
	0x79,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x73,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x74,
	0x61,
	0x69,
	0x6e,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x69,
	0x74,
	0x3b,
	0x20,
	0x6f,
	0x72,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x63,
	0x29,
	0x20,
	0x50,
	0x72,
	0x6f,
	0x68,
	0x69,
	0x62,
	0x69,
	0x74,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x6d,
	0x69,
	0x73,
	0x72,
	0x65,
	0x70,
	0x72,
	0x65,
	0x73,
	0x65,
	0x6e,
	0x74,
	0x61,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x6f,
	0x72,
	0x69,
	0x67,
	0x69,
	0x6e,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x6d,
	0x61,
	0x74,
	0x65,
	0x72,
	0x69,
	0x61,
	0x6c,
	0x2c,
	0x20,
	0x6f,
	0x72,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x72,
	0x65,
	0x71,
	0x75,
	0x69,
	0x72,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x6d,
	0x6f,
	0x64,
	0x69,
	0x66,
	0x69,
	0x65,
	0x64,
	0x20,
	0x76,
	0x65,
	0x72,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x73,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x73,
	0x75,
	0x63,
	0x68,
	0x20,
	0x6d,
	0x61,
	0x74,
	0x65,
	0x72,
	0x69,
	0x61,
	0x6c,
	0x20,
	0x62,
	0x65,
	0x20,
	0x6d,
	0x61,
	0x72,
	0x6b,
	0x65,
	0x64,
	0x20,
	0x69,
	0x6e,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x72,
	0x65,
	0x61,
	0x73,
	0x6f,
	0x6e,
	0x61,
	0x62,
	0x6c,
	0x65,
	0x20,
	0x77,
	0x61,
	0x79,
	0x73,
	0x20,
	0x61,
	0x73,
	0x20,
	0x64,
	0x69,
	0x66,
	0x66,
	0x65,
	0x72,
	0x65,
	0x6e,
	0x74,
	0x20,
	0x66,
	0x72,
	0x6f,
	0x6d,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x6f,
	0x72,
	0x69,
	0x67,
	0x69,
	0x6e,
	0x61,
	0x6c,
	0x20,
	0x76,
	0x65,
	0x72,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x3b,
	0x20,
	0x6f,
	0x72,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x64,
	0x29,
	0x20,
	0x4c,
	0x69,
	0x6d,
	0x69,
	0x74,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x75,
	0x73,
	0x65,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x20,
	0x70,
	0x75,
	0x62,
	0x6c,
	0x69,
	0x63,
	0x69,
	0x74,
	0x79,
	0x20,
	0x70,
	0x75,
	0x72,
	0x70,
	0x6f,
	0x73,
	0x65,
	0x73,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x6e,
	0x61,
	0x6d,
	0x65,
	0x73,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x6c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x6f,
	0x72,
	0x73,
	0x20,
	0x6f,
	0x72,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x61,
	0x75,
	0x74,
	0x68,
	0x6f,
	0x72,
	0x73,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x6d,
	0x61,
	0x74,
	0x65,
	0x72,
	0x69,
	0x61,
	0x6c,
	0x3b,
	0x20,
	0x6f,
	0x72,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x65,
	0x29,
	0x20,
	0x44,
	0x65,
	0x63,
	0x6c,
	0x69,
	0x6e,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x67,
	0x72,
	0x61,
	0x6e,
	0x74,
	0x20,
	0x72,
	0x69,
	0x67,
	0x68,
	0x74,
	0x73,
	0x20,
	0x75,
	0x6e,
	0x64,
	0x65,
	0x72,
	0x20,
	0x74,
	0x72,
	0x61,
	0x64,
	0x65,
	0x6d,
	0x61,
	0x72,
	0x6b,
	0x20,
	0x6c,
	0x61,
	0x77,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x20,
	0x75,
	0x73,
	0x65,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x73,
	0x6f,
	0x6d,
	0x65,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x74,
	0x72,
	0x61,
	0x64,
	0x65,
	0x20,
	0x6e,
	0x61,
	0x6d,
	0x65,
	0x73,
	0x2c,
	0x20,
	0x74,
	0x72,
	0x61,
	0x64,
	0x65,
	0x6d,
	0x61,
	0x72,
	0x6b,
	0x73,
	0x2c,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x73,
	0x65,
	0x72,
	0x76,
	0x69,
	0x63,
	0x65,
	0x20,
	0x6d,
	0x61,
	0x72,
	0x6b,
	0x73,
	0x3b,
	0x20,
	0x6f,
	0x72,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x66,
	0x29,
	0x20,
	0x52,
	0x65,
	0x71,
	0x75,
	0x69,
	0x72,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x69,
	0x6e,
	0x64,
	0x65,
	0x6d,
	0x6e,
	0x69,
	0x66,
	0x69,
	0x63,
	0x61,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x6c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x6f,
	0x72,
	0x73,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x61,
	0x75,
	0x74,
	0x68,
	0x6f,
	0x72,
	0x73,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x6d,
	0x61,
	0x74,
	0x65,
	0x72,
	0x69,
	0x61,
	0x6c,
	0x20,
	0x62,
	0x79,
	0x20,
	0x61,
	0x6e,
	0x79,
	0x6f,
	0x6e,
	0x65,
	0x20,
	0x77,
	0x68,
	0x6f,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x76,
	0x65,
	0x79,
	0x73,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x6d,
	0x61,
	0x74,
	0x65,
	0x72,
	0x69,
	0x61,
	0x6c,
	0x20,
	0x28,
	0x6f,
	0x72,
	0x20,
	0x6d,
	0x6f,
	0x64,
	0x69,
	0x66,
	0x69,
	0x65,
	0x64,
	0x20,
	0x76,
	0x65,
	0x72,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x73,
	0x20,
	0x6f,
	0x66,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x69,
	0x74,
	0x29,
	0x20,
	0x77,
	0x69,
	0x74,
	0x68,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x74,
	0x72,
	0x61,
	0x63,
	0x74,
	0x75,
	0x61,
	0x6c,
	0x20,
	0x61,
	0x73,
	0x73,
	0x75,
	0x6d,
	0x70,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x73,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x6c,
	0x69,
	0x61,
	0x62,
	0x69,
	0x6c,
	0x69,
	0x74,
	0x79,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x72,
	0x65,
	0x63,
	0x69,
	0x70,
	0x69,
	0x65,
	0x6e,
	0x74,
	0x2c,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x61,
	0x6e,
	0x79,
	0x20,
	0x6c,
	0x69,
	0x61,
	0x62,
	0x69,
	0x6c,
	0x69,
	0x74,
	0x79,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x74,
	0x68,
	0x65,
	0x73,
	0x65,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x74,
	0x72,
	0x61,
	0x63,
	0x74,
	0x75,
	0x61,
	0x6c,
	0x20,
	0x61,
	0x73,
	0x73,
	0x75,
	0x6d,
	0x70,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x73,
	0x20,
	0x64,
	0x69,
	0x72,
	0x65,
	0x63,
	0x74,
	0x6c,
	0x79,
	0x20,
	0x69,
	0x6d,
	0x70,
	0x6f,
	0x73,
	0x65,
	0x20,
	0x6f,
	0x6e,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x74,
	0x68,
	0x6f,
	0x73,
	0x65,
	0x20,
	0x6c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x6f,
	0x72,
	0x73,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x61,
	0x75,
	0x74,
	0x68,
	0x6f,
	0x72,
	0x73,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x41,
	0x6c,
	0x6c,
	0x20,
	0x6f,
	0x74,
	0x68,
	0x65,
	0x72,
	0x20,
	0x6e,
	0x6f,
	0x6e,
	0x2d,
	0x70,
	0x65,
	0x72,
	0x6d,
	0x69,
	0x73,
	0x73,
	0x69,
	0x76,
	0x65,
	0x20,
	0x61,
	0x64,
	0x64,
	0x69,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x61,
	0x6c,
	0x20,
	0x74,
	0x65,
	0x72,
	0x6d,
	0x73,
	0x20,
	0x61,
	0x72,
	0x65,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x73,
	0x69,
	0x64,
	0x65,
	0x72,
	0x65,
	0x64,
	0x20,
	0x22,
	0x66,
	0x75,
	0x72,
	0x74,
	0x68,
	0x65,
	0x72,
	0x0a,
	0x72,
	0x65,
	0x73,
	0x74,
	0x72,
	0x69,
	0x63,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x73,
	0x22,
	0x20,
	0x77,
	0x69,
	0x74,
	0x68,
	0x69,
	0x6e,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x6d,
	0x65,
	0x61,
	0x6e,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x73,
	0x65,
	0x63,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x31,
	0x30,
	0x2e,
	0x20,
	0x20,
	0x49,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x50,
	0x72,
	0x6f,
	0x67,
	0x72,
	0x61,
	0x6d,
	0x20,
	0x61,
	0x73,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x0a,
	0x72,
	0x65,
	0x63,
	0x65,
	0x69,
	0x76,
	0x65,
	0x64,
	0x20,
	0x69,
	0x74,
	0x2c,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x61,
	0x6e,
	0x79,
	0x20,
	0x70,
	0x61,
	0x72,
	0x74,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x69,
	0x74,
	0x2c,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x74,
	0x61,
	0x69,
	0x6e,
	0x73,
	0x20,
	0x61,
	0x20,
	0x6e,
	0x6f,
	0x74,
	0x69,
	0x63,
	0x65,
	0x20,
	0x73,
	0x74,
	0x61,
	0x74,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x69,
	0x74,
	0x20,
	0x69,
	0x73,
	0x0a,
	0x67,
	0x6f,
	0x76,
	0x65,
	0x72,
	0x6e,
	0x65,
	0x64,
	0x20,
	0x62,
	0x79,
	0x20,
	0x74,
	0x68,
	0x69,
	0x73,
	0x20,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x20,
	0x61,
	0x6c,
	0x6f,
	0x6e,
	0x67,
	0x20,
	0x77,
	0x69,
	0x74,
	0x68,
	0x20,
	0x61,
	0x20,
	0x74,
	0x65,
	0x72,
	0x6d,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x69,
	0x73,
	0x20,
	0x61,
	0x20,
	0x66,
	0x75,
	0x72,
	0x74,
	0x68,
	0x65,
	0x72,
	0x0a,
	0x72,
	0x65,
	0x73,
	0x74,
	0x72,
	0x69,
	0x63,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x2c,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x6d,
	0x61,
	0x79,
	0x20,
	0x72,
	0x65,
	0x6d,
	0x6f,
	0x76,
	0x65,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x74,
	0x65,
	0x72,
	0x6d,
	0x2e,
	0x20,
	0x20,
	0x49,
	0x66,
	0x20,
	0x61,
	0x20,
	0x6c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x20,
	0x64,
	0x6f,
	0x63,
	0x75,
	0x6d,
	0x65,
	0x6e,
	0x74,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x74,
	0x61,
	0x69,
	0x6e,
	0x73,
	0x0a,
	0x61,
	0x20,
	0x66,
	0x75,
	0x72,
	0x74,
	0x68,
	0x65,
	0x72,
	0x20,
	0x72,
	0x65,
	0x73,
	0x74,
	0x72,
	0x69,
	0x63,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x62,
	0x75,
	0x74,
	0x20,
	0x70,
	0x65,
	0x72,
	0x6d,
	0x69,
	0x74,
	0x73,
	0x20,
	0x72,
	0x65,
	0x6c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x76,
	0x65,
	0x79,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x75,
	0x6e,
	0x64,
	0x65,
	0x72,
	0x20,
	0x74,
	0x68,
	0x69,
	0x73,
	0x0a,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x2c,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x6d,
	0x61,
	0x79,
	0x20,
	0x61,
	0x64,
	0x64,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x61,
	0x20,
	0x63,
	0x6f,
	0x76,
	0x65,
	0x72,
	0x65,
	0x64,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x20,
	0x6d,
	0x61,
	0x74,
	0x65,
	0x72,
	0x69,
	0x61,
	0x6c,
	0x20,
	0x67,
	0x6f,
	0x76,
	0x65,
	0x72,
	0x6e,
	0x65,
	0x64,
	0x20,
	0x62,
	0x79,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x74,
	0x65,
	0x72,
	0x6d,
	0x73,
	0x0a,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x6c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x20,
	0x64,
	0x6f,
	0x63,
	0x75,
	0x6d,
	0x65,
	0x6e,
	0x74,
	0x2c,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x76,
	0x69,
	0x64,
	0x65,
	0x64,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x66,
	0x75,
	0x72,
	0x74,
	0x68,
	0x65,
	0x72,
	0x20,
	0x72,
	0x65,
	0x73,
	0x74,
	0x72,
	0x69,
	0x63,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x64,
	0x6f,
	0x65,
	0x73,
	0x0a,
	0x6e,
	0x6f,
	0x74,
	0x20,
	0x73,
	0x75,
	0x72,
	0x76,
	0x69,
	0x76,
	0x65,
	0x20,
	0x73,
	0x75,
	0x63,
	0x68,
	0x20,
	0x72,
	0x65,
	0x6c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x76,
	0x65,
	0x79,
	0x69,
	0x6e,
	0x67,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x49,
	0x66,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x61,
	0x64,
	0x64,
	0x20,
	0x74,
	0x65,
	0x72,
	0x6d,
	0x73,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x61,
	0x20,
	0x63,
	0x6f,
	0x76,
	0x65,
	0x72,
	0x65,
	0x64,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x20,
	0x69,
	0x6e,
	0x20,
	0x61,
	0x63,
	0x63,
	0x6f,
	0x72,
	0x64,
	0x20,
	0x77,
	0x69,
	0x74,
	0x68,
	0x20,
	0x74,
	0x68,
	0x69,
	0x73,
	0x20,
	0x73,
	0x65,
	0x63,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x2c,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x0a,
	0x6d,
	0x75,
	0x73,
	0x74,
	0x20,
	0x70,
	0x6c,
	0x61,
	0x63,
	0x65,
	0x2c,
	0x20,
	0x69,
	0x6e,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x72,
	0x65,
	0x6c,
	0x65,
	0x76,
	0x61,
	0x6e,
	0x74,
	0x20,
	0x73,
	0x6f,
	0x75,
	0x72,
	0x63,
	0x65,
	0x20,
	0x66,
	0x69,
	0x6c,
	0x65,
	0x73,
	0x2c,
	0x20,
	0x61,
	0x20,
	0x73,
	0x74,
	0x61,
	0x74,
	0x65,
	0x6d,
	0x65,
	0x6e,
	0x74,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x0a,
	0x61,
	0x64,
	0x64,
	0x69,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x61,
	0x6c,
	0x20,
	0x74,
	0x65,
	0x72,
	0x6d,
	0x73,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x61,
	0x70,
	0x70,
	0x6c,
	0x79,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x74,
	0x68,
	0x6f,
	0x73,
	0x65,
	0x20,
	0x66,
	0x69,
	0x6c,
	0x65,
	0x73,
	0x2c,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x61,
	0x20,
	0x6e,
	0x6f,
	0x74,
	0x69,
	0x63,
	0x65,
	0x20,
	0x69,
	0x6e,
	0x64,
	0x69,
	0x63,
	0x61,
	0x74,
	0x69,
	0x6e,
	0x67,
	0x0a,
	0x77,
	0x68,
	0x65,
	0x72,
	0x65,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x66,
	0x69,
	0x6e,
	0x64,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x61,
	0x70,
	0x70,
	0x6c,
	0x69,
	0x63,
	0x61,
	0x62,
	0x6c,
	0x65,
	0x20,
	0x74,
	0x65,
	0x72,
	0x6d,
	0x73,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x41,
	0x64,
	0x64,
	0x69,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x61,
	0x6c,
	0x20,
	0x74,
	0x65,
	0x72,
	0x6d,
	0x73,
	0x2c,
	0x20,
	0x70,
	0x65,
	0x72,
	0x6d,
	0x69,
	0x73,
	0x73,
	0x69,
	0x76,
	0x65,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x6e,
	0x6f,
	0x6e,
	0x2d,
	0x70,
	0x65,
	0x72,
	0x6d,
	0x69,
	0x73,
	0x73,
	0x69,
	0x76,
	0x65,
	0x2c,
	0x20,
	0x6d,
	0x61,
	0x79,
	0x20,
	0x62,
	0x65,
	0x20,
	0x73,
	0x74,
	0x61,
	0x74,
	0x65,
	0x64,
	0x20,
	0x69,
	0x6e,
	0x20,
	0x74,
	0x68,
	0x65,
	0x0a,
	0x66,
	0x6f,
	0x72,
	0x6d,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x61,
	0x20,
	0x73,
	0x65,
	0x70,
	0x61,
	0x72,
	0x61,
	0x74,
	0x65,
	0x6c,
	0x79,
	0x20,
	0x77,
	0x72,
	0x69,
	0x74,
	0x74,
	0x65,
	0x6e,
	0x20,
	0x6c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x2c,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x73,
	0x74,
	0x61,
	0x74,
	0x65,
	0x64,
	0x20,
	0x61,
	0x73,
	0x20,
	0x65,
	0x78,
	0x63,
	0x65,
	0x70,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x73,
	0x3b,
	0x0a,
	0x74,
	0x68,
	0x65,
	0x20,
	0x61,
	0x62,
	0x6f,
	0x76,
	0x65,
	0x20,
	0x72,
	0x65,
	0x71,
	0x75,
	0x69,
	0x72,
	0x65,
	0x6d,
	0x65,
	0x6e,
	0x74,
	0x73,
	0x20,
	0x61,
	0x70,
	0x70,
	0x6c,
	0x79,
	0x20,
	0x65,
	0x69,
	0x74,
	0x68,
	0x65,
	0x72,
	0x20,
	0x77,
	0x61,
	0x79,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x38,
	0x2e,
	0x20,
	0x54,
	0x65,
	0x72,
	0x6d,
	0x69,
	0x6e,
	0x61,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x59,
	0x6f,
	0x75,
	0x20,
	0x6d,
	0x61,
	0x79,
	0x20,
	0x6e,
	0x6f,
	0x74,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x70,
	0x61,
	0x67,
	0x61,
	0x74,
	0x65,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x6d,
	0x6f,
	0x64,
	0x69,
	0x66,
	0x79,
	0x20,
	0x61,
	0x20,
	0x63,
	0x6f,
	0x76,
	0x65,
	0x72,
	0x65,
	0x64,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x20,
	0x65,
	0x78,
	0x63,
	0x65,
	0x70,
	0x74,
	0x20,
	0x61,
	0x73,
	0x20,
	0x65,
	0x78,
	0x70,
	0x72,
	0x65,
	0x73,
	0x73,
	0x6c,
	0x79,
	0x0a,
	0x70,
	0x72,
	0x6f,
	0x76,
	0x69,
	0x64,
	0x65,
	0x64,
	0x20,
	0x75,
	0x6e,
	0x64,
	0x65,
	0x72,
	0x20,
	0x74,
	0x68,
	0x69,
	0x73,
	0x20,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x2e,
	0x20,
	0x20,
	0x41,
	0x6e,
	0x79,
	0x20,
	0x61,
	0x74,
	0x74,
	0x65,
	0x6d,
	0x70,
	0x74,
	0x20,
	0x6f,
	0x74,
	0x68,
	0x65,
	0x72,
	0x77,
	0x69,
	0x73,
	0x65,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x70,
	0x61,
	0x67,
	0x61,
	0x74,
	0x65,
	0x20,
	0x6f,
	0x72,
	0x0a,
	0x6d,
	0x6f,
	0x64,
	0x69,
	0x66,
	0x79,
	0x20,
	0x69,
	0x74,
	0x20,
	0x69,
	0x73,
	0x20,
	0x76,
	0x6f,
	0x69,
	0x64,
	0x2c,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x77,
	0x69,
	0x6c,
	0x6c,
	0x20,
	0x61,
	0x75,
	0x74,
	0x6f,
	0x6d,
	0x61,
	0x74,
	0x69,
	0x63,
	0x61,
	0x6c,
	0x6c,
	0x79,
	0x20,
	0x74,
	0x65,
	0x72,
	0x6d,
	0x69,
	0x6e,
	0x61,
	0x74,
	0x65,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x72,
	0x20,
	0x72,
	0x69,
	0x67,
	0x68,
	0x74,
	0x73,
	0x20,
	0x75,
	0x6e,
	0x64,
	0x65,
	0x72,
	0x0a,
	0x74,
	0x68,
	0x69,
	0x73,
	0x20,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x20,
	0x28,
	0x69,
	0x6e,
	0x63,
	0x6c,
	0x75,
	0x64,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x61,
	0x6e,
	0x79,
	0x20,
	0x70,
	0x61,
	0x74,
	0x65,
	0x6e,
	0x74,
	0x20,
	0x6c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x73,
	0x20,
	0x67,
	0x72,
	0x61,
	0x6e,
	0x74,
	0x65,
	0x64,
	0x20,
	0x75,
	0x6e,
	0x64,
	0x65,
	0x72,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x74,
	0x68,
	0x69,
	0x72,
	0x64,
	0x0a,
	0x70,
	0x61,
	0x72,
	0x61,
	0x67,
	0x72,
	0x61,
	0x70,
	0x68,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x73,
	0x65,
	0x63,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x31,
	0x31,
	0x29,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x48,
	0x6f,
	0x77,
	0x65,
	0x76,
	0x65,
	0x72,
	0x2c,
	0x20,
	0x69,
	0x66,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x63,
	0x65,
	0x61,
	0x73,
	0x65,
	0x20,
	0x61,
	0x6c,
	0x6c,
	0x20,
	0x76,
	0x69,
	0x6f,
	0x6c,
	0x61,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x69,
	0x73,
	0x20,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x2c,
	0x20,
	0x74,
	0x68,
	0x65,
	0x6e,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x72,
	0x0a,
	0x6c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x20,
	0x66,
	0x72,
	0x6f,
	0x6d,
	0x20,
	0x61,
	0x20,
	0x70,
	0x61,
	0x72,
	0x74,
	0x69,
	0x63,
	0x75,
	0x6c,
	0x61,
	0x72,
	0x20,
	0x63,
	0x6f,
	0x70,
	0x79,
	0x72,
	0x69,
	0x67,
	0x68,
	0x74,
	0x20,
	0x68,
	0x6f,
	0x6c,
	0x64,
	0x65,
	0x72,
	0x20,
	0x69,
	0x73,
	0x20,
	0x72,
	0x65,
	0x69,
	0x6e,
	0x73,
	0x74,
	0x61,
	0x74,
	0x65,
	0x64,
	0x20,
	0x28,
	0x61,
	0x29,
	0x0a,
	0x70,
	0x72,
	0x6f,
	0x76,
	0x69,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x61,
	0x6c,
	0x6c,
	0x79,
	0x2c,
	0x20,
	0x75,
	0x6e,
	0x6c,
	0x65,
	0x73,
	0x73,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x75,
	0x6e,
	0x74,
	0x69,
	0x6c,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x63,
	0x6f,
	0x70,
	0x79,
	0x72,
	0x69,
	0x67,
	0x68,
	0x74,
	0x20,
	0x68,
	0x6f,
	0x6c,
	0x64,
	0x65,
	0x72,
	0x20,
	0x65,
	0x78,
	0x70,
	0x6c,
	0x69,
	0x63,
	0x69,
	0x74,
	0x6c,
	0x79,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x0a,
	0x66,
	0x69,
	0x6e,
	0x61,
	0x6c,
	0x6c,
	0x79,
	0x20,
	0x74,
	0x65,
	0x72,
	0x6d,
	0x69,
	0x6e,
	0x61,
	0x74,
	0x65,
	0x73,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x72,
	0x20,
	0x6c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x2c,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x28,
	0x62,
	0x29,
	0x20,
	0x70,
	0x65,
	0x72,
	0x6d,
	0x61,
	0x6e,
	0x65,
	0x6e,
	0x74,
	0x6c,
	0x79,
	0x2c,
	0x20,
	0x69,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x63,
	0x6f,
	0x70,
	0x79,
	0x72,
	0x69,
	0x67,
	0x68,
	0x74,
	0x0a,
	0x68,
	0x6f,
	0x6c,
	0x64,
	0x65,
	0x72,
	0x20,
	0x66,
	0x61,
	0x69,
	0x6c,
	0x73,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x6e,
	0x6f,
	0x74,
	0x69,
	0x66,
	0x79,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x76,
	0x69,
	0x6f,
	0x6c,
	0x61,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x62,
	0x79,
	0x20,
	0x73,
	0x6f,
	0x6d,
	0x65,
	0x20,
	0x72,
	0x65,
	0x61,
	0x73,
	0x6f,
	0x6e,
	0x61,
	0x62,
	0x6c,
	0x65,
	0x20,
	0x6d,
	0x65,
	0x61,
	0x6e,
	0x73,
	0x0a,
	0x70,
	0x72,
	0x69,
	0x6f,
	0x72,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x36,
	0x30,
	0x20,
	0x64,
	0x61,
	0x79,
	0x73,
	0x20,
	0x61,
	0x66,
	0x74,
	0x65,
	0x72,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x63,
	0x65,
	0x73,
	0x73,
	0x61,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x4d,
	0x6f,
	0x72,
	0x65,
	0x6f,
	0x76,
	0x65,
	0x72,
	0x2c,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x72,
	0x20,
	0x6c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x20,
	0x66,
	0x72,
	0x6f,
	0x6d,
	0x20,
	0x61,
	0x20,
	0x70,
	0x61,
	0x72,
	0x74,
	0x69,
	0x63,
	0x75,
	0x6c,
	0x61,
	0x72,
	0x20,
	0x63,
	0x6f,
	0x70,
	0x79,
	0x72,
	0x69,
	0x67,
	0x68,
	0x74,
	0x20,
	0x68,
	0x6f,
	0x6c,
	0x64,
	0x65,
	0x72,
	0x20,
	0x69,
	0x73,
	0x0a,
	0x72,
	0x65,
	0x69,
	0x6e,
	0x73,
	0x74,
	0x61,
	0x74,
	0x65,
	0x64,
	0x20,
	0x70,
	0x65,
	0x72,
	0x6d,
	0x61,
	0x6e,
	0x65,
	0x6e,
	0x74,
	0x6c,
	0x79,
	0x20,
	0x69,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x63,
	0x6f,
	0x70,
	0x79,
	0x72,
	0x69,
	0x67,
	0x68,
	0x74,
	0x20,
	0x68,
	0x6f,
	0x6c,
	0x64,
	0x65,
	0x72,
	0x20,
	0x6e,
	0x6f,
	0x74,
	0x69,
	0x66,
	0x69,
	0x65,
	0x73,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x0a,
	0x76,
	0x69,
	0x6f,
	0x6c,
	0x61,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x62,
	0x79,
	0x20,
	0x73,
	0x6f,
	0x6d,
	0x65,
	0x20,
	0x72,
	0x65,
	0x61,
	0x73,
	0x6f,
	0x6e,
	0x61,
	0x62,
	0x6c,
	0x65,
	0x20,
	0x6d,
	0x65,
	0x61,
	0x6e,
	0x73,
	0x2c,
	0x20,
	0x74,
	0x68,
	0x69,
	0x73,
	0x20,
	0x69,
	0x73,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x66,
	0x69,
	0x72,
	0x73,
	0x74,
	0x20,
	0x74,
	0x69,
	0x6d,
	0x65,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x68,
	0x61,
	0x76,
	0x65,
	0x0a,
	0x72,
	0x65,
	0x63,
	0x65,
	0x69,
	0x76,
	0x65,
	0x64,
	0x20,
	0x6e,
	0x6f,
	0x74,
	0x69,
	0x63,
	0x65,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x76,
	0x69,
	0x6f,
	0x6c,
	0x61,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x69,
	0x73,
	0x20,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x20,
	0x28,
	0x66,
	0x6f,
	0x72,
	0x20,
	0x61,
	0x6e,
	0x79,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x29,
	0x20,
	0x66,
	0x72,
	0x6f,
	0x6d,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x0a,
	0x63,
	0x6f,
	0x70,
	0x79,
	0x72,
	0x69,
	0x67,
	0x68,
	0x74,
	0x20,
	0x68,
	0x6f,
	0x6c,
	0x64,
	0x65,
	0x72,
	0x2c,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x63,
	0x75,
	0x72,
	0x65,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x76,
	0x69,
	0x6f,
	0x6c,
	0x61,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x70,
	0x72,
	0x69,
	0x6f,
	0x72,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x33,
	0x30,
	0x20,
	0x64,
	0x61,
	0x79,
	0x73,
	0x20,
	0x61,
	0x66,
	0x74,
	0x65,
	0x72,
	0x0a,
	0x79,
	0x6f,
	0x75,
	0x72,
	0x20,
	0x72,
	0x65,
	0x63,
	0x65,
	0x69,
	0x70,
	0x74,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x6e,
	0x6f,
	0x74,
	0x69,
	0x63,
	0x65,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x54,
	0x65,
	0x72,
	0x6d,
	0x69,
	0x6e,
	0x61,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x72,
	0x20,
	0x72,
	0x69,
	0x67,
	0x68,
	0x74,
	0x73,
	0x20,
	0x75,
	0x6e,
	0x64,
	0x65,
	0x72,
	0x20,
	0x74,
	0x68,
	0x69,
	0x73,
	0x20,
	0x73,
	0x65,
	0x63,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x64,
	0x6f,
	0x65,
	0x73,
	0x20,
	0x6e,
	0x6f,
	0x74,
	0x20,
	0x74,
	0x65,
	0x72,
	0x6d,
	0x69,
	0x6e,
	0x61,
	0x74,
	0x65,
	0x20,
	0x74,
	0x68,
	0x65,
	0x0a,
	0x6c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x73,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x70,
	0x61,
	0x72,
	0x74,
	0x69,
	0x65,
	0x73,
	0x20,
	0x77,
	0x68,
	0x6f,
	0x20,
	0x68,
	0x61,
	0x76,
	0x65,
	0x20,
	0x72,
	0x65,
	0x63,
	0x65,
	0x69,
	0x76,
	0x65,
	0x64,
	0x20,
	0x63,
	0x6f,
	0x70,
	0x69,
	0x65,
	0x73,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x72,
	0x69,
	0x67,
	0x68,
	0x74,
	0x73,
	0x20,
	0x66,
	0x72,
	0x6f,
	0x6d,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x75,
	0x6e,
	0x64,
	0x65,
	0x72,
	0x0a,
	0x74,
	0x68,
	0x69,
	0x73,
	0x20,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x2e,
	0x20,
	0x20,
	0x49,
	0x66,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x72,
	0x20,
	0x72,
	0x69,
	0x67,
	0x68,
	0x74,
	0x73,
	0x20,
	0x68,
	0x61,
	0x76,
	0x65,
	0x20,
	0x62,
	0x65,
	0x65,
	0x6e,
	0x20,
	0x74,
	0x65,
	0x72,
	0x6d,
	0x69,
	0x6e,
	0x61,
	0x74,
	0x65,
	0x64,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x6e,
	0x6f,
	0x74,
	0x20,
	0x70,
	0x65,
	0x72,
	0x6d,
	0x61,
	0x6e,
	0x65,
	0x6e,
	0x74,
	0x6c,
	0x79,
	0x0a,
	0x72,
	0x65,
	0x69,
	0x6e,
	0x73,
	0x74,
	0x61,
	0x74,
	0x65,
	0x64,
	0x2c,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x64,
	0x6f,
	0x20,
	0x6e,
	0x6f,
	0x74,
	0x20,
	0x71,
	0x75,
	0x61,
	0x6c,
	0x69,
	0x66,
	0x79,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x72,
	0x65,
	0x63,
	0x65,
	0x69,
	0x76,
	0x65,
	0x20,
	0x6e,
	0x65,
	0x77,
	0x20,
	0x6c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x73,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x73,
	0x61,
	0x6d,
	0x65,
	0x0a,
	0x6d,
	0x61,
	0x74,
	0x65,
	0x72,
	0x69,
	0x61,
	0x6c,
	0x20,
	0x75,
	0x6e,
	0x64,
	0x65,
	0x72,
	0x20,
	0x73,
	0x65,
	0x63,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x31,
	0x30,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x39,
	0x2e,
	0x20,
	0x41,
	0x63,
	0x63,
	0x65,
	0x70,
	0x74,
	0x61,
	0x6e,
	0x63,
	0x65,
	0x20,
	0x4e,
	0x6f,
	0x74,
	0x20,
	0x52,
	0x65,
	0x71,
	0x75,
	0x69,
	0x72,
	0x65,
	0x64,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x20,
	0x48,
	0x61,
	0x76,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x43,
	0x6f,
	0x70,
	0x69,
	0x65,
	0x73,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x59,
	0x6f,
	0x75,
	0x20,
	0x61,
	0x72,
	0x65,
	0x20,
	0x6e,
	0x6f,
	0x74,
	0x20,
	0x72,
	0x65,
	0x71,
	0x75,
	0x69,
	0x72,
	0x65,
	0x64,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x61,
	0x63,
	0x63,
	0x65,
	0x70,
	0x74,
	0x20,
	0x74,
	0x68,
	0x69,
	0x73,
	0x20,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x20,
	0x69,
	0x6e,
	0x20,
	0x6f,
	0x72,
	0x64,
	0x65,
	0x72,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x72,
	0x65,
	0x63,
	0x65,
	0x69,
	0x76,
	0x65,
	0x20,
	0x6f,
	0x72,
	0x0a,
	0x72,
	0x75,
	0x6e,
	0x20,
	0x61,
	0x20,
	0x63,
	0x6f,
	0x70,
	0x79,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x50,
	0x72,
	0x6f,
	0x67,
	0x72,
	0x61,
	0x6d,
	0x2e,
	0x20,
	0x20,
	0x41,
	0x6e,
	0x63,
	0x69,
	0x6c,
	0x6c,
	0x61,
	0x72,
	0x79,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x70,
	0x61,
	0x67,
	0x61,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x61,
	0x20,
	0x63,
	0x6f,
	0x76,
	0x65,
	0x72,
	0x65,
	0x64,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x0a,
	0x6f,
	0x63,
	0x63,
	0x75,
	0x72,
	0x72,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x73,
	0x6f,
	0x6c,
	0x65,
	0x6c,
	0x79,
	0x20,
	0x61,
	0x73,
	0x20,
	0x61,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x73,
	0x65,
	0x71,
	0x75,
	0x65,
	0x6e,
	0x63,
	0x65,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x75,
	0x73,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x70,
	0x65,
	0x65,
	0x72,
	0x2d,
	0x74,
	0x6f,
	0x2d,
	0x70,
	0x65,
	0x65,
	0x72,
	0x20,
	0x74,
	0x72,
	0x61,
	0x6e,
	0x73,
	0x6d,
	0x69,
	0x73,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x0a,
	0x74,
	0x6f,
	0x20,
	0x72,
	0x65,
	0x63,
	0x65,
	0x69,
	0x76,
	0x65,
	0x20,
	0x61,
	0x20,
	0x63,
	0x6f,
	0x70,
	0x79,
	0x20,
	0x6c,
	0x69,
	0x6b,
	0x65,
	0x77,
	0x69,
	0x73,
	0x65,
	0x20,
	0x64,
	0x6f,
	0x65,
	0x73,
	0x20,
	0x6e,
	0x6f,
	0x74,
	0x20,
	0x72,
	0x65,
	0x71,
	0x75,
	0x69,
	0x72,
	0x65,
	0x20,
	0x61,
	0x63,
	0x63,
	0x65,
	0x70,
	0x74,
	0x61,
	0x6e,
	0x63,
	0x65,
	0x2e,
	0x20,
	0x20,
	0x48,
	0x6f,
	0x77,
	0x65,
	0x76,
	0x65,
	0x72,
	0x2c,
	0x0a,
	0x6e,
	0x6f,
	0x74,
	0x68,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x6f,
	0x74,
	0x68,
	0x65,
	0x72,
	0x20,
	0x74,
	0x68,
	0x61,
	0x6e,
	0x20,
	0x74,
	0x68,
	0x69,
	0x73,
	0x20,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x20,
	0x67,
	0x72,
	0x61,
	0x6e,
	0x74,
	0x73,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x70,
	0x65,
	0x72,
	0x6d,
	0x69,
	0x73,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x70,
	0x61,
	0x67,
	0x61,
	0x74,
	0x65,
	0x20,
	0x6f,
	0x72,
	0x0a,
	0x6d,
	0x6f,
	0x64,
	0x69,
	0x66,
	0x79,
	0x20,
	0x61,
	0x6e,
	0x79,
	0x20,
	0x63,
	0x6f,
	0x76,
	0x65,
	0x72,
	0x65,
	0x64,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x2e,
	0x20,
	0x20,
	0x54,
	0x68,
	0x65,
	0x73,
	0x65,
	0x20,
	0x61,
	0x63,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x73,
	0x20,
	0x69,
	0x6e,
	0x66,
	0x72,
	0x69,
	0x6e,
	0x67,
	0x65,
	0x20,
	0x63,
	0x6f,
	0x70,
	0x79,
	0x72,
	0x69,
	0x67,
	0x68,
	0x74,
	0x20,
	0x69,
	0x66,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x64,
	0x6f,
	0x0a,
	0x6e,
	0x6f,
	0x74,
	0x20,
	0x61,
	0x63,
	0x63,
	0x65,
	0x70,
	0x74,
	0x20,
	0x74,
	0x68,
	0x69,
	0x73,
	0x20,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x2e,
	0x20,
	0x20,
	0x54,
	0x68,
	0x65,
	0x72,
	0x65,
	0x66,
	0x6f,
	0x72,
	0x65,
	0x2c,
	0x20,
	0x62,
	0x79,
	0x20,
	0x6d,
	0x6f,
	0x64,
	0x69,
	0x66,
	0x79,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x70,
	0x61,
	0x67,
	0x61,
	0x74,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x61,
	0x0a,
	0x63,
	0x6f,
	0x76,
	0x65,
	0x72,
	0x65,
	0x64,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x2c,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x69,
	0x6e,
	0x64,
	0x69,
	0x63,
	0x61,
	0x74,
	0x65,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x72,
	0x20,
	0x61,
	0x63,
	0x63,
	0x65,
	0x70,
	0x74,
	0x61,
	0x6e,
	0x63,
	0x65,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x69,
	0x73,
	0x20,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x64,
	0x6f,
	0x20,
	0x73,
	0x6f,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x31,
	0x30,
	0x2e,
	0x20,
	0x41,
	0x75,
	0x74,
	0x6f,
	0x6d,
	0x61,
	0x74,
	0x69,
	0x63,
	0x20,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x44,
	0x6f,
	0x77,
	0x6e,
	0x73,
	0x74,
	0x72,
	0x65,
	0x61,
	0x6d,
	0x20,
	0x52,
	0x65,
	0x63,
	0x69,
	0x70,
	0x69,
	0x65,
	0x6e,
	0x74,
	0x73,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x45,
	0x61,
	0x63,
	0x68,
	0x20,
	0x74,
	0x69,
	0x6d,
	0x65,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x76,
	0x65,
	0x79,
	0x20,
	0x61,
	0x20,
	0x63,
	0x6f,
	0x76,
	0x65,
	0x72,
	0x65,
	0x64,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x2c,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x72,
	0x65,
	0x63,
	0x69,
	0x70,
	0x69,
	0x65,
	0x6e,
	0x74,
	0x20,
	0x61,
	0x75,
	0x74,
	0x6f,
	0x6d,
	0x61,
	0x74,
	0x69,
	0x63,
	0x61,
	0x6c,
	0x6c,
	0x79,
	0x0a,
	0x72,
	0x65,
	0x63,
	0x65,
	0x69,
	0x76,
	0x65,
	0x73,
	0x20,
	0x61,
	0x20,
	0x6c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x20,
	0x66,
	0x72,
	0x6f,
	0x6d,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x6f,
	0x72,
	0x69,
	0x67,
	0x69,
	0x6e,
	0x61,
	0x6c,
	0x20,
	0x6c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x6f,
	0x72,
	0x73,
	0x2c,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x72,
	0x75,
	0x6e,
	0x2c,
	0x20,
	0x6d,
	0x6f,
	0x64,
	0x69,
	0x66,
	0x79,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x0a,
	0x70,
	0x72,
	0x6f,
	0x70,
	0x61,
	0x67,
	0x61,
	0x74,
	0x65,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x2c,
	0x20,
	0x73,
	0x75,
	0x62,
	0x6a,
	0x65,
	0x63,
	0x74,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x74,
	0x68,
	0x69,
	0x73,
	0x20,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x2e,
	0x20,
	0x20,
	0x59,
	0x6f,
	0x75,
	0x20,
	0x61,
	0x72,
	0x65,
	0x20,
	0x6e,
	0x6f,
	0x74,
	0x20,
	0x72,
	0x65,
	0x73,
	0x70,
	0x6f,
	0x6e,
	0x73,
	0x69,
	0x62,
	0x6c,
	0x65,
	0x0a,
	0x66,
	0x6f,
	0x72,
	0x20,
	0x65,
	0x6e,
	0x66,
	0x6f,
	0x72,
	0x63,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x63,
	0x6f,
	0x6d,
	0x70,
	0x6c,
	0x69,
	0x61,
	0x6e,
	0x63,
	0x65,
	0x20,
	0x62,
	0x79,
	0x20,
	0x74,
	0x68,
	0x69,
	0x72,
	0x64,
	0x20,
	0x70,
	0x61,
	0x72,
	0x74,
	0x69,
	0x65,
	0x73,
	0x20,
	0x77,
	0x69,
	0x74,
	0x68,
	0x20,
	0x74,
	0x68,
	0x69,
	0x73,
	0x20,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x41,
	0x6e,
	0x20,
	0x22,
	0x65,
	0x6e,
	0x74,
	0x69,
	0x74,
	0x79,
	0x20,
	0x74,
	0x72,
	0x61,
	0x6e,
	0x73,
	0x61,
	0x63,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x22,
	0x20,
	0x69,
	0x73,
	0x20,
	0x61,
	0x20,
	0x74,
	0x72,
	0x61,
	0x6e,
	0x73,
	0x61,
	0x63,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x74,
	0x72,
	0x61,
	0x6e,
	0x73,
	0x66,
	0x65,
	0x72,
	0x72,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x74,
	0x72,
	0x6f,
	0x6c,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x61,
	0x6e,
	0x0a,
	0x6f,
	0x72,
	0x67,
	0x61,
	0x6e,
	0x69,
	0x7a,
	0x61,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x2c,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x73,
	0x75,
	0x62,
	0x73,
	0x74,
	0x61,
	0x6e,
	0x74,
	0x69,
	0x61,
	0x6c,
	0x6c,
	0x79,
	0x20,
	0x61,
	0x6c,
	0x6c,
	0x20,
	0x61,
	0x73,
	0x73,
	0x65,
	0x74,
	0x73,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x6f,
	0x6e,
	0x65,
	0x2c,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x73,
	0x75,
	0x62,
	0x64,
	0x69,
	0x76,
	0x69,
	0x64,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x61,
	0x6e,
	0x0a,
	0x6f,
	0x72,
	0x67,
	0x61,
	0x6e,
	0x69,
	0x7a,
	0x61,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x2c,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x6d,
	0x65,
	0x72,
	0x67,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x6f,
	0x72,
	0x67,
	0x61,
	0x6e,
	0x69,
	0x7a,
	0x61,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x73,
	0x2e,
	0x20,
	0x20,
	0x49,
	0x66,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x70,
	0x61,
	0x67,
	0x61,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x61,
	0x20,
	0x63,
	0x6f,
	0x76,
	0x65,
	0x72,
	0x65,
	0x64,
	0x0a,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x20,
	0x72,
	0x65,
	0x73,
	0x75,
	0x6c,
	0x74,
	0x73,
	0x20,
	0x66,
	0x72,
	0x6f,
	0x6d,
	0x20,
	0x61,
	0x6e,
	0x20,
	0x65,
	0x6e,
	0x74,
	0x69,
	0x74,
	0x79,
	0x20,
	0x74,
	0x72,
	0x61,
	0x6e,
	0x73,
	0x61,
	0x63,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x2c,
	0x20,
	0x65,
	0x61,
	0x63,
	0x68,
	0x20,
	0x70,
	0x61,
	0x72,
	0x74,
	0x79,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x0a,
	0x74,
	0x72,
	0x61,
	0x6e,
	0x73,
	0x61,
	0x63,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x77,
	0x68,
	0x6f,
	0x20,
	0x72,
	0x65,
	0x63,
	0x65,
	0x69,
	0x76,
	0x65,
	0x73,
	0x20,
	0x61,
	0x20,
	0x63,
	0x6f,
	0x70,
	0x79,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x20,
	0x61,
	0x6c,
	0x73,
	0x6f,
	0x20,
	0x72,
	0x65,
	0x63,
	0x65,
	0x69,
	0x76,
	0x65,
	0x73,
	0x20,
	0x77,
	0x68,
	0x61,
	0x74,
	0x65,
	0x76,
	0x65,
	0x72,
	0x0a,
	0x6c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x73,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x70,
	0x61,
	0x72,
	0x74,
	0x79,
	0x27,
	0x73,
	0x20,
	0x70,
	0x72,
	0x65,
	0x64,
	0x65,
	0x63,
	0x65,
	0x73,
	0x73,
	0x6f,
	0x72,
	0x20,
	0x69,
	0x6e,
	0x20,
	0x69,
	0x6e,
	0x74,
	0x65,
	0x72,
	0x65,
	0x73,
	0x74,
	0x20,
	0x68,
	0x61,
	0x64,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x63,
	0x6f,
	0x75,
	0x6c,
	0x64,
	0x0a,
	0x67,
	0x69,
	0x76,
	0x65,
	0x20,
	0x75,
	0x6e,
	0x64,
	0x65,
	0x72,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x70,
	0x72,
	0x65,
	0x76,
	0x69,
	0x6f,
	0x75,
	0x73,
	0x20,
	0x70,
	0x61,
	0x72,
	0x61,
	0x67,
	0x72,
	0x61,
	0x70,
	0x68,
	0x2c,
	0x20,
	0x70,
	0x6c,
	0x75,
	0x73,
	0x20,
	0x61,
	0x20,
	0x72,
	0x69,
	0x67,
	0x68,
	0x74,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x70,
	0x6f,
	0x73,
	0x73,
	0x65,
	0x73,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x0a,
	0x43,
	0x6f,
	0x72,
	0x72,
	0x65,
	0x73,
	0x70,
	0x6f,
	0x6e,
	0x64,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x53,
	0x6f,
	0x75,
	0x72,
	0x63,
	0x65,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x20,
	0x66,
	0x72,
	0x6f,
	0x6d,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x70,
	0x72,
	0x65,
	0x64,
	0x65,
	0x63,
	0x65,
	0x73,
	0x73,
	0x6f,
	0x72,
	0x20,
	0x69,
	0x6e,
	0x20,
	0x69,
	0x6e,
	0x74,
	0x65,
	0x72,
	0x65,
	0x73,
	0x74,
	0x2c,
	0x20,
	0x69,
	0x66,
	0x0a,
	0x74,
	0x68,
	0x65,
	0x20,
	0x70,
	0x72,
	0x65,
	0x64,
	0x65,
	0x63,
	0x65,
	0x73,
	0x73,
	0x6f,
	0x72,
	0x20,
	0x68,
	0x61,
	0x73,
	0x20,
	0x69,
	0x74,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x63,
	0x61,
	0x6e,
	0x20,
	0x67,
	0x65,
	0x74,
	0x20,
	0x69,
	0x74,
	0x20,
	0x77,
	0x69,
	0x74,
	0x68,
	0x20,
	0x72,
	0x65,
	0x61,
	0x73,
	0x6f,
	0x6e,
	0x61,
	0x62,
	0x6c,
	0x65,
	0x20,
	0x65,
	0x66,
	0x66,
	0x6f,
	0x72,
	0x74,
	0x73,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x59,
	0x6f,
	0x75,
	0x20,
	0x6d,
	0x61,
	0x79,
	0x20,
	0x6e,
	0x6f,
	0x74,
	0x20,
	0x69,
	0x6d,
	0x70,
	0x6f,
	0x73,
	0x65,
	0x20,
	0x61,
	0x6e,
	0x79,
	0x20,
	0x66,
	0x75,
	0x72,
	0x74,
	0x68,
	0x65,
	0x72,
	0x20,
	0x72,
	0x65,
	0x73,
	0x74,
	0x72,
	0x69,
	0x63,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x73,
	0x20,
	0x6f,
	0x6e,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x65,
	0x78,
	0x65,
	0x72,
	0x63,
	0x69,
	0x73,
	0x65,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x0a,
	0x72,
	0x69,
	0x67,
	0x68,
	0x74,
	0x73,
	0x20,
	0x67,
	0x72,
	0x61,
	0x6e,
	0x74,
	0x65,
	0x64,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x61,
	0x66,
	0x66,
	0x69,
	0x72,
	0x6d,
	0x65,
	0x64,
	0x20,
	0x75,
	0x6e,
	0x64,
	0x65,
	0x72,
	0x20,
	0x74,
	0x68,
	0x69,
	0x73,
	0x20,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x2e,
	0x20,
	0x20,
	0x46,
	0x6f,
	0x72,
	0x20,
	0x65,
	0x78,
	0x61,
	0x6d,
	0x70,
	0x6c,
	0x65,
	0x2c,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x6d,
	0x61,
	0x79,
	0x0a,
	0x6e,
	0x6f,
	0x74,
	0x20,
	0x69,
	0x6d,
	0x70,
	0x6f,
	0x73,
	0x65,
	0x20,
	0x61,
	0x20,
	0x6c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x20,
	0x66,
	0x65,
	0x65,
	0x2c,
	0x20,
	0x72,
	0x6f,
	0x79,
	0x61,
	0x6c,
	0x74,
	0x79,
	0x2c,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x6f,
	0x74,
	0x68,
	0x65,
	0x72,
	0x20,
	0x63,
	0x68,
	0x61,
	0x72,
	0x67,
	0x65,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x20,
	0x65,
	0x78,
	0x65,
	0x72,
	0x63,
	0x69,
	0x73,
	0x65,
	0x20,
	0x6f,
	0x66,
	0x0a,
	0x72,
	0x69,
	0x67,
	0x68,
	0x74,
	0x73,
	0x20,
	0x67,
	0x72,
	0x61,
	0x6e,
	0x74,
	0x65,
	0x64,
	0x20,
	0x75,
	0x6e,
	0x64,
	0x65,
	0x72,
	0x20,
	0x74,
	0x68,
	0x69,
	0x73,
	0x20,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x2c,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x6d,
	0x61,
	0x79,
	0x20,
	0x6e,
	0x6f,
	0x74,
	0x20,
	0x69,
	0x6e,
	0x69,
	0x74,
	0x69,
	0x61,
	0x74,
	0x65,
	0x20,
	0x6c,
	0x69,
	0x74,
	0x69,
	0x67,
	0x61,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x0a,
	0x28,
	0x69,
	0x6e,
	0x63,
	0x6c,
	0x75,
	0x64,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x61,
	0x20,
	0x63,
	0x72,
	0x6f,
	0x73,
	0x73,
	0x2d,
	0x63,
	0x6c,
	0x61,
	0x69,
	0x6d,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x63,
	0x6f,
	0x75,
	0x6e,
	0x74,
	0x65,
	0x72,
	0x63,
	0x6c,
	0x61,
	0x69,
	0x6d,
	0x20,
	0x69,
	0x6e,
	0x20,
	0x61,
	0x20,
	0x6c,
	0x61,
	0x77,
	0x73,
	0x75,
	0x69,
	0x74,
	0x29,
	0x20,
	0x61,
	0x6c,
	0x6c,
	0x65,
	0x67,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x0a,
	0x61,
	0x6e,
	0x79,
	0x20,
	0x70,
	0x61,
	0x74,
	0x65,
	0x6e,
	0x74,
	0x20,
	0x63,
	0x6c,
	0x61,
	0x69,
	0x6d,
	0x20,
	0x69,
	0x73,
	0x20,
	0x69,
	0x6e,
	0x66,
	0x72,
	0x69,
	0x6e,
	0x67,
	0x65,
	0x64,
	0x20,
	0x62,
	0x79,
	0x20,
	0x6d,
	0x61,
	0x6b,
	0x69,
	0x6e,
	0x67,
	0x2c,
	0x20,
	0x75,
	0x73,
	0x69,
	0x6e,
	0x67,
	0x2c,
	0x20,
	0x73,
	0x65,
	0x6c,
	0x6c,
	0x69,
	0x6e,
	0x67,
	0x2c,
	0x20,
	0x6f,
	0x66,
	0x66,
	0x65,
	0x72,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x0a,
	0x73,
	0x61,
	0x6c,
	0x65,
	0x2c,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x69,
	0x6d,
	0x70,
	0x6f,
	0x72,
	0x74,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x50,
	0x72,
	0x6f,
	0x67,
	0x72,
	0x61,
	0x6d,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x61,
	0x6e,
	0x79,
	0x20,
	0x70,
	0x6f,
	0x72,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x69,
	0x74,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x31,
	0x31,
	0x2e,
	0x20,
	0x50,
	0x61,
	0x74,
	0x65,
	0x6e,
	0x74,
	0x73,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x41,
	0x20,
	0x22,
	0x63,
	0x6f,
	0x6e,
	0x74,
	0x72,
	0x69,
	0x62,
	0x75,
	0x74,
	0x6f,
	0x72,
	0x22,
	0x20,
	0x69,
	0x73,
	0x20,
	0x61,
	0x20,
	0x63,
	0x6f,
	0x70,
	0x79,
	0x72,
	0x69,
	0x67,
	0x68,
	0x74,
	0x20,
	0x68,
	0x6f,
	0x6c,
	0x64,
	0x65,
	0x72,
	0x20,
	0x77,
	0x68,
	0x6f,
	0x20,
	0x61,
	0x75,
	0x74,
	0x68,
	0x6f,
	0x72,
	0x69,
	0x7a,
	0x65,
	0x73,
	0x20,
	0x75,
	0x73,
	0x65,
	0x20,
	0x75,
	0x6e,
	0x64,
	0x65,
	0x72,
	0x20,
	0x74,
	0x68,
	0x69,
	0x73,
	0x0a,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x50,
	0x72,
	0x6f,
	0x67,
	0x72,
	0x61,
	0x6d,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x61,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x20,
	0x6f,
	0x6e,
	0x20,
	0x77,
	0x68,
	0x69,
	0x63,
	0x68,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x50,
	0x72,
	0x6f,
	0x67,
	0x72,
	0x61,
	0x6d,
	0x20,
	0x69,
	0x73,
	0x20,
	0x62,
	0x61,
	0x73,
	0x65,
	0x64,
	0x2e,
	0x20,
	0x20,
	0x54,
	0x68,
	0x65,
	0x0a,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x20,
	0x74,
	0x68,
	0x75,
	0x73,
	0x20,
	0x6c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x64,
	0x20,
	0x69,
	0x73,
	0x20,
	0x63,
	0x61,
	0x6c,
	0x6c,
	0x65,
	0x64,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x74,
	0x72,
	0x69,
	0x62,
	0x75,
	0x74,
	0x6f,
	0x72,
	0x27,
	0x73,
	0x20,
	0x22,
	0x63,
	0x6f,
	0x6e,
	0x74,
	0x72,
	0x69,
	0x62,
	0x75,
	0x74,
	0x6f,
	0x72,
	0x20,
	0x76,
	0x65,
	0x72,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x22,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x41,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x74,
	0x72,
	0x69,
	0x62,
	0x75,
	0x74,
	0x6f,
	0x72,
	0x27,
	0x73,
	0x20,
	0x22,
	0x65,
	0x73,
	0x73,
	0x65,
	0x6e,
	0x74,
	0x69,
	0x61,
	0x6c,
	0x20,
	0x70,
	0x61,
	0x74,
	0x65,
	0x6e,
	0x74,
	0x20,
	0x63,
	0x6c,
	0x61,
	0x69,
	0x6d,
	0x73,
	0x22,
	0x20,
	0x61,
	0x72,
	0x65,
	0x20,
	0x61,
	0x6c,
	0x6c,
	0x20,
	0x70,
	0x61,
	0x74,
	0x65,
	0x6e,
	0x74,
	0x20,
	0x63,
	0x6c,
	0x61,
	0x69,
	0x6d,
	0x73,
	0x0a,
	0x6f,
	0x77,
	0x6e,
	0x65,
	0x64,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x74,
	0x72,
	0x6f,
	0x6c,
	0x6c,
	0x65,
	0x64,
	0x20,
	0x62,
	0x79,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x74,
	0x72,
	0x69,
	0x62,
	0x75,
	0x74,
	0x6f,
	0x72,
	0x2c,
	0x20,
	0x77,
	0x68,
	0x65,
	0x74,
	0x68,
	0x65,
	0x72,
	0x20,
	0x61,
	0x6c,
	0x72,
	0x65,
	0x61,
	0x64,
	0x79,
	0x20,
	0x61,
	0x63,
	0x71,
	0x75,
	0x69,
	0x72,
	0x65,
	0x64,
	0x20,
	0x6f,
	0x72,
	0x0a,
	0x68,
	0x65,
	0x72,
	0x65,
	0x61,
	0x66,
	0x74,
	0x65,
	0x72,
	0x20,
	0x61,
	0x63,
	0x71,
	0x75,
	0x69,
	0x72,
	0x65,
	0x64,
	0x2c,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x77,
	0x6f,
	0x75,
	0x6c,
	0x64,
	0x20,
	0x62,
	0x65,
	0x20,
	0x69,
	0x6e,
	0x66,
	0x72,
	0x69,
	0x6e,
	0x67,
	0x65,
	0x64,
	0x20,
	0x62,
	0x79,
	0x20,
	0x73,
	0x6f,
	0x6d,
	0x65,
	0x20,
	0x6d,
	0x61,
	0x6e,
	0x6e,
	0x65,
	0x72,
	0x2c,
	0x20,
	0x70,
	0x65,
	0x72,
	0x6d,
	0x69,
	0x74,
	0x74,
	0x65,
	0x64,
	0x0a,
	0x62,
	0x79,
	0x20,
	0x74,
	0x68,
	0x69,
	0x73,
	0x20,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x2c,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x6d,
	0x61,
	0x6b,
	0x69,
	0x6e,
	0x67,
	0x2c,
	0x20,
	0x75,
	0x73,
	0x69,
	0x6e,
	0x67,
	0x2c,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x73,
	0x65,
	0x6c,
	0x6c,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x69,
	0x74,
	0x73,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x74,
	0x72,
	0x69,
	0x62,
	0x75,
	0x74,
	0x6f,
	0x72,
	0x20,
	0x76,
	0x65,
	0x72,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x2c,
	0x0a,
	0x62,
	0x75,
	0x74,
	0x20,
	0x64,
	0x6f,
	0x20,
	0x6e,
	0x6f,
	0x74,
	0x20,
	0x69,
	0x6e,
	0x63,
	0x6c,
	0x75,
	0x64,
	0x65,
	0x20,
	0x63,
	0x6c,
	0x61,
	0x69,
	0x6d,
	0x73,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x77,
	0x6f,
	0x75,
	0x6c,
	0x64,
	0x20,
	0x62,
	0x65,
	0x20,
	0x69,
	0x6e,
	0x66,
	0x72,
	0x69,
	0x6e,
	0x67,
	0x65,
	0x64,
	0x20,
	0x6f,
	0x6e,
	0x6c,
	0x79,
	0x20,
	0x61,
	0x73,
	0x20,
	0x61,
	0x0a,
	0x63,
	0x6f,
	0x6e,
	0x73,
	0x65,
	0x71,
	0x75,
	0x65,
	0x6e,
	0x63,
	0x65,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x66,
	0x75,
	0x72,
	0x74,
	0x68,
	0x65,
	0x72,
	0x20,
	0x6d,
	0x6f,
	0x64,
	0x69,
	0x66,
	0x69,
	0x63,
	0x61,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x74,
	0x72,
	0x69,
	0x62,
	0x75,
	0x74,
	0x6f,
	0x72,
	0x20,
	0x76,
	0x65,
	0x72,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x2e,
	0x20,
	0x20,
	0x46,
	0x6f,
	0x72,
	0x0a,
	0x70,
	0x75,
	0x72,
	0x70,
	0x6f,
	0x73,
	0x65,
	0x73,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x69,
	0x73,
	0x20,
	0x64,
	0x65,
	0x66,
	0x69,
	0x6e,
	0x69,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x2c,
	0x20,
	0x22,
	0x63,
	0x6f,
	0x6e,
	0x74,
	0x72,
	0x6f,
	0x6c,
	0x22,
	0x20,
	0x69,
	0x6e,
	0x63,
	0x6c,
	0x75,
	0x64,
	0x65,
	0x73,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x72,
	0x69,
	0x67,
	0x68,
	0x74,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x67,
	0x72,
	0x61,
	0x6e,
	0x74,
	0x0a,
	0x70,
	0x61,
	0x74,
	0x65,
	0x6e,
	0x74,
	0x20,
	0x73,
	0x75,
	0x62,
	0x6c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x73,
	0x20,
	0x69,
	0x6e,
	0x20,
	0x61,
	0x20,
	0x6d,
	0x61,
	0x6e,
	0x6e,
	0x65,
	0x72,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x73,
	0x69,
	0x73,
	0x74,
	0x65,
	0x6e,
	0x74,
	0x20,
	0x77,
	0x69,
	0x74,
	0x68,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x72,
	0x65,
	0x71,
	0x75,
	0x69,
	0x72,
	0x65,
	0x6d,
	0x65,
	0x6e,
	0x74,
	0x73,
	0x20,
	0x6f,
	0x66,
	0x0a,
	0x74,
	0x68,
	0x69,
	0x73,
	0x20,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x45,
	0x61,
	0x63,
	0x68,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x74,
	0x72,
	0x69,
	0x62,
	0x75,
	0x74,
	0x6f,
	0x72,
	0x20,
	0x67,
	0x72,
	0x61,
	0x6e,
	0x74,
	0x73,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x61,
	0x20,
	0x6e,
	0x6f,
	0x6e,
	0x2d,
	0x65,
	0x78,
	0x63,
	0x6c,
	0x75,
	0x73,
	0x69,
	0x76,
	0x65,
	0x2c,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6c,
	0x64,
	0x77,
	0x69,
	0x64,
	0x65,
	0x2c,
	0x20,
	0x72,
	0x6f,
	0x79,
	0x61,
	0x6c,
	0x74,
	0x79,
	0x2d,
	0x66,
	0x72,
	0x65,
	0x65,
	0x0a,
	0x70,
	0x61,
	0x74,
	0x65,
	0x6e,
	0x74,
	0x20,
	0x6c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x20,
	0x75,
	0x6e,
	0x64,
	0x65,
	0x72,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x74,
	0x72,
	0x69,
	0x62,
	0x75,
	0x74,
	0x6f,
	0x72,
	0x27,
	0x73,
	0x20,
	0x65,
	0x73,
	0x73,
	0x65,
	0x6e,
	0x74,
	0x69,
	0x61,
	0x6c,
	0x20,
	0x70,
	0x61,
	0x74,
	0x65,
	0x6e,
	0x74,
	0x20,
	0x63,
	0x6c,
	0x61,
	0x69,
	0x6d,
	0x73,
	0x2c,
	0x20,
	0x74,
	0x6f,
	0x0a,
	0x6d,
	0x61,
	0x6b,
	0x65,
	0x2c,
	0x20,
	0x75,
	0x73,
	0x65,
	0x2c,
	0x20,
	0x73,
	0x65,
	0x6c,
	0x6c,
	0x2c,
	0x20,
	0x6f,
	0x66,
	0x66,
	0x65,
	0x72,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x20,
	0x73,
	0x61,
	0x6c,
	0x65,
	0x2c,
	0x20,
	0x69,
	0x6d,
	0x70,
	0x6f,
	0x72,
	0x74,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x6f,
	0x74,
	0x68,
	0x65,
	0x72,
	0x77,
	0x69,
	0x73,
	0x65,
	0x20,
	0x72,
	0x75,
	0x6e,
	0x2c,
	0x20,
	0x6d,
	0x6f,
	0x64,
	0x69,
	0x66,
	0x79,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x0a,
	0x70,
	0x72,
	0x6f,
	0x70,
	0x61,
	0x67,
	0x61,
	0x74,
	0x65,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x74,
	0x65,
	0x6e,
	0x74,
	0x73,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x69,
	0x74,
	0x73,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x74,
	0x72,
	0x69,
	0x62,
	0x75,
	0x74,
	0x6f,
	0x72,
	0x20,
	0x76,
	0x65,
	0x72,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x49,
	0x6e,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x66,
	0x6f,
	0x6c,
	0x6c,
	0x6f,
	0x77,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x74,
	0x68,
	0x72,
	0x65,
	0x65,
	0x20,
	0x70,
	0x61,
	0x72,
	0x61,
	0x67,
	0x72,
	0x61,
	0x70,
	0x68,
	0x73,
	0x2c,
	0x20,
	0x61,
	0x20,
	0x22,
	0x70,
	0x61,
	0x74,
	0x65,
	0x6e,
	0x74,
	0x20,
	0x6c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x22,
	0x20,
	0x69,
	0x73,
	0x20,
	0x61,
	0x6e,
	0x79,
	0x20,
	0x65,
	0x78,
	0x70,
	0x72,
	0x65,
	0x73,
	0x73,
	0x0a,
	0x61,
	0x67,
	0x72,
	0x65,
	0x65,
	0x6d,
	0x65,
	0x6e,
	0x74,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x63,
	0x6f,
	0x6d,
	0x6d,
	0x69,
	0x74,
	0x6d,
	0x65,
	0x6e,
	0x74,
	0x2c,
	0x20,
	0x68,
	0x6f,
	0x77,
	0x65,
	0x76,
	0x65,
	0x72,
	0x20,
	0x64,
	0x65,
	0x6e,
	0x6f,
	0x6d,
	0x69,
	0x6e,
	0x61,
	0x74,
	0x65,
	0x64,
	0x2c,
	0x20,
	0x6e,
	0x6f,
	0x74,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x65,
	0x6e,
	0x66,
	0x6f,
	0x72,
	0x63,
	0x65,
	0x20,
	0x61,
	0x20,
	0x70,
	0x61,
	0x74,
	0x65,
	0x6e,
	0x74,
	0x0a,
	0x28,
	0x73,
	0x75,
	0x63,
	0x68,
	0x20,
	0x61,
	0x73,
	0x20,
	0x61,
	0x6e,
	0x20,
	0x65,
	0x78,
	0x70,
	0x72,
	0x65,
	0x73,
	0x73,
	0x20,
	0x70,
	0x65,
	0x72,
	0x6d,
	0x69,
	0x73,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x70,
	0x72,
	0x61,
	0x63,
	0x74,
	0x69,
	0x63,
	0x65,
	0x20,
	0x61,
	0x20,
	0x70,
	0x61,
	0x74,
	0x65,
	0x6e,
	0x74,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x63,
	0x6f,
	0x76,
	0x65,
	0x6e,
	0x61,
	0x6e,
	0x74,
	0x20,
	0x6e,
	0x6f,
	0x74,
	0x20,
	0x74,
	0x6f,
	0x0a,
	0x73,
	0x75,
	0x65,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x20,
	0x70,
	0x61,
	0x74,
	0x65,
	0x6e,
	0x74,
	0x20,
	0x69,
	0x6e,
	0x66,
	0x72,
	0x69,
	0x6e,
	0x67,
	0x65,
	0x6d,
	0x65,
	0x6e,
	0x74,
	0x29,
	0x2e,
	0x20,
	0x20,
	0x54,
	0x6f,
	0x20,
	0x22,
	0x67,
	0x72,
	0x61,
	0x6e,
	0x74,
	0x22,
	0x20,
	0x73,
	0x75,
	0x63,
	0x68,
	0x20,
	0x61,
	0x20,
	0x70,
	0x61,
	0x74,
	0x65,
	0x6e,
	0x74,
	0x20,
	0x6c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x61,
	0x0a,
	0x70,
	0x61,
	0x72,
	0x74,
	0x79,
	0x20,
	0x6d,
	0x65,
	0x61,
	0x6e,
	0x73,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x6d,
	0x61,
	0x6b,
	0x65,
	0x20,
	0x73,
	0x75,
	0x63,
	0x68,
	0x20,
	0x61,
	0x6e,
	0x20,
	0x61,
	0x67,
	0x72,
	0x65,
	0x65,
	0x6d,
	0x65,
	0x6e,
	0x74,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x63,
	0x6f,
	0x6d,
	0x6d,
	0x69,
	0x74,
	0x6d,
	0x65,
	0x6e,
	0x74,
	0x20,
	0x6e,
	0x6f,
	0x74,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x65,
	0x6e,
	0x66,
	0x6f,
	0x72,
	0x63,
	0x65,
	0x20,
	0x61,
	0x0a,
	0x70,
	0x61,
	0x74,
	0x65,
	0x6e,
	0x74,
	0x20,
	0x61,
	0x67,
	0x61,
	0x69,
	0x6e,
	0x73,
	0x74,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x70,
	0x61,
	0x72,
	0x74,
	0x79,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x49,
	0x66,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x76,
	0x65,
	0x79,
	0x20,
	0x61,
	0x20,
	0x63,
	0x6f,
	0x76,
	0x65,
	0x72,
	0x65,
	0x64,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x2c,
	0x20,
	0x6b,
	0x6e,
	0x6f,
	0x77,
	0x69,
	0x6e,
	0x67,
	0x6c,
	0x79,
	0x20,
	0x72,
	0x65,
	0x6c,
	0x79,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x6f,
	0x6e,
	0x20,
	0x61,
	0x20,
	0x70,
	0x61,
	0x74,
	0x65,
	0x6e,
	0x74,
	0x20,
	0x6c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x2c,
	0x0a,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x43,
	0x6f,
	0x72,
	0x72,
	0x65,
	0x73,
	0x70,
	0x6f,
	0x6e,
	0x64,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x53,
	0x6f,
	0x75,
	0x72,
	0x63,
	0x65,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x20,
	0x69,
	0x73,
	0x20,
	0x6e,
	0x6f,
	0x74,
	0x20,
	0x61,
	0x76,
	0x61,
	0x69,
	0x6c,
	0x61,
	0x62,
	0x6c,
	0x65,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x20,
	0x61,
	0x6e,
	0x79,
	0x6f,
	0x6e,
	0x65,
	0x0a,
	0x74,
	0x6f,
	0x20,
	0x63,
	0x6f,
	0x70,
	0x79,
	0x2c,
	0x20,
	0x66,
	0x72,
	0x65,
	0x65,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x63,
	0x68,
	0x61,
	0x72,
	0x67,
	0x65,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x75,
	0x6e,
	0x64,
	0x65,
	0x72,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x74,
	0x65,
	0x72,
	0x6d,
	0x73,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x69,
	0x73,
	0x20,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x2c,
	0x20,
	0x74,
	0x68,
	0x72,
	0x6f,
	0x75,
	0x67,
	0x68,
	0x20,
	0x61,
	0x0a,
	0x70,
	0x75,
	0x62,
	0x6c,
	0x69,
	0x63,
	0x6c,
	0x79,
	0x20,
	0x61,
	0x76,
	0x61,
	0x69,
	0x6c,
	0x61,
	0x62,
	0x6c,
	0x65,
	0x20,
	0x6e,
	0x65,
	0x74,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x20,
	0x73,
	0x65,
	0x72,
	0x76,
	0x65,
	0x72,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x6f,
	0x74,
	0x68,
	0x65,
	0x72,
	0x20,
	0x72,
	0x65,
	0x61,
	0x64,
	0x69,
	0x6c,
	0x79,
	0x20,
	0x61,
	0x63,
	0x63,
	0x65,
	0x73,
	0x73,
	0x69,
	0x62,
	0x6c,
	0x65,
	0x20,
	0x6d,
	0x65,
	0x61,
	0x6e,
	0x73,
	0x2c,
	0x0a,
	0x74,
	0x68,
	0x65,
	0x6e,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x6d,
	0x75,
	0x73,
	0x74,
	0x20,
	0x65,
	0x69,
	0x74,
	0x68,
	0x65,
	0x72,
	0x20,
	0x28,
	0x31,
	0x29,
	0x20,
	0x63,
	0x61,
	0x75,
	0x73,
	0x65,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x43,
	0x6f,
	0x72,
	0x72,
	0x65,
	0x73,
	0x70,
	0x6f,
	0x6e,
	0x64,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x53,
	0x6f,
	0x75,
	0x72,
	0x63,
	0x65,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x62,
	0x65,
	0x20,
	0x73,
	0x6f,
	0x0a,
	0x61,
	0x76,
	0x61,
	0x69,
	0x6c,
	0x61,
	0x62,
	0x6c,
	0x65,
	0x2c,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x28,
	0x32,
	0x29,
	0x20,
	0x61,
	0x72,
	0x72,
	0x61,
	0x6e,
	0x67,
	0x65,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x64,
	0x65,
	0x70,
	0x72,
	0x69,
	0x76,
	0x65,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x72,
	0x73,
	0x65,
	0x6c,
	0x66,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x62,
	0x65,
	0x6e,
	0x65,
	0x66,
	0x69,
	0x74,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x0a,
	0x70,
	0x61,
	0x74,
	0x65,
	0x6e,
	0x74,
	0x20,
	0x6c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x20,
	0x74,
	0x68,
	0x69,
	0x73,
	0x20,
	0x70,
	0x61,
	0x72,
	0x74,
	0x69,
	0x63,
	0x75,
	0x6c,
	0x61,
	0x72,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x2c,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x28,
	0x33,
	0x29,
	0x20,
	0x61,
	0x72,
	0x72,
	0x61,
	0x6e,
	0x67,
	0x65,
	0x2c,
	0x20,
	0x69,
	0x6e,
	0x20,
	0x61,
	0x20,
	0x6d,
	0x61,
	0x6e,
	0x6e,
	0x65,
	0x72,
	0x0a,
	0x63,
	0x6f,
	0x6e,
	0x73,
	0x69,
	0x73,
	0x74,
	0x65,
	0x6e,
	0x74,
	0x20,
	0x77,
	0x69,
	0x74,
	0x68,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x72,
	0x65,
	0x71,
	0x75,
	0x69,
	0x72,
	0x65,
	0x6d,
	0x65,
	0x6e,
	0x74,
	0x73,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x69,
	0x73,
	0x20,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x2c,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x65,
	0x78,
	0x74,
	0x65,
	0x6e,
	0x64,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x70,
	0x61,
	0x74,
	0x65,
	0x6e,
	0x74,
	0x0a,
	0x6c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x64,
	0x6f,
	0x77,
	0x6e,
	0x73,
	0x74,
	0x72,
	0x65,
	0x61,
	0x6d,
	0x20,
	0x72,
	0x65,
	0x63,
	0x69,
	0x70,
	0x69,
	0x65,
	0x6e,
	0x74,
	0x73,
	0x2e,
	0x20,
	0x20,
	0x22,
	0x4b,
	0x6e,
	0x6f,
	0x77,
	0x69,
	0x6e,
	0x67,
	0x6c,
	0x79,
	0x20,
	0x72,
	0x65,
	0x6c,
	0x79,
	0x69,
	0x6e,
	0x67,
	0x22,
	0x20,
	0x6d,
	0x65,
	0x61,
	0x6e,
	0x73,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x68,
	0x61,
	0x76,
	0x65,
	0x0a,
	0x61,
	0x63,
	0x74,
	0x75,
	0x61,
	0x6c,
	0x20,
	0x6b,
	0x6e,
	0x6f,
	0x77,
	0x6c,
	0x65,
	0x64,
	0x67,
	0x65,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x2c,
	0x20,
	0x62,
	0x75,
	0x74,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x70,
	0x61,
	0x74,
	0x65,
	0x6e,
	0x74,
	0x20,
	0x6c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x2c,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x72,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x76,
	0x65,
	0x79,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x74,
	0x68,
	0x65,
	0x0a,
	0x63,
	0x6f,
	0x76,
	0x65,
	0x72,
	0x65,
	0x64,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x20,
	0x69,
	0x6e,
	0x20,
	0x61,
	0x20,
	0x63,
	0x6f,
	0x75,
	0x6e,
	0x74,
	0x72,
	0x79,
	0x2c,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x72,
	0x20,
	0x72,
	0x65,
	0x63,
	0x69,
	0x70,
	0x69,
	0x65,
	0x6e,
	0x74,
	0x27,
	0x73,
	0x20,
	0x75,
	0x73,
	0x65,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x63,
	0x6f,
	0x76,
	0x65,
	0x72,
	0x65,
	0x64,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x0a,
	0x69,
	0x6e,
	0x20,
	0x61,
	0x20,
	0x63,
	0x6f,
	0x75,
	0x6e,
	0x74,
	0x72,
	0x79,
	0x2c,
	0x20,
	0x77,
	0x6f,
	0x75,
	0x6c,
	0x64,
	0x20,
	0x69,
	0x6e,
	0x66,
	0x72,
	0x69,
	0x6e,
	0x67,
	0x65,
	0x20,
	0x6f,
	0x6e,
	0x65,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x6d,
	0x6f,
	0x72,
	0x65,
	0x20,
	0x69,
	0x64,
	0x65,
	0x6e,
	0x74,
	0x69,
	0x66,
	0x69,
	0x61,
	0x62,
	0x6c,
	0x65,
	0x20,
	0x70,
	0x61,
	0x74,
	0x65,
	0x6e,
	0x74,
	0x73,
	0x20,
	0x69,
	0x6e,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x0a,
	0x63,
	0x6f,
	0x75,
	0x6e,
	0x74,
	0x72,
	0x79,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x68,
	0x61,
	0x76,
	0x65,
	0x20,
	0x72,
	0x65,
	0x61,
	0x73,
	0x6f,
	0x6e,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x62,
	0x65,
	0x6c,
	0x69,
	0x65,
	0x76,
	0x65,
	0x20,
	0x61,
	0x72,
	0x65,
	0x20,
	0x76,
	0x61,
	0x6c,
	0x69,
	0x64,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x49,
	0x66,
	0x2c,
	0x20,
	0x70,
	0x75,
	0x72,
	0x73,
	0x75,
	0x61,
	0x6e,
	0x74,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x69,
	0x6e,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x6e,
	0x65,
	0x63,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x77,
	0x69,
	0x74,
	0x68,
	0x20,
	0x61,
	0x20,
	0x73,
	0x69,
	0x6e,
	0x67,
	0x6c,
	0x65,
	0x20,
	0x74,
	0x72,
	0x61,
	0x6e,
	0x73,
	0x61,
	0x63,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x6f,
	0x72,
	0x0a,
	0x61,
	0x72,
	0x72,
	0x61,
	0x6e,
	0x67,
	0x65,
	0x6d,
	0x65,
	0x6e,
	0x74,
	0x2c,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x76,
	0x65,
	0x79,
	0x2c,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x70,
	0x61,
	0x67,
	0x61,
	0x74,
	0x65,
	0x20,
	0x62,
	0x79,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x63,
	0x75,
	0x72,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x76,
	0x65,
	0x79,
	0x61,
	0x6e,
	0x63,
	0x65,
	0x20,
	0x6f,
	0x66,
	0x2c,
	0x20,
	0x61,
	0x0a,
	0x63,
	0x6f,
	0x76,
	0x65,
	0x72,
	0x65,
	0x64,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x2c,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x67,
	0x72,
	0x61,
	0x6e,
	0x74,
	0x20,
	0x61,
	0x20,
	0x70,
	0x61,
	0x74,
	0x65,
	0x6e,
	0x74,
	0x20,
	0x6c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x73,
	0x6f,
	0x6d,
	0x65,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x70,
	0x61,
	0x72,
	0x74,
	0x69,
	0x65,
	0x73,
	0x0a,
	0x72,
	0x65,
	0x63,
	0x65,
	0x69,
	0x76,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x63,
	0x6f,
	0x76,
	0x65,
	0x72,
	0x65,
	0x64,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x20,
	0x61,
	0x75,
	0x74,
	0x68,
	0x6f,
	0x72,
	0x69,
	0x7a,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x74,
	0x68,
	0x65,
	0x6d,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x75,
	0x73,
	0x65,
	0x2c,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x70,
	0x61,
	0x67,
	0x61,
	0x74,
	0x65,
	0x2c,
	0x20,
	0x6d,
	0x6f,
	0x64,
	0x69,
	0x66,
	0x79,
	0x0a,
	0x6f,
	0x72,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x76,
	0x65,
	0x79,
	0x20,
	0x61,
	0x20,
	0x73,
	0x70,
	0x65,
	0x63,
	0x69,
	0x66,
	0x69,
	0x63,
	0x20,
	0x63,
	0x6f,
	0x70,
	0x79,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x63,
	0x6f,
	0x76,
	0x65,
	0x72,
	0x65,
	0x64,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x2c,
	0x20,
	0x74,
	0x68,
	0x65,
	0x6e,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x70,
	0x61,
	0x74,
	0x65,
	0x6e,
	0x74,
	0x20,
	0x6c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x0a,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x67,
	0x72,
	0x61,
	0x6e,
	0x74,
	0x20,
	0x69,
	0x73,
	0x20,
	0x61,
	0x75,
	0x74,
	0x6f,
	0x6d,
	0x61,
	0x74,
	0x69,
	0x63,
	0x61,
	0x6c,
	0x6c,
	0x79,
	0x20,
	0x65,
	0x78,
	0x74,
	0x65,
	0x6e,
	0x64,
	0x65,
	0x64,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x61,
	0x6c,
	0x6c,
	0x20,
	0x72,
	0x65,
	0x63,
	0x69,
	0x70,
	0x69,
	0x65,
	0x6e,
	0x74,
	0x73,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x63,
	0x6f,
	0x76,
	0x65,
	0x72,
	0x65,
	0x64,
	0x0a,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x73,
	0x20,
	0x62,
	0x61,
	0x73,
	0x65,
	0x64,
	0x20,
	0x6f,
	0x6e,
	0x20,
	0x69,
	0x74,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x41,
	0x20,
	0x70,
	0x61,
	0x74,
	0x65,
	0x6e,
	0x74,
	0x20,
	0x6c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x20,
	0x69,
	0x73,
	0x20,
	0x22,
	0x64,
	0x69,
	0x73,
	0x63,
	0x72,
	0x69,
	0x6d,
	0x69,
	0x6e,
	0x61,
	0x74,
	0x6f,
	0x72,
	0x79,
	0x22,
	0x20,
	0x69,
	0x66,
	0x20,
	0x69,
	0x74,
	0x20,
	0x64,
	0x6f,
	0x65,
	0x73,
	0x20,
	0x6e,
	0x6f,
	0x74,
	0x20,
	0x69,
	0x6e,
	0x63,
	0x6c,
	0x75,
	0x64,
	0x65,
	0x20,
	0x77,
	0x69,
	0x74,
	0x68,
	0x69,
	0x6e,
	0x0a,
	0x74,
	0x68,
	0x65,
	0x20,
	0x73,
	0x63,
	0x6f,
	0x70,
	0x65,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x69,
	0x74,
	0x73,
	0x20,
	0x63,
	0x6f,
	0x76,
	0x65,
	0x72,
	0x61,
	0x67,
	0x65,
	0x2c,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x68,
	0x69,
	0x62,
	0x69,
	0x74,
	0x73,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x65,
	0x78,
	0x65,
	0x72,
	0x63,
	0x69,
	0x73,
	0x65,
	0x20,
	0x6f,
	0x66,
	0x2c,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x69,
	0x73,
	0x0a,
	0x63,
	0x6f,
	0x6e,
	0x64,
	0x69,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x65,
	0x64,
	0x20,
	0x6f,
	0x6e,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x6e,
	0x6f,
	0x6e,
	0x2d,
	0x65,
	0x78,
	0x65,
	0x72,
	0x63,
	0x69,
	0x73,
	0x65,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x6f,
	0x6e,
	0x65,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x6d,
	0x6f,
	0x72,
	0x65,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x72,
	0x69,
	0x67,
	0x68,
	0x74,
	0x73,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x61,
	0x72,
	0x65,
	0x0a,
	0x73,
	0x70,
	0x65,
	0x63,
	0x69,
	0x66,
	0x69,
	0x63,
	0x61,
	0x6c,
	0x6c,
	0x79,
	0x20,
	0x67,
	0x72,
	0x61,
	0x6e,
	0x74,
	0x65,
	0x64,
	0x20,
	0x75,
	0x6e,
	0x64,
	0x65,
	0x72,
	0x20,
	0x74,
	0x68,
	0x69,
	0x73,
	0x20,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x2e,
	0x20,
	0x20,
	0x59,
	0x6f,
	0x75,
	0x20,
	0x6d,
	0x61,
	0x79,
	0x20,
	0x6e,
	0x6f,
	0x74,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x76,
	0x65,
	0x79,
	0x20,
	0x61,
	0x20,
	0x63,
	0x6f,
	0x76,
	0x65,
	0x72,
	0x65,
	0x64,
	0x0a,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x20,
	0x69,
	0x66,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x61,
	0x72,
	0x65,
	0x20,
	0x61,
	0x20,
	0x70,
	0x61,
	0x72,
	0x74,
	0x79,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x61,
	0x6e,
	0x20,
	0x61,
	0x72,
	0x72,
	0x61,
	0x6e,
	0x67,
	0x65,
	0x6d,
	0x65,
	0x6e,
	0x74,
	0x20,
	0x77,
	0x69,
	0x74,
	0x68,
	0x20,
	0x61,
	0x20,
	0x74,
	0x68,
	0x69,
	0x72,
	0x64,
	0x20,
	0x70,
	0x61,
	0x72,
	0x74,
	0x79,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x69,
	0x73,
	0x0a,
	0x69,
	0x6e,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x62,
	0x75,
	0x73,
	0x69,
	0x6e,
	0x65,
	0x73,
	0x73,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x64,
	0x69,
	0x73,
	0x74,
	0x72,
	0x69,
	0x62,
	0x75,
	0x74,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x73,
	0x6f,
	0x66,
	0x74,
	0x77,
	0x61,
	0x72,
	0x65,
	0x2c,
	0x20,
	0x75,
	0x6e,
	0x64,
	0x65,
	0x72,
	0x20,
	0x77,
	0x68,
	0x69,
	0x63,
	0x68,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x6d,
	0x61,
	0x6b,
	0x65,
	0x20,
	0x70,
	0x61,
	0x79,
	0x6d,
	0x65,
	0x6e,
	0x74,
	0x0a,
	0x74,
	0x6f,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x74,
	0x68,
	0x69,
	0x72,
	0x64,
	0x20,
	0x70,
	0x61,
	0x72,
	0x74,
	0x79,
	0x20,
	0x62,
	0x61,
	0x73,
	0x65,
	0x64,
	0x20,
	0x6f,
	0x6e,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x65,
	0x78,
	0x74,
	0x65,
	0x6e,
	0x74,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x72,
	0x20,
	0x61,
	0x63,
	0x74,
	0x69,
	0x76,
	0x69,
	0x74,
	0x79,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x76,
	0x65,
	0x79,
	0x69,
	0x6e,
	0x67,
	0x0a,
	0x74,
	0x68,
	0x65,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x2c,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x75,
	0x6e,
	0x64,
	0x65,
	0x72,
	0x20,
	0x77,
	0x68,
	0x69,
	0x63,
	0x68,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x74,
	0x68,
	0x69,
	0x72,
	0x64,
	0x20,
	0x70,
	0x61,
	0x72,
	0x74,
	0x79,
	0x20,
	0x67,
	0x72,
	0x61,
	0x6e,
	0x74,
	0x73,
	0x2c,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x61,
	0x6e,
	0x79,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x0a,
	0x70,
	0x61,
	0x72,
	0x74,
	0x69,
	0x65,
	0x73,
	0x20,
	0x77,
	0x68,
	0x6f,
	0x20,
	0x77,
	0x6f,
	0x75,
	0x6c,
	0x64,
	0x20,
	0x72,
	0x65,
	0x63,
	0x65,
	0x69,
	0x76,
	0x65,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x63,
	0x6f,
	0x76,
	0x65,
	0x72,
	0x65,
	0x64,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x20,
	0x66,
	0x72,
	0x6f,
	0x6d,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x2c,
	0x20,
	0x61,
	0x20,
	0x64,
	0x69,
	0x73,
	0x63,
	0x72,
	0x69,
	0x6d,
	0x69,
	0x6e,
	0x61,
	0x74,
	0x6f,
	0x72,
	0x79,
	0x0a,
	0x70,
	0x61,
	0x74,
	0x65,
	0x6e,
	0x74,
	0x20,
	0x6c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x20,
	0x28,
	0x61,
	0x29,
	0x20,
	0x69,
	0x6e,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x6e,
	0x65,
	0x63,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x77,
	0x69,
	0x74,
	0x68,
	0x20,
	0x63,
	0x6f,
	0x70,
	0x69,
	0x65,
	0x73,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x63,
	0x6f,
	0x76,
	0x65,
	0x72,
	0x65,
	0x64,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x0a,
	0x63,
	0x6f,
	0x6e,
	0x76,
	0x65,
	0x79,
	0x65,
	0x64,
	0x20,
	0x62,
	0x79,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x28,
	0x6f,
	0x72,
	0x20,
	0x63,
	0x6f,
	0x70,
	0x69,
	0x65,
	0x73,
	0x20,
	0x6d,
	0x61,
	0x64,
	0x65,
	0x20,
	0x66,
	0x72,
	0x6f,
	0x6d,
	0x20,
	0x74,
	0x68,
	0x6f,
	0x73,
	0x65,
	0x20,
	0x63,
	0x6f,
	0x70,
	0x69,
	0x65,
	0x73,
	0x29,
	0x2c,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x28,
	0x62,
	0x29,
	0x20,
	0x70,
	0x72,
	0x69,
	0x6d,
	0x61,
	0x72,
	0x69,
	0x6c,
	0x79,
	0x0a,
	0x66,
	0x6f,
	0x72,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x69,
	0x6e,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x6e,
	0x65,
	0x63,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x77,
	0x69,
	0x74,
	0x68,
	0x20,
	0x73,
	0x70,
	0x65,
	0x63,
	0x69,
	0x66,
	0x69,
	0x63,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x64,
	0x75,
	0x63,
	0x74,
	0x73,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x63,
	0x6f,
	0x6d,
	0x70,
	0x69,
	0x6c,
	0x61,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x73,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x0a,
	0x63,
	0x6f,
	0x6e,
	0x74,
	0x61,
	0x69,
	0x6e,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x63,
	0x6f,
	0x76,
	0x65,
	0x72,
	0x65,
	0x64,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x2c,
	0x20,
	0x75,
	0x6e,
	0x6c,
	0x65,
	0x73,
	0x73,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x65,
	0x6e,
	0x74,
	0x65,
	0x72,
	0x65,
	0x64,
	0x20,
	0x69,
	0x6e,
	0x74,
	0x6f,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x61,
	0x72,
	0x72,
	0x61,
	0x6e,
	0x67,
	0x65,
	0x6d,
	0x65,
	0x6e,
	0x74,
	0x2c,
	0x0a,
	0x6f,
	0x72,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x70,
	0x61,
	0x74,
	0x65,
	0x6e,
	0x74,
	0x20,
	0x6c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x20,
	0x77,
	0x61,
	0x73,
	0x20,
	0x67,
	0x72,
	0x61,
	0x6e,
	0x74,
	0x65,
	0x64,
	0x2c,
	0x20,
	0x70,
	0x72,
	0x69,
	0x6f,
	0x72,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x32,
	0x38,
	0x20,
	0x4d,
	0x61,
	0x72,
	0x63,
	0x68,
	0x20,
	0x32,
	0x30,
	0x30,
	0x37,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x4e,
	0x6f,
	0x74,
	0x68,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x69,
	0x6e,
	0x20,
	0x74,
	0x68,
	0x69,
	0x73,
	0x20,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x20,
	0x73,
	0x68,
	0x61,
	0x6c,
	0x6c,
	0x20,
	0x62,
	0x65,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x73,
	0x74,
	0x72,
	0x75,
	0x65,
	0x64,
	0x20,
	0x61,
	0x73,
	0x20,
	0x65,
	0x78,
	0x63,
	0x6c,
	0x75,
	0x64,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x6c,
	0x69,
	0x6d,
	0x69,
	0x74,
	0x69,
	0x6e,
	0x67,
	0x0a,
	0x61,
	0x6e,
	0x79,
	0x20,
	0x69,
	0x6d,
	0x70,
	0x6c,
	0x69,
	0x65,
	0x64,
	0x20,
	0x6c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x6f,
	0x74,
	0x68,
	0x65,
	0x72,
	0x20,
	0x64,
	0x65,
	0x66,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x73,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x69,
	0x6e,
	0x66,
	0x72,
	0x69,
	0x6e,
	0x67,
	0x65,
	0x6d,
	0x65,
	0x6e,
	0x74,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x6d,
	0x61,
	0x79,
	0x0a,
	0x6f,
	0x74,
	0x68,
	0x65,
	0x72,
	0x77,
	0x69,
	0x73,
	0x65,
	0x20,
	0x62,
	0x65,
	0x20,
	0x61,
	0x76,
	0x61,
	0x69,
	0x6c,
	0x61,
	0x62,
	0x6c,
	0x65,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x75,
	0x6e,
	0x64,
	0x65,
	0x72,
	0x20,
	0x61,
	0x70,
	0x70,
	0x6c,
	0x69,
	0x63,
	0x61,
	0x62,
	0x6c,
	0x65,
	0x20,
	0x70,
	0x61,
	0x74,
	0x65,
	0x6e,
	0x74,
	0x20,
	0x6c,
	0x61,
	0x77,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x31,
	0x32,
	0x2e,
	0x20,
	0x4e,
	0x6f,
	0x20,
	0x53,
	0x75,
	0x72,
	0x72,
	0x65,
	0x6e,
	0x64,
	0x65,
	0x72,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x4f,
	0x74,
	0x68,
	0x65,
	0x72,
	0x73,
	0x27,
	0x20,
	0x46,
	0x72,
	0x65,
	0x65,
	0x64,
	0x6f,
	0x6d,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x49,
	0x66,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x64,
	0x69,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x73,
	0x20,
	0x61,
	0x72,
	0x65,
	0x20,
	0x69,
	0x6d,
	0x70,
	0x6f,
	0x73,
	0x65,
	0x64,
	0x20,
	0x6f,
	0x6e,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x28,
	0x77,
	0x68,
	0x65,
	0x74,
	0x68,
	0x65,
	0x72,
	0x20,
	0x62,
	0x79,
	0x20,
	0x63,
	0x6f,
	0x75,
	0x72,
	0x74,
	0x20,
	0x6f,
	0x72,
	0x64,
	0x65,
	0x72,
	0x2c,
	0x20,
	0x61,
	0x67,
	0x72,
	0x65,
	0x65,
	0x6d,
	0x65,
	0x6e,
	0x74,
	0x20,
	0x6f,
	0x72,
	0x0a,
	0x6f,
	0x74,
	0x68,
	0x65,
	0x72,
	0x77,
	0x69,
	0x73,
	0x65,
	0x29,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x74,
	0x72,
	0x61,
	0x64,
	0x69,
	0x63,
	0x74,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x64,
	0x69,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x73,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x69,
	0x73,
	0x20,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x2c,
	0x20,
	0x74,
	0x68,
	0x65,
	0x79,
	0x20,
	0x64,
	0x6f,
	0x20,
	0x6e,
	0x6f,
	0x74,
	0x0a,
	0x65,
	0x78,
	0x63,
	0x75,
	0x73,
	0x65,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x66,
	0x72,
	0x6f,
	0x6d,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x64,
	0x69,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x73,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x69,
	0x73,
	0x20,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x2e,
	0x20,
	0x20,
	0x49,
	0x66,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x63,
	0x61,
	0x6e,
	0x6e,
	0x6f,
	0x74,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x76,
	0x65,
	0x79,
	0x20,
	0x61,
	0x0a,
	0x63,
	0x6f,
	0x76,
	0x65,
	0x72,
	0x65,
	0x64,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x20,
	0x73,
	0x6f,
	0x20,
	0x61,
	0x73,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x73,
	0x61,
	0x74,
	0x69,
	0x73,
	0x66,
	0x79,
	0x20,
	0x73,
	0x69,
	0x6d,
	0x75,
	0x6c,
	0x74,
	0x61,
	0x6e,
	0x65,
	0x6f,
	0x75,
	0x73,
	0x6c,
	0x79,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x72,
	0x20,
	0x6f,
	0x62,
	0x6c,
	0x69,
	0x67,
	0x61,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x73,
	0x20,
	0x75,
	0x6e,
	0x64,
	0x65,
	0x72,
	0x20,
	0x74,
	0x68,
	0x69,
	0x73,
	0x0a,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x61,
	0x6e,
	0x79,
	0x20,
	0x6f,
	0x74,
	0x68,
	0x65,
	0x72,
	0x20,
	0x70,
	0x65,
	0x72,
	0x74,
	0x69,
	0x6e,
	0x65,
	0x6e,
	0x74,
	0x20,
	0x6f,
	0x62,
	0x6c,
	0x69,
	0x67,
	0x61,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x73,
	0x2c,
	0x20,
	0x74,
	0x68,
	0x65,
	0x6e,
	0x20,
	0x61,
	0x73,
	0x20,
	0x61,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x73,
	0x65,
	0x71,
	0x75,
	0x65,
	0x6e,
	0x63,
	0x65,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x6d,
	0x61,
	0x79,
	0x0a,
	0x6e,
	0x6f,
	0x74,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x76,
	0x65,
	0x79,
	0x20,
	0x69,
	0x74,
	0x20,
	0x61,
	0x74,
	0x20,
	0x61,
	0x6c,
	0x6c,
	0x2e,
	0x20,
	0x20,
	0x46,
	0x6f,
	0x72,
	0x20,
	0x65,
	0x78,
	0x61,
	0x6d,
	0x70,
	0x6c,
	0x65,
	0x2c,
	0x20,
	0x69,
	0x66,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x61,
	0x67,
	0x72,
	0x65,
	0x65,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x74,
	0x65,
	0x72,
	0x6d,
	0x73,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x6f,
	0x62,
	0x6c,
	0x69,
	0x67,
	0x61,
	0x74,
	0x65,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x0a,
	0x74,
	0x6f,
	0x20,
	0x63,
	0x6f,
	0x6c,
	0x6c,
	0x65,
	0x63,
	0x74,
	0x20,
	0x61,
	0x20,
	0x72,
	0x6f,
	0x79,
	0x61,
	0x6c,
	0x74,
	0x79,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x20,
	0x66,
	0x75,
	0x72,
	0x74,
	0x68,
	0x65,
	0x72,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x76,
	0x65,
	0x79,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x66,
	0x72,
	0x6f,
	0x6d,
	0x20,
	0x74,
	0x68,
	0x6f,
	0x73,
	0x65,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x77,
	0x68,
	0x6f,
	0x6d,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x76,
	0x65,
	0x79,
	0x0a,
	0x74,
	0x68,
	0x65,
	0x20,
	0x50,
	0x72,
	0x6f,
	0x67,
	0x72,
	0x61,
	0x6d,
	0x2c,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x6f,
	0x6e,
	0x6c,
	0x79,
	0x20,
	0x77,
	0x61,
	0x79,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x63,
	0x6f,
	0x75,
	0x6c,
	0x64,
	0x20,
	0x73,
	0x61,
	0x74,
	0x69,
	0x73,
	0x66,
	0x79,
	0x20,
	0x62,
	0x6f,
	0x74,
	0x68,
	0x20,
	0x74,
	0x68,
	0x6f,
	0x73,
	0x65,
	0x20,
	0x74,
	0x65,
	0x72,
	0x6d,
	0x73,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x74,
	0x68,
	0x69,
	0x73,
	0x0a,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x20,
	0x77,
	0x6f,
	0x75,
	0x6c,
	0x64,
	0x20,
	0x62,
	0x65,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x72,
	0x65,
	0x66,
	0x72,
	0x61,
	0x69,
	0x6e,
	0x20,
	0x65,
	0x6e,
	0x74,
	0x69,
	0x72,
	0x65,
	0x6c,
	0x79,
	0x20,
	0x66,
	0x72,
	0x6f,
	0x6d,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x76,
	0x65,
	0x79,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x50,
	0x72,
	0x6f,
	0x67,
	0x72,
	0x61,
	0x6d,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x31,
	0x33,
	0x2e,
	0x20,
	0x55,
	0x73,
	0x65,
	0x20,
	0x77,
	0x69,
	0x74,
	0x68,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x47,
	0x4e,
	0x55,
	0x20,
	0x41,
	0x66,
	0x66,
	0x65,
	0x72,
	0x6f,
	0x20,
	0x47,
	0x65,
	0x6e,
	0x65,
	0x72,
	0x61,
	0x6c,
	0x20,
	0x50,
	0x75,
	0x62,
	0x6c,
	0x69,
	0x63,
	0x20,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x4e,
	0x6f,
	0x74,
	0x77,
	0x69,
	0x74,
	0x68,
	0x73,
	0x74,
	0x61,
	0x6e,
	0x64,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x61,
	0x6e,
	0x79,
	0x20,
	0x6f,
	0x74,
	0x68,
	0x65,
	0x72,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x76,
	0x69,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x69,
	0x73,
	0x20,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x2c,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x68,
	0x61,
	0x76,
	0x65,
	0x0a,
	0x70,
	0x65,
	0x72,
	0x6d,
	0x69,
	0x73,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x6c,
	0x69,
	0x6e,
	0x6b,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x63,
	0x6f,
	0x6d,
	0x62,
	0x69,
	0x6e,
	0x65,
	0x20,
	0x61,
	0x6e,
	0x79,
	0x20,
	0x63,
	0x6f,
	0x76,
	0x65,
	0x72,
	0x65,
	0x64,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x20,
	0x77,
	0x69,
	0x74,
	0x68,
	0x20,
	0x61,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x20,
	0x6c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x64,
	0x0a,
	0x75,
	0x6e,
	0x64,
	0x65,
	0x72,
	0x20,
	0x76,
	0x65,
	0x72,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x33,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x47,
	0x4e,
	0x55,
	0x20,
	0x41,
	0x66,
	0x66,
	0x65,
	0x72,
	0x6f,
	0x20,
	0x47,
	0x65,
	0x6e,
	0x65,
	0x72,
	0x61,
	0x6c,
	0x20,
	0x50,
	0x75,
	0x62,
	0x6c,
	0x69,
	0x63,
	0x20,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x20,
	0x69,
	0x6e,
	0x74,
	0x6f,
	0x20,
	0x61,
	0x20,
	0x73,
	0x69,
	0x6e,
	0x67,
	0x6c,
	0x65,
	0x0a,
	0x63,
	0x6f,
	0x6d,
	0x62,
	0x69,
	0x6e,
	0x65,
	0x64,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x2c,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x76,
	0x65,
	0x79,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x72,
	0x65,
	0x73,
	0x75,
	0x6c,
	0x74,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x2e,
	0x20,
	0x20,
	0x54,
	0x68,
	0x65,
	0x20,
	0x74,
	0x65,
	0x72,
	0x6d,
	0x73,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x69,
	0x73,
	0x0a,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x20,
	0x77,
	0x69,
	0x6c,
	0x6c,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x74,
	0x69,
	0x6e,
	0x75,
	0x65,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x61,
	0x70,
	0x70,
	0x6c,
	0x79,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x70,
	0x61,
	0x72,
	0x74,
	0x20,
	0x77,
	0x68,
	0x69,
	0x63,
	0x68,
	0x20,
	0x69,
	0x73,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x63,
	0x6f,
	0x76,
	0x65,
	0x72,
	0x65,
	0x64,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x2c,
	0x0a,
	0x62,
	0x75,
	0x74,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x73,
	0x70,
	0x65,
	0x63,
	0x69,
	0x61,
	0x6c,
	0x20,
	0x72,
	0x65,
	0x71,
	0x75,
	0x69,
	0x72,
	0x65,
	0x6d,
	0x65,
	0x6e,
	0x74,
	0x73,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x47,
	0x4e,
	0x55,
	0x20,
	0x41,
	0x66,
	0x66,
	0x65,
	0x72,
	0x6f,
	0x20,
	0x47,
	0x65,
	0x6e,
	0x65,
	0x72,
	0x61,
	0x6c,
	0x20,
	0x50,
	0x75,
	0x62,
	0x6c,
	0x69,
	0x63,
	0x20,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x2c,
	0x0a,
	0x73,
	0x65,
	0x63,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x31,
	0x33,
	0x2c,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x63,
	0x65,
	0x72,
	0x6e,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x69,
	0x6e,
	0x74,
	0x65,
	0x72,
	0x61,
	0x63,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x74,
	0x68,
	0x72,
	0x6f,
	0x75,
	0x67,
	0x68,
	0x20,
	0x61,
	0x20,
	0x6e,
	0x65,
	0x74,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x20,
	0x77,
	0x69,
	0x6c,
	0x6c,
	0x20,
	0x61,
	0x70,
	0x70,
	0x6c,
	0x79,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x74,
	0x68,
	0x65,
	0x0a,
	0x63,
	0x6f,
	0x6d,
	0x62,
	0x69,
	0x6e,
	0x61,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x61,
	0x73,
	0x20,
	0x73,
	0x75,
	0x63,
	0x68,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x31,
	0x34,
	0x2e,
	0x20,
	0x52,
	0x65,
	0x76,
	0x69,
	0x73,
	0x65,
	0x64,
	0x20,
	0x56,
	0x65,
	0x72,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x73,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x69,
	0x73,
	0x20,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x54,
	0x68,
	0x65,
	0x20,
	0x46,
	0x72,
	0x65,
	0x65,
	0x20,
	0x53,
	0x6f,
	0x66,
	0x74,
	0x77,
	0x61,
	0x72,
	0x65,
	0x20,
	0x46,
	0x6f,
	0x75,
	0x6e,
	0x64,
	0x61,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x6d,
	0x61,
	0x79,
	0x20,
	0x70,
	0x75,
	0x62,
	0x6c,
	0x69,
	0x73,
	0x68,
	0x20,
	0x72,
	0x65,
	0x76,
	0x69,
	0x73,
	0x65,
	0x64,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x2f,
	0x6f,
	0x72,
	0x20,
	0x6e,
	0x65,
	0x77,
	0x20,
	0x76,
	0x65,
	0x72,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x73,
	0x20,
	0x6f,
	0x66,
	0x0a,
	0x74,
	0x68,
	0x65,
	0x20,
	0x47,
	0x4e,
	0x55,
	0x20,
	0x47,
	0x65,
	0x6e,
	0x65,
	0x72,
	0x61,
	0x6c,
	0x20,
	0x50,
	0x75,
	0x62,
	0x6c,
	0x69,
	0x63,
	0x20,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x20,
	0x66,
	0x72,
	0x6f,
	0x6d,
	0x20,
	0x74,
	0x69,
	0x6d,
	0x65,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x74,
	0x69,
	0x6d,
	0x65,
	0x2e,
	0x20,
	0x20,
	0x53,
	0x75,
	0x63,
	0x68,
	0x20,
	0x6e,
	0x65,
	0x77,
	0x20,
	0x76,
	0x65,
	0x72,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x73,
	0x20,
	0x77,
	0x69,
	0x6c,
	0x6c,
	0x0a,
	0x62,
	0x65,
	0x20,
	0x73,
	0x69,
	0x6d,
	0x69,
	0x6c,
	0x61,
	0x72,
	0x20,
	0x69,
	0x6e,
	0x20,
	0x73,
	0x70,
	0x69,
	0x72,
	0x69,
	0x74,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x70,
	0x72,
	0x65,
	0x73,
	0x65,
	0x6e,
	0x74,
	0x20,
	0x76,
	0x65,
	0x72,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x2c,
	0x20,
	0x62,
	0x75,
	0x74,
	0x20,
	0x6d,
	0x61,
	0x79,
	0x20,
	0x64,
	0x69,
	0x66,
	0x66,
	0x65,
	0x72,
	0x20,
	0x69,
	0x6e,
	0x20,
	0x64,
	0x65,
	0x74,
	0x61,
	0x69,
	0x6c,
	0x20,
	0x74,
	0x6f,
	0x0a,
	0x61,
	0x64,
	0x64,
	0x72,
	0x65,
	0x73,
	0x73,
	0x20,
	0x6e,
	0x65,
	0x77,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x62,
	0x6c,
	0x65,
	0x6d,
	0x73,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x63,
	0x65,
	0x72,
	0x6e,
	0x73,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x45,
	0x61,
	0x63,
	0x68,
	0x20,
	0x76,
	0x65,
	0x72,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x69,
	0x73,
	0x20,
	0x67,
	0x69,
	0x76,
	0x65,
	0x6e,
	0x20,
	0x61,
	0x20,
	0x64,
	0x69,
	0x73,
	0x74,
	0x69,
	0x6e,
	0x67,
	0x75,
	0x69,
	0x73,
	0x68,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x76,
	0x65,
	0x72,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x6e,
	0x75,
	0x6d,
	0x62,
	0x65,
	0x72,
	0x2e,
	0x20,
	0x20,
	0x49,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x0a,
	0x50,
	0x72,
	0x6f,
	0x67,
	0x72,
	0x61,
	0x6d,
	0x20,
	0x73,
	0x70,
	0x65,
	0x63,
	0x69,
	0x66,
	0x69,
	0x65,
	0x73,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x61,
	0x20,
	0x63,
	0x65,
	0x72,
	0x74,
	0x61,
	0x69,
	0x6e,
	0x20,
	0x6e,
	0x75,
	0x6d,
	0x62,
	0x65,
	0x72,
	0x65,
	0x64,
	0x20,
	0x76,
	0x65,
	0x72,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x47,
	0x4e,
	0x55,
	0x20,
	0x47,
	0x65,
	0x6e,
	0x65,
	0x72,
	0x61,
	0x6c,
	0x0a,
	0x50,
	0x75,
	0x62,
	0x6c,
	0x69,
	0x63,
	0x20,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x20,
	0x22,
	0x6f,
	0x72,
	0x20,
	0x61,
	0x6e,
	0x79,
	0x20,
	0x6c,
	0x61,
	0x74,
	0x65,
	0x72,
	0x20,
	0x76,
	0x65,
	0x72,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x22,
	0x20,
	0x61,
	0x70,
	0x70,
	0x6c,
	0x69,
	0x65,
	0x73,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x69,
	0x74,
	0x2c,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x68,
	0x61,
	0x76,
	0x65,
	0x20,
	0x74,
	0x68,
	0x65,
	0x0a,
	0x6f,
	0x70,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x66,
	0x6f,
	0x6c,
	0x6c,
	0x6f,
	0x77,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x74,
	0x65,
	0x72,
	0x6d,
	0x73,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x64,
	0x69,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x73,
	0x20,
	0x65,
	0x69,
	0x74,
	0x68,
	0x65,
	0x72,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x6e,
	0x75,
	0x6d,
	0x62,
	0x65,
	0x72,
	0x65,
	0x64,
	0x0a,
	0x76,
	0x65,
	0x72,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x61,
	0x6e,
	0x79,
	0x20,
	0x6c,
	0x61,
	0x74,
	0x65,
	0x72,
	0x20,
	0x76,
	0x65,
	0x72,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x70,
	0x75,
	0x62,
	0x6c,
	0x69,
	0x73,
	0x68,
	0x65,
	0x64,
	0x20,
	0x62,
	0x79,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x46,
	0x72,
	0x65,
	0x65,
	0x20,
	0x53,
	0x6f,
	0x66,
	0x74,
	0x77,
	0x61,
	0x72,
	0x65,
	0x0a,
	0x46,
	0x6f,
	0x75,
	0x6e,
	0x64,
	0x61,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x2e,
	0x20,
	0x20,
	0x49,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x50,
	0x72,
	0x6f,
	0x67,
	0x72,
	0x61,
	0x6d,
	0x20,
	0x64,
	0x6f,
	0x65,
	0x73,
	0x20,
	0x6e,
	0x6f,
	0x74,
	0x20,
	0x73,
	0x70,
	0x65,
	0x63,
	0x69,
	0x66,
	0x79,
	0x20,
	0x61,
	0x20,
	0x76,
	0x65,
	0x72,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x6e,
	0x75,
	0x6d,
	0x62,
	0x65,
	0x72,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x0a,
	0x47,
	0x4e,
	0x55,
	0x20,
	0x47,
	0x65,
	0x6e,
	0x65,
	0x72,
	0x61,
	0x6c,
	0x20,
	0x50,
	0x75,
	0x62,
	0x6c,
	0x69,
	0x63,
	0x20,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x2c,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x6d,
	0x61,
	0x79,
	0x20,
	0x63,
	0x68,
	0x6f,
	0x6f,
	0x73,
	0x65,
	0x20,
	0x61,
	0x6e,
	0x79,
	0x20,
	0x76,
	0x65,
	0x72,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x65,
	0x76,
	0x65,
	0x72,
	0x20,
	0x70,
	0x75,
	0x62,
	0x6c,
	0x69,
	0x73,
	0x68,
	0x65,
	0x64,
	0x0a,
	0x62,
	0x79,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x46,
	0x72,
	0x65,
	0x65,
	0x20,
	0x53,
	0x6f,
	0x66,
	0x74,
	0x77,
	0x61,
	0x72,
	0x65,
	0x20,
	0x46,
	0x6f,
	0x75,
	0x6e,
	0x64,
	0x61,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x49,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x50,
	0x72,
	0x6f,
	0x67,
	0x72,
	0x61,
	0x6d,
	0x20,
	0x73,
	0x70,
	0x65,
	0x63,
	0x69,
	0x66,
	0x69,
	0x65,
	0x73,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x61,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x78,
	0x79,
	0x20,
	0x63,
	0x61,
	0x6e,
	0x20,
	0x64,
	0x65,
	0x63,
	0x69,
	0x64,
	0x65,
	0x20,
	0x77,
	0x68,
	0x69,
	0x63,
	0x68,
	0x20,
	0x66,
	0x75,
	0x74,
	0x75,
	0x72,
	0x65,
	0x0a,
	0x76,
	0x65,
	0x72,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x73,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x47,
	0x4e,
	0x55,
	0x20,
	0x47,
	0x65,
	0x6e,
	0x65,
	0x72,
	0x61,
	0x6c,
	0x20,
	0x50,
	0x75,
	0x62,
	0x6c,
	0x69,
	0x63,
	0x20,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x20,
	0x63,
	0x61,
	0x6e,
	0x20,
	0x62,
	0x65,
	0x20,
	0x75,
	0x73,
	0x65,
	0x64,
	0x2c,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x78,
	0x79,
	0x27,
	0x73,
	0x0a,
	0x70,
	0x75,
	0x62,
	0x6c,
	0x69,
	0x63,
	0x20,
	0x73,
	0x74,
	0x61,
	0x74,
	0x65,
	0x6d,
	0x65,
	0x6e,
	0x74,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x61,
	0x63,
	0x63,
	0x65,
	0x70,
	0x74,
	0x61,
	0x6e,
	0x63,
	0x65,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x61,
	0x20,
	0x76,
	0x65,
	0x72,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x70,
	0x65,
	0x72,
	0x6d,
	0x61,
	0x6e,
	0x65,
	0x6e,
	0x74,
	0x6c,
	0x79,
	0x20,
	0x61,
	0x75,
	0x74,
	0x68,
	0x6f,
	0x72,
	0x69,
	0x7a,
	0x65,
	0x73,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x0a,
	0x74,
	0x6f,
	0x20,
	0x63,
	0x68,
	0x6f,
	0x6f,
	0x73,
	0x65,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x76,
	0x65,
	0x72,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x50,
	0x72,
	0x6f,
	0x67,
	0x72,
	0x61,
	0x6d,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x4c,
	0x61,
	0x74,
	0x65,
	0x72,
	0x20,
	0x6c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x20,
	0x76,
	0x65,
	0x72,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x73,
	0x20,
	0x6d,
	0x61,
	0x79,
	0x20,
	0x67,
	0x69,
	0x76,
	0x65,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x61,
	0x64,
	0x64,
	0x69,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x61,
	0x6c,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x64,
	0x69,
	0x66,
	0x66,
	0x65,
	0x72,
	0x65,
	0x6e,
	0x74,
	0x0a,
	0x70,
	0x65,
	0x72,
	0x6d,
	0x69,
	0x73,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x73,
	0x2e,
	0x20,
	0x20,
	0x48,
	0x6f,
	0x77,
	0x65,
	0x76,
	0x65,
	0x72,
	0x2c,
	0x20,
	0x6e,
	0x6f,
	0x20,
	0x61,
	0x64,
	0x64,
	0x69,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x61,
	0x6c,
	0x20,
	0x6f,
	0x62,
	0x6c,
	0x69,
	0x67,
	0x61,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x73,
	0x20,
	0x61,
	0x72,
	0x65,
	0x20,
	0x69,
	0x6d,
	0x70,
	0x6f,
	0x73,
	0x65,
	0x64,
	0x20,
	0x6f,
	0x6e,
	0x20,
	0x61,
	0x6e,
	0x79,
	0x0a,
	0x61,
	0x75,
	0x74,
	0x68,
	0x6f,
	0x72,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x63,
	0x6f,
	0x70,
	0x79,
	0x72,
	0x69,
	0x67,
	0x68,
	0x74,
	0x20,
	0x68,
	0x6f,
	0x6c,
	0x64,
	0x65,
	0x72,
	0x20,
	0x61,
	0x73,
	0x20,
	0x61,
	0x20,
	0x72,
	0x65,
	0x73,
	0x75,
	0x6c,
	0x74,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x72,
	0x20,
	0x63,
	0x68,
	0x6f,
	0x6f,
	0x73,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x66,
	0x6f,
	0x6c,
	0x6c,
	0x6f,
	0x77,
	0x20,
	0x61,
	0x0a,
	0x6c,
	0x61,
	0x74,
	0x65,
	0x72,
	0x20,
	0x76,
	0x65,
	0x72,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x31,
	0x35,
	0x2e,
	0x20,
	0x44,
	0x69,
	0x73,
	0x63,
	0x6c,
	0x61,
	0x69,
	0x6d,
	0x65,
	0x72,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x57,
	0x61,
	0x72,
	0x72,
	0x61,
	0x6e,
	0x74,
	0x79,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x54,
	0x48,
	0x45,
	0x52,
	0x45,
	0x20,
	0x49,
	0x53,
	0x20,
	0x4e,
	0x4f,
	0x20,
	0x57,
	0x41,
	0x52,
	0x52,
	0x41,
	0x4e,
	0x54,
	0x59,
	0x20,
	0x46,
	0x4f,
	0x52,
	0x20,
	0x54,
	0x48,
	0x45,
	0x20,
	0x50,
	0x52,
	0x4f,
	0x47,
	0x52,
	0x41,
	0x4d,
	0x2c,
	0x20,
	0x54,
	0x4f,
	0x20,
	0x54,
	0x48,
	0x45,
	0x20,
	0x45,
	0x58,
	0x54,
	0x45,
	0x4e,
	0x54,
	0x20,
	0x50,
	0x45,
	0x52,
	0x4d,
	0x49,
	0x54,
	0x54,
	0x45,
	0x44,
	0x20,
	0x42,
	0x59,
	0x0a,
	0x41,
	0x50,
	0x50,
	0x4c,
	0x49,
	0x43,
	0x41,
	0x42,
	0x4c,
	0x45,
	0x20,
	0x4c,
	0x41,
	0x57,
	0x2e,
	0x20,
	0x20,
	0x45,
	0x58,
	0x43,
	0x45,
	0x50,
	0x54,
	0x20,
	0x57,
	0x48,
	0x45,
	0x4e,
	0x20,
	0x4f,
	0x54,
	0x48,
	0x45,
	0x52,
	0x57,
	0x49,
	0x53,
	0x45,
	0x20,
	0x53,
	0x54,
	0x41,
	0x54,
	0x45,
	0x44,
	0x20,
	0x49,
	0x4e,
	0x20,
	0x57,
	0x52,
	0x49,
	0x54,
	0x49,
	0x4e,
	0x47,
	0x20,
	0x54,
	0x48,
	0x45,
	0x20,
	0x43,
	0x4f,
	0x50,
	0x59,
	0x52,
	0x49,
	0x47,
	0x48,
	0x54,
	0x0a,
	0x48,
	0x4f,
	0x4c,
	0x44,
	0x45,
	0x52,
	0x53,
	0x20,
	0x41,
	0x4e,
	0x44,
	0x2f,
	0x4f,
	0x52,
	0x20,
	0x4f,
	0x54,
	0x48,
	0x45,
	0x52,
	0x20,
	0x50,
	0x41,
	0x52,
	0x54,
	0x49,
	0x45,
	0x53,
	0x20,
	0x50,
	0x52,
	0x4f,
	0x56,
	0x49,
	0x44,
	0x45,
	0x20,
	0x54,
	0x48,
	0x45,
	0x20,
	0x50,
	0x52,
	0x4f,
	0x47,
	0x52,
	0x41,
	0x4d,
	0x20,
	0x22,
	0x41,
	0x53,
	0x20,
	0x49,
	0x53,
	0x22,
	0x20,
	0x57,
	0x49,
	0x54,
	0x48,
	0x4f,
	0x55,
	0x54,
	0x20,
	0x57,
	0x41,
	0x52,
	0x52,
	0x41,
	0x4e,
	0x54,
	0x59,
	0x0a,
	0x4f,
	0x46,
	0x20,
	0x41,
	0x4e,
	0x59,
	0x20,
	0x4b,
	0x49,
	0x4e,
	0x44,
	0x2c,
	0x20,
	0x45,
	0x49,
	0x54,
	0x48,
	0x45,
	0x52,
	0x20,
	0x45,
	0x58,
	0x50,
	0x52,
	0x45,
	0x53,
	0x53,
	0x45,
	0x44,
	0x20,
	0x4f,
	0x52,
	0x20,
	0x49,
	0x4d,
	0x50,
	0x4c,
	0x49,
	0x45,
	0x44,
	0x2c,
	0x20,
	0x49,
	0x4e,
	0x43,
	0x4c,
	0x55,
	0x44,
	0x49,
	0x4e,
	0x47,
	0x2c,
	0x20,
	0x42,
	0x55,
	0x54,
	0x20,
	0x4e,
	0x4f,
	0x54,
	0x20,
	0x4c,
	0x49,
	0x4d,
	0x49,
	0x54,
	0x45,
	0x44,
	0x20,
	0x54,
	0x4f,
	0x2c,
	0x0a,
	0x54,
	0x48,
	0x45,
	0x20,
	0x49,
	0x4d,
	0x50,
	0x4c,
	0x49,
	0x45,
	0x44,
	0x20,
	0x57,
	0x41,
	0x52,
	0x52,
	0x41,
	0x4e,
	0x54,
	0x49,
	0x45,
	0x53,
	0x20,
	0x4f,
	0x46,
	0x20,
	0x4d,
	0x45,
	0x52,
	0x43,
	0x48,
	0x41,
	0x4e,
	0x54,
	0x41,
	0x42,
	0x49,
	0x4c,
	0x49,
	0x54,
	0x59,
	0x20,
	0x41,
	0x4e,
	0x44,
	0x20,
	0x46,
	0x49,
	0x54,
	0x4e,
	0x45,
	0x53,
	0x53,
	0x20,
	0x46,
	0x4f,
	0x52,
	0x20,
	0x41,
	0x20,
	0x50,
	0x41,
	0x52,
	0x54,
	0x49,
	0x43,
	0x55,
	0x4c,
	0x41,
	0x52,
	0x0a,
	0x50,
	0x55,
	0x52,
	0x50,
	0x4f,
	0x53,
	0x45,
	0x2e,
	0x20,
	0x20,
	0x54,
	0x48,
	0x45,
	0x20,
	0x45,
	0x4e,
	0x54,
	0x49,
	0x52,
	0x45,
	0x20,
	0x52,
	0x49,
	0x53,
	0x4b,
	0x20,
	0x41,
	0x53,
	0x20,
	0x54,
	0x4f,
	0x20,
	0x54,
	0x48,
	0x45,
	0x20,
	0x51,
	0x55,
	0x41,
	0x4c,
	0x49,
	0x54,
	0x59,
	0x20,
	0x41,
	0x4e,
	0x44,
	0x20,
	0x50,
	0x45,
	0x52,
	0x46,
	0x4f,
	0x52,
	0x4d,
	0x41,
	0x4e,
	0x43,
	0x45,
	0x20,
	0x4f,
	0x46,
	0x20,
	0x54,
	0x48,
	0x45,
	0x20,
	0x50,
	0x52,
	0x4f,
	0x47,
	0x52,
	0x41,
	0x4d,
	0x0a,
	0x49,
	0x53,
	0x20,
	0x57,
	0x49,
	0x54,
	0x48,
	0x20,
	0x59,
	0x4f,
	0x55,
	0x2e,
	0x20,
	0x20,
	0x53,
	0x48,
	0x4f,
	0x55,
	0x4c,
	0x44,
	0x20,
	0x54,
	0x48,
	0x45,
	0x20,
	0x50,
	0x52,
	0x4f,
	0x47,
	0x52,
	0x41,
	0x4d,
	0x20,
	0x50,
	0x52,
	0x4f,
	0x56,
	0x45,
	0x20,
	0x44,
	0x45,
	0x46,
	0x45,
	0x43,
	0x54,
	0x49,
	0x56,
	0x45,
	0x2c,
	0x20,
	0x59,
	0x4f,
	0x55,
	0x20,
	0x41,
	0x53,
	0x53,
	0x55,
	0x4d,
	0x45,
	0x20,
	0x54,
	0x48,
	0x45,
	0x20,
	0x43,
	0x4f,
	0x53,
	0x54,
	0x20,
	0x4f,
	0x46,
	0x0a,
	0x41,
	0x4c,
	0x4c,
	0x20,
	0x4e,
	0x45,
	0x43,
	0x45,
	0x53,
	0x53,
	0x41,
	0x52,
	0x59,
	0x20,
	0x53,
	0x45,
	0x52,
	0x56,
	0x49,
	0x43,
	0x49,
	0x4e,
	0x47,
	0x2c,
	0x20,
	0x52,
	0x45,
	0x50,
	0x41,
	0x49,
	0x52,
	0x20,
	0x4f,
	0x52,
	0x20,
	0x43,
	0x4f,
	0x52,
	0x52,
	0x45,
	0x43,
	0x54,
	0x49,
	0x4f,
	0x4e,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x31,
	0x36,
	0x2e,
	0x20,
	0x4c,
	0x69,
	0x6d,
	0x69,
	0x74,
	0x61,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x4c,
	0x69,
	0x61,
	0x62,
	0x69,
	0x6c,
	0x69,
	0x74,
	0x79,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x49,
	0x4e,
	0x20,
	0x4e,
	0x4f,
	0x20,
	0x45,
	0x56,
	0x45,
	0x4e,
	0x54,
	0x20,
	0x55,
	0x4e,
	0x4c,
	0x45,
	0x53,
	0x53,
	0x20,
	0x52,
	0x45,
	0x51,
	0x55,
	0x49,
	0x52,
	0x45,
	0x44,
	0x20,
	0x42,
	0x59,
	0x20,
	0x41,
	0x50,
	0x50,
	0x4c,
	0x49,
	0x43,
	0x41,
	0x42,
	0x4c,
	0x45,
	0x20,
	0x4c,
	0x41,
	0x57,
	0x20,
	0x4f,
	0x52,
	0x20,
	0x41,
	0x47,
	0x52,
	0x45,
	0x45,
	0x44,
	0x20,
	0x54,
	0x4f,
	0x20,
	0x49,
	0x4e,
	0x20,
	0x57,
	0x52,
	0x49,
	0x54,
	0x49,
	0x4e,
	0x47,
	0x0a,
	0x57,
	0x49,
	0x4c,
	0x4c,
	0x20,
	0x41,
	0x4e,
	0x59,
	0x20,
	0x43,
	0x4f,
	0x50,
	0x59,
	0x52,
	0x49,
	0x47,
	0x48,
	0x54,
	0x20,
	0x48,
	0x4f,
	0x4c,
	0x44,
	0x45,
	0x52,
	0x2c,
	0x20,
	0x4f,
	0x52,
	0x20,
	0x41,
	0x4e,
	0x59,
	0x20,
	0x4f,
	0x54,
	0x48,
	0x45,
	0x52,
	0x20,
	0x50,
	0x41,
	0x52,
	0x54,
	0x59,
	0x20,
	0x57,
	0x48,
	0x4f,
	0x20,
	0x4d,
	0x4f,
	0x44,
	0x49,
	0x46,
	0x49,
	0x45,
	0x53,
	0x20,
	0x41,
	0x4e,
	0x44,
	0x2f,
	0x4f,
	0x52,
	0x20,
	0x43,
	0x4f,
	0x4e,
	0x56,
	0x45,
	0x59,
	0x53,
	0x0a,
	0x54,
	0x48,
	0x45,
	0x20,
	0x50,
	0x52,
	0x4f,
	0x47,
	0x52,
	0x41,
	0x4d,
	0x20,
	0x41,
	0x53,
	0x20,
	0x50,
	0x45,
	0x52,
	0x4d,
	0x49,
	0x54,
	0x54,
	0x45,
	0x44,
	0x20,
	0x41,
	0x42,
	0x4f,
	0x56,
	0x45,
	0x2c,
	0x20,
	0x42,
	0x45,
	0x20,
	0x4c,
	0x49,
	0x41,
	0x42,
	0x4c,
	0x45,
	0x20,
	0x54,
	0x4f,
	0x20,
	0x59,
	0x4f,
	0x55,
	0x20,
	0x46,
	0x4f,
	0x52,
	0x20,
	0x44,
	0x41,
	0x4d,
	0x41,
	0x47,
	0x45,
	0x53,
	0x2c,
	0x20,
	0x49,
	0x4e,
	0x43,
	0x4c,
	0x55,
	0x44,
	0x49,
	0x4e,
	0x47,
	0x20,
	0x41,
	0x4e,
	0x59,
	0x0a,
	0x47,
	0x45,
	0x4e,
	0x45,
	0x52,
	0x41,
	0x4c,
	0x2c,
	0x20,
	0x53,
	0x50,
	0x45,
	0x43,
	0x49,
	0x41,
	0x4c,
	0x2c,
	0x20,
	0x49,
	0x4e,
	0x43,
	0x49,
	0x44,
	0x45,
	0x4e,
	0x54,
	0x41,
	0x4c,
	0x20,
	0x4f,
	0x52,
	0x20,
	0x43,
	0x4f,
	0x4e,
	0x53,
	0x45,
	0x51,
	0x55,
	0x45,
	0x4e,
	0x54,
	0x49,
	0x41,
	0x4c,
	0x20,
	0x44,
	0x41,
	0x4d,
	0x41,
	0x47,
	0x45,
	0x53,
	0x20,
	0x41,
	0x52,
	0x49,
	0x53,
	0x49,
	0x4e,
	0x47,
	0x20,
	0x4f,
	0x55,
	0x54,
	0x20,
	0x4f,
	0x46,
	0x20,
	0x54,
	0x48,
	0x45,
	0x0a,
	0x55,
	0x53,
	0x45,
	0x20,
	0x4f,
	0x52,
	0x20,
	0x49,
	0x4e,
	0x41,
	0x42,
	0x49,
	0x4c,
	0x49,
	0x54,
	0x59,
	0x20,
	0x54,
	0x4f,
	0x20,
	0x55,
	0x53,
	0x45,
	0x20,
	0x54,
	0x48,
	0x45,
	0x20,
	0x50,
	0x52,
	0x4f,
	0x47,
	0x52,
	0x41,
	0x4d,
	0x20,
	0x28,
	0x49,
	0x4e,
	0x43,
	0x4c,
	0x55,
	0x44,
	0x49,
	0x4e,
	0x47,
	0x20,
	0x42,
	0x55,
	0x54,
	0x20,
	0x4e,
	0x4f,
	0x54,
	0x20,
	0x4c,
	0x49,
	0x4d,
	0x49,
	0x54,
	0x45,
	0x44,
	0x20,
	0x54,
	0x4f,
	0x20,
	0x4c,
	0x4f,
	0x53,
	0x53,
	0x20,
	0x4f,
	0x46,
	0x0a,
	0x44,
	0x41,
	0x54,
	0x41,
	0x20,
	0x4f,
	0x52,
	0x20,
	0x44,
	0x41,
	0x54,
	0x41,
	0x20,
	0x42,
	0x45,
	0x49,
	0x4e,
	0x47,
	0x20,
	0x52,
	0x45,
	0x4e,
	0x44,
	0x45,
	0x52,
	0x45,
	0x44,
	0x20,
	0x49,
	0x4e,
	0x41,
	0x43,
	0x43,
	0x55,
	0x52,
	0x41,
	0x54,
	0x45,
	0x20,
	0x4f,
	0x52,
	0x20,
	0x4c,
	0x4f,
	0x53,
	0x53,
	0x45,
	0x53,
	0x20,
	0x53,
	0x55,
	0x53,
	0x54,
	0x41,
	0x49,
	0x4e,
	0x45,
	0x44,
	0x20,
	0x42,
	0x59,
	0x20,
	0x59,
	0x4f,
	0x55,
	0x20,
	0x4f,
	0x52,
	0x20,
	0x54,
	0x48,
	0x49,
	0x52,
	0x44,
	0x0a,
	0x50,
	0x41,
	0x52,
	0x54,
	0x49,
	0x45,
	0x53,
	0x20,
	0x4f,
	0x52,
	0x20,
	0x41,
	0x20,
	0x46,
	0x41,
	0x49,
	0x4c,
	0x55,
	0x52,
	0x45,
	0x20,
	0x4f,
	0x46,
	0x20,
	0x54,
	0x48,
	0x45,
	0x20,
	0x50,
	0x52,
	0x4f,
	0x47,
	0x52,
	0x41,
	0x4d,
	0x20,
	0x54,
	0x4f,
	0x20,
	0x4f,
	0x50,
	0x45,
	0x52,
	0x41,
	0x54,
	0x45,
	0x20,
	0x57,
	0x49,
	0x54,
	0x48,
	0x20,
	0x41,
	0x4e,
	0x59,
	0x20,
	0x4f,
	0x54,
	0x48,
	0x45,
	0x52,
	0x20,
	0x50,
	0x52,
	0x4f,
	0x47,
	0x52,
	0x41,
	0x4d,
	0x53,
	0x29,
	0x2c,
	0x0a,
	0x45,
	0x56,
	0x45,
	0x4e,
	0x20,
	0x49,
	0x46,
	0x20,
	0x53,
	0x55,
	0x43,
	0x48,
	0x20,
	0x48,
	0x4f,
	0x4c,
	0x44,
	0x45,
	0x52,
	0x20,
	0x4f,
	0x52,
	0x20,
	0x4f,
	0x54,
	0x48,
	0x45,
	0x52,
	0x20,
	0x50,
	0x41,
	0x52,
	0x54,
	0x59,
	0x20,
	0x48,
	0x41,
	0x53,
	0x20,
	0x42,
	0x45,
	0x45,
	0x4e,
	0x20,
	0x41,
	0x44,
	0x56,
	0x49,
	0x53,
	0x45,
	0x44,
	0x20,
	0x4f,
	0x46,
	0x20,
	0x54,
	0x48,
	0x45,
	0x20,
	0x50,
	0x4f,
	0x53,
	0x53,
	0x49,
	0x42,
	0x49,
	0x4c,
	0x49,
	0x54,
	0x59,
	0x20,
	0x4f,
	0x46,
	0x0a,
	0x53,
	0x55,
	0x43,
	0x48,
	0x20,
	0x44,
	0x41,
	0x4d,
	0x41,
	0x47,
	0x45,
	0x53,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x31,
	0x37,
	0x2e,
	0x20,
	0x49,
	0x6e,
	0x74,
	0x65,
	0x72,
	0x70,
	0x72,
	0x65,
	0x74,
	0x61,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x53,
	0x65,
	0x63,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x73,
	0x20,
	0x31,
	0x35,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x31,
	0x36,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x49,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x64,
	0x69,
	0x73,
	0x63,
	0x6c,
	0x61,
	0x69,
	0x6d,
	0x65,
	0x72,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x77,
	0x61,
	0x72,
	0x72,
	0x61,
	0x6e,
	0x74,
	0x79,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x6c,
	0x69,
	0x6d,
	0x69,
	0x74,
	0x61,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x6c,
	0x69,
	0x61,
	0x62,
	0x69,
	0x6c,
	0x69,
	0x74,
	0x79,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x76,
	0x69,
	0x64,
	0x65,
	0x64,
	0x0a,
	0x61,
	0x62,
	0x6f,
	0x76,
	0x65,
	0x20,
	0x63,
	0x61,
	0x6e,
	0x6e,
	0x6f,
	0x74,
	0x20,
	0x62,
	0x65,
	0x20,
	0x67,
	0x69,
	0x76,
	0x65,
	0x6e,
	0x20,
	0x6c,
	0x6f,
	0x63,
	0x61,
	0x6c,
	0x20,
	0x6c,
	0x65,
	0x67,
	0x61,
	0x6c,
	0x20,
	0x65,
	0x66,
	0x66,
	0x65,
	0x63,
	0x74,
	0x20,
	0x61,
	0x63,
	0x63,
	0x6f,
	0x72,
	0x64,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x74,
	0x68,
	0x65,
	0x69,
	0x72,
	0x20,
	0x74,
	0x65,
	0x72,
	0x6d,
	0x73,
	0x2c,
	0x0a,
	0x72,
	0x65,
	0x76,
	0x69,
	0x65,
	0x77,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x63,
	0x6f,
	0x75,
	0x72,
	0x74,
	0x73,
	0x20,
	0x73,
	0x68,
	0x61,
	0x6c,
	0x6c,
	0x20,
	0x61,
	0x70,
	0x70,
	0x6c,
	0x79,
	0x20,
	0x6c,
	0x6f,
	0x63,
	0x61,
	0x6c,
	0x20,
	0x6c,
	0x61,
	0x77,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x6d,
	0x6f,
	0x73,
	0x74,
	0x20,
	0x63,
	0x6c,
	0x6f,
	0x73,
	0x65,
	0x6c,
	0x79,
	0x20,
	0x61,
	0x70,
	0x70,
	0x72,
	0x6f,
	0x78,
	0x69,
	0x6d,
	0x61,
	0x74,
	0x65,
	0x73,
	0x0a,
	0x61,
	0x6e,
	0x20,
	0x61,
	0x62,
	0x73,
	0x6f,
	0x6c,
	0x75,
	0x74,
	0x65,
	0x20,
	0x77,
	0x61,
	0x69,
	0x76,
	0x65,
	0x72,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x61,
	0x6c,
	0x6c,
	0x20,
	0x63,
	0x69,
	0x76,
	0x69,
	0x6c,
	0x20,
	0x6c,
	0x69,
	0x61,
	0x62,
	0x69,
	0x6c,
	0x69,
	0x74,
	0x79,
	0x20,
	0x69,
	0x6e,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x6e,
	0x65,
	0x63,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x77,
	0x69,
	0x74,
	0x68,
	0x20,
	0x74,
	0x68,
	0x65,
	0x0a,
	0x50,
	0x72,
	0x6f,
	0x67,
	0x72,
	0x61,
	0x6d,
	0x2c,
	0x20,
	0x75,
	0x6e,
	0x6c,
	0x65,
	0x73,
	0x73,
	0x20,
	0x61,
	0x20,
	0x77,
	0x61,
	0x72,
	0x72,
	0x61,
	0x6e,
	0x74,
	0x79,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x61,
	0x73,
	0x73,
	0x75,
	0x6d,
	0x70,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x6c,
	0x69,
	0x61,
	0x62,
	0x69,
	0x6c,
	0x69,
	0x74,
	0x79,
	0x20,
	0x61,
	0x63,
	0x63,
	0x6f,
	0x6d,
	0x70,
	0x61,
	0x6e,
	0x69,
	0x65,
	0x73,
	0x20,
	0x61,
	0x0a,
	0x63,
	0x6f,
	0x70,
	0x79,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x50,
	0x72,
	0x6f,
	0x67,
	0x72,
	0x61,
	0x6d,
	0x20,
	0x69,
	0x6e,
	0x20,
	0x72,
	0x65,
	0x74,
	0x75,
	0x72,
	0x6e,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x20,
	0x61,
	0x20,
	0x66,
	0x65,
	0x65,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x45,
	0x4e,
	0x44,
	0x20,
	0x4f,
	0x46,
	0x20,
	0x54,
	0x45,
	0x52,
	0x4d,
	0x53,
	0x20,
	0x41,
	0x4e,
	0x44,
	0x20,
	0x43,
	0x4f,
	0x4e,
	0x44,
	0x49,
	0x54,
	0x49,
	0x4f,
	0x4e,
	0x53,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x20,
	0x48,
	0x6f,
	0x77,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x41,
	0x70,
	0x70,
	0x6c,
	0x79,
	0x20,
	0x54,
	0x68,
	0x65,
	0x73,
	0x65,
	0x20,
	0x54,
	0x65,
	0x72,
	0x6d,
	0x73,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x59,
	0x6f,
	0x75,
	0x72,
	0x20,
	0x4e,
	0x65,
	0x77,
	0x20,
	0x50,
	0x72,
	0x6f,
	0x67,
	0x72,
	0x61,
	0x6d,
	0x73,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x49,
	0x66,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x64,
	0x65,
	0x76,
	0x65,
	0x6c,
	0x6f,
	0x70,
	0x20,
	0x61,
	0x20,
	0x6e,
	0x65,
	0x77,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x67,
	0x72,
	0x61,
	0x6d,
	0x2c,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x77,
	0x61,
	0x6e,
	0x74,
	0x20,
	0x69,
	0x74,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x62,
	0x65,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x67,
	0x72,
	0x65,
	0x61,
	0x74,
	0x65,
	0x73,
	0x74,
	0x0a,
	0x70,
	0x6f,
	0x73,
	0x73,
	0x69,
	0x62,
	0x6c,
	0x65,
	0x20,
	0x75,
	0x73,
	0x65,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x70,
	0x75,
	0x62,
	0x6c,
	0x69,
	0x63,
	0x2c,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x62,
	0x65,
	0x73,
	0x74,
	0x20,
	0x77,
	0x61,
	0x79,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x61,
	0x63,
	0x68,
	0x69,
	0x65,
	0x76,
	0x65,
	0x20,
	0x74,
	0x68,
	0x69,
	0x73,
	0x20,
	0x69,
	0x73,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x6d,
	0x61,
	0x6b,
	0x65,
	0x20,
	0x69,
	0x74,
	0x0a,
	0x66,
	0x72,
	0x65,
	0x65,
	0x20,
	0x73,
	0x6f,
	0x66,
	0x74,
	0x77,
	0x61,
	0x72,
	0x65,
	0x20,
	0x77,
	0x68,
	0x69,
	0x63,
	0x68,
	0x20,
	0x65,
	0x76,
	0x65,
	0x72,
	0x79,
	0x6f,
	0x6e,
	0x65,
	0x20,
	0x63,
	0x61,
	0x6e,
	0x20,
	0x72,
	0x65,
	0x64,
	0x69,
	0x73,
	0x74,
	0x72,
	0x69,
	0x62,
	0x75,
	0x74,
	0x65,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x63,
	0x68,
	0x61,
	0x6e,
	0x67,
	0x65,
	0x20,
	0x75,
	0x6e,
	0x64,
	0x65,
	0x72,
	0x20,
	0x74,
	0x68,
	0x65,
	0x73,
	0x65,
	0x20,
	0x74,
	0x65,
	0x72,
	0x6d,
	0x73,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x54,
	0x6f,
	0x20,
	0x64,
	0x6f,
	0x20,
	0x73,
	0x6f,
	0x2c,
	0x20,
	0x61,
	0x74,
	0x74,
	0x61,
	0x63,
	0x68,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x66,
	0x6f,
	0x6c,
	0x6c,
	0x6f,
	0x77,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x6e,
	0x6f,
	0x74,
	0x69,
	0x63,
	0x65,
	0x73,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x67,
	0x72,
	0x61,
	0x6d,
	0x2e,
	0x20,
	0x20,
	0x49,
	0x74,
	0x20,
	0x69,
	0x73,
	0x20,
	0x73,
	0x61,
	0x66,
	0x65,
	0x73,
	0x74,
	0x0a,
	0x74,
	0x6f,
	0x20,
	0x61,
	0x74,
	0x74,
	0x61,
	0x63,
	0x68,
	0x20,
	0x74,
	0x68,
	0x65,
	0x6d,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x73,
	0x74,
	0x61,
	0x72,
	0x74,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x65,
	0x61,
	0x63,
	0x68,
	0x20,
	0x73,
	0x6f,
	0x75,
	0x72,
	0x63,
	0x65,
	0x20,
	0x66,
	0x69,
	0x6c,
	0x65,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x6d,
	0x6f,
	0x73,
	0x74,
	0x20,
	0x65,
	0x66,
	0x66,
	0x65,
	0x63,
	0x74,
	0x69,
	0x76,
	0x65,
	0x6c,
	0x79,
	0x0a,
	0x73,
	0x74,
	0x61,
	0x74,
	0x65,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x65,
	0x78,
	0x63,
	0x6c,
	0x75,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x77,
	0x61,
	0x72,
	0x72,
	0x61,
	0x6e,
	0x74,
	0x79,
	0x3b,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x65,
	0x61,
	0x63,
	0x68,
	0x20,
	0x66,
	0x69,
	0x6c,
	0x65,
	0x20,
	0x73,
	0x68,
	0x6f,
	0x75,
	0x6c,
	0x64,
	0x20,
	0x68,
	0x61,
	0x76,
	0x65,
	0x20,
	0x61,
	0x74,
	0x20,
	0x6c,
	0x65,
	0x61,
	0x73,
	0x74,
	0x0a,
	0x74,
	0x68,
	0x65,
	0x20,
	0x22,
	0x63,
	0x6f,
	0x70,
	0x79,
	0x72,
	0x69,
	0x67,
	0x68,
	0x74,
	0x22,
	0x20,
	0x6c,
	0x69,
	0x6e,
	0x65,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x61,
	0x20,
	0x70,
	0x6f,
	0x69,
	0x6e,
	0x74,
	0x65,
	0x72,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x77,
	0x68,
	0x65,
	0x72,
	0x65,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x66,
	0x75,
	0x6c,
	0x6c,
	0x20,
	0x6e,
	0x6f,
	0x74,
	0x69,
	0x63,
	0x65,
	0x20,
	0x69,
	0x73,
	0x20,
	0x66,
	0x6f,
	0x75,
	0x6e,
	0x64,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x3c,
	0x6f,
	0x6e,
	0x65,
	0x20,
	0x6c,
	0x69,
	0x6e,
	0x65,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x67,
	0x69,
	0x76,
	0x65,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x67,
	0x72,
	0x61,
	0x6d,
	0x27,
	0x73,
	0x20,
	0x6e,
	0x61,
	0x6d,
	0x65,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x61,
	0x20,
	0x62,
	0x72,
	0x69,
	0x65,
	0x66,
	0x20,
	0x69,
	0x64,
	0x65,
	0x61,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x77,
	0x68,
	0x61,
	0x74,
	0x20,
	0x69,
	0x74,
	0x20,
	0x64,
	0x6f,
	0x65,
	0x73,
	0x2e,
	0x3e,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x43,
	0x6f,
	0x70,
	0x79,
	0x72,
	0x69,
	0x67,
	0x68,
	0x74,
	0x20,
	0x28,
	0x43,
	0x29,
	0x20,
	0x3c,
	0x79,
	0x65,
	0x61,
	0x72,
	0x3e,
	0x20,
	0x20,
	0x3c,
	0x6e,
	0x61,
	0x6d,
	0x65,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x61,
	0x75,
	0x74,
	0x68,
	0x6f,
	0x72,
	0x3e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x54,
	0x68,
	0x69,
	0x73,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x67,
	0x72,
	0x61,
	0x6d,
	0x20,
	0x69,
	0x73,
	0x20,
	0x66,
	0x72,
	0x65,
	0x65,
	0x20,
	0x73,
	0x6f,
	0x66,
	0x74,
	0x77,
	0x61,
	0x72,
	0x65,
	0x3a,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x63,
	0x61,
	0x6e,
	0x20,
	0x72,
	0x65,
	0x64,
	0x69,
	0x73,
	0x74,
	0x72,
	0x69,
	0x62,
	0x75,
	0x74,
	0x65,
	0x20,
	0x69,
	0x74,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x2f,
	0x6f,
	0x72,
	0x20,
	0x6d,
	0x6f,
	0x64,
	0x69,
	0x66,
	0x79,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x69,
	0x74,
	0x20,
	0x75,
	0x6e,
	0x64,
	0x65,
	0x72,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x74,
	0x65,
	0x72,
	0x6d,
	0x73,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x47,
	0x4e,
	0x55,
	0x20,
	0x47,
	0x65,
	0x6e,
	0x65,
	0x72,
	0x61,
	0x6c,
	0x20,
	0x50,
	0x75,
	0x62,
	0x6c,
	0x69,
	0x63,
	0x20,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x20,
	0x61,
	0x73,
	0x20,
	0x70,
	0x75,
	0x62,
	0x6c,
	0x69,
	0x73,
	0x68,
	0x65,
	0x64,
	0x20,
	0x62,
	0x79,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x46,
	0x72,
	0x65,
	0x65,
	0x20,
	0x53,
	0x6f,
	0x66,
	0x74,
	0x77,
	0x61,
	0x72,
	0x65,
	0x20,
	0x46,
	0x6f,
	0x75,
	0x6e,
	0x64,
	0x61,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x2c,
	0x20,
	0x65,
	0x69,
	0x74,
	0x68,
	0x65,
	0x72,
	0x20,
	0x76,
	0x65,
	0x72,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x33,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x2c,
	0x20,
	0x6f,
	0x72,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x28,
	0x61,
	0x74,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x72,
	0x20,
	0x6f,
	0x70,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x29,
	0x20,
	0x61,
	0x6e,
	0x79,
	0x20,
	0x6c,
	0x61,
	0x74,
	0x65,
	0x72,
	0x20,
	0x76,
	0x65,
	0x72,
	0x73,
	0x69,
	0x6f,
	0x6e,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x54,
	0x68,
	0x69,
	0x73,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x67,
	0x72,
	0x61,
	0x6d,
	0x20,
	0x69,
	0x73,
	0x20,
	0x64,
	0x69,
	0x73,
	0x74,
	0x72,
	0x69,
	0x62,
	0x75,
	0x74,
	0x65,
	0x64,
	0x20,
	0x69,
	0x6e,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x68,
	0x6f,
	0x70,
	0x65,
	0x20,
	0x74,
	0x68,
	0x61,
	0x74,
	0x20,
	0x69,
	0x74,
	0x20,
	0x77,
	0x69,
	0x6c,
	0x6c,
	0x20,
	0x62,
	0x65,
	0x20,
	0x75,
	0x73,
	0x65,
	0x66,
	0x75,
	0x6c,
	0x2c,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x62,
	0x75,
	0x74,
	0x20,
	0x57,
	0x49,
	0x54,
	0x48,
	0x4f,
	0x55,
	0x54,
	0x20,
	0x41,
	0x4e,
	0x59,
	0x20,
	0x57,
	0x41,
	0x52,
	0x52,
	0x41,
	0x4e,
	0x54,
	0x59,
	0x3b,
	0x20,
	0x77,
	0x69,
	0x74,
	0x68,
	0x6f,
	0x75,
	0x74,
	0x20,
	0x65,
	0x76,
	0x65,
	0x6e,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x69,
	0x6d,
	0x70,
	0x6c,
	0x69,
	0x65,
	0x64,
	0x20,
	0x77,
	0x61,
	0x72,
	0x72,
	0x61,
	0x6e,
	0x74,
	0x79,
	0x20,
	0x6f,
	0x66,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x4d,
	0x45,
	0x52,
	0x43,
	0x48,
	0x41,
	0x4e,
	0x54,
	0x41,
	0x42,
	0x49,
	0x4c,
	0x49,
	0x54,
	0x59,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x46,
	0x49,
	0x54,
	0x4e,
	0x45,
	0x53,
	0x53,
	0x20,
	0x46,
	0x4f,
	0x52,
	0x20,
	0x41,
	0x20,
	0x50,
	0x41,
	0x52,
	0x54,
	0x49,
	0x43,
	0x55,
	0x4c,
	0x41,
	0x52,
	0x20,
	0x50,
	0x55,
	0x52,
	0x50,
	0x4f,
	0x53,
	0x45,
	0x2e,
	0x20,
	0x20,
	0x53,
	0x65,
	0x65,
	0x20,
	0x74,
	0x68,
	0x65,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x47,
	0x4e,
	0x55,
	0x20,
	0x47,
	0x65,
	0x6e,
	0x65,
	0x72,
	0x61,
	0x6c,
	0x20,
	0x50,
	0x75,
	0x62,
	0x6c,
	0x69,
	0x63,
	0x20,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x20,
	0x6d,
	0x6f,
	0x72,
	0x65,
	0x20,
	0x64,
	0x65,
	0x74,
	0x61,
	0x69,
	0x6c,
	0x73,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x59,
	0x6f,
	0x75,
	0x20,
	0x73,
	0x68,
	0x6f,
	0x75,
	0x6c,
	0x64,
	0x20,
	0x68,
	0x61,
	0x76,
	0x65,
	0x20,
	0x72,
	0x65,
	0x63,
	0x65,
	0x69,
	0x76,
	0x65,
	0x64,
	0x20,
	0x61,
	0x20,
	0x63,
	0x6f,
	0x70,
	0x79,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x47,
	0x4e,
	0x55,
	0x20,
	0x47,
	0x65,
	0x6e,
	0x65,
	0x72,
	0x61,
	0x6c,
	0x20,
	0x50,
	0x75,
	0x62,
	0x6c,
	0x69,
	0x63,
	0x20,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x61,
	0x6c,
	0x6f,
	0x6e,
	0x67,
	0x20,
	0x77,
	0x69,
	0x74,
	0x68,
	0x20,
	0x74,
	0x68,
	0x69,
	0x73,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x67,
	0x72,
	0x61,
	0x6d,
	0x2e,
	0x20,
	0x20,
	0x49,
	0x66,
	0x20,
	0x6e,
	0x6f,
	0x74,
	0x2c,
	0x20,
	0x73,
	0x65,
	0x65,
	0x20,
	0x3c,
	0x68,
	0x74,
	0x74,
	0x70,
	0x3a,
	0x2f,
	0x2f,
	0x77,
	0x77,
	0x77,
	0x2e,
	0x67,
	0x6e,
	0x75,
	0x2e,
	0x6f,
	0x72,
	0x67,
	0x2f,
	0x6c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x73,
	0x2f,
	0x3e,
	0x2e,
	0x0a,
	0x0a,
	0x41,
	0x6c,
	0x73,
	0x6f,
	0x20,
	0x61,
	0x64,
	0x64,
	0x20,
	0x69,
	0x6e,
	0x66,
	0x6f,
	0x72,
	0x6d,
	0x61,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x6f,
	0x6e,
	0x20,
	0x68,
	0x6f,
	0x77,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x74,
	0x61,
	0x63,
	0x74,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x62,
	0x79,
	0x20,
	0x65,
	0x6c,
	0x65,
	0x63,
	0x74,
	0x72,
	0x6f,
	0x6e,
	0x69,
	0x63,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x70,
	0x61,
	0x70,
	0x65,
	0x72,
	0x20,
	0x6d,
	0x61,
	0x69,
	0x6c,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x49,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x67,
	0x72,
	0x61,
	0x6d,
	0x20,
	0x64,
	0x6f,
	0x65,
	0x73,
	0x20,
	0x74,
	0x65,
	0x72,
	0x6d,
	0x69,
	0x6e,
	0x61,
	0x6c,
	0x20,
	0x69,
	0x6e,
	0x74,
	0x65,
	0x72,
	0x61,
	0x63,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x2c,
	0x20,
	0x6d,
	0x61,
	0x6b,
	0x65,
	0x20,
	0x69,
	0x74,
	0x20,
	0x6f,
	0x75,
	0x74,
	0x70,
	0x75,
	0x74,
	0x20,
	0x61,
	0x20,
	0x73,
	0x68,
	0x6f,
	0x72,
	0x74,
	0x0a,
	0x6e,
	0x6f,
	0x74,
	0x69,
	0x63,
	0x65,
	0x20,
	0x6c,
	0x69,
	0x6b,
	0x65,
	0x20,
	0x74,
	0x68,
	0x69,
	0x73,
	0x20,
	0x77,
	0x68,
	0x65,
	0x6e,
	0x20,
	0x69,
	0x74,
	0x20,
	0x73,
	0x74,
	0x61,
	0x72,
	0x74,
	0x73,
	0x20,
	0x69,
	0x6e,
	0x20,
	0x61,
	0x6e,
	0x20,
	0x69,
	0x6e,
	0x74,
	0x65,
	0x72,
	0x61,
	0x63,
	0x74,
	0x69,
	0x76,
	0x65,
	0x20,
	0x6d,
	0x6f,
	0x64,
	0x65,
	0x3a,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x3c,
	0x70,
	0x72,
	0x6f,
	0x67,
	0x72,
	0x61,
	0x6d,
	0x3e,
	0x20,
	0x20,
	0x43,
	0x6f,
	0x70,
	0x79,
	0x72,
	0x69,
	0x67,
	0x68,
	0x74,
	0x20,
	0x28,
	0x43,
	0x29,
	0x20,
	0x3c,
	0x79,
	0x65,
	0x61,
	0x72,
	0x3e,
	0x20,
	0x20,
	0x3c,
	0x6e,
	0x61,
	0x6d,
	0x65,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x61,
	0x75,
	0x74,
	0x68,
	0x6f,
	0x72,
	0x3e,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x54,
	0x68,
	0x69,
	0x73,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x67,
	0x72,
	0x61,
	0x6d,
	0x20,
	0x63,
	0x6f,
	0x6d,
	0x65,
	0x73,
	0x20,
	0x77,
	0x69,
	0x74,
	0x68,
	0x20,
	0x41,
	0x42,
	0x53,
	0x4f,
	0x4c,
	0x55,
	0x54,
	0x45,
	0x4c,
	0x59,
	0x20,
	0x4e,
	0x4f,
	0x20,
	0x57,
	0x41,
	0x52,
	0x52,
	0x41,
	0x4e,
	0x54,
	0x59,
	0x3b,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x20,
	0x64,
	0x65,
	0x74,
	0x61,
	0x69,
	0x6c,
	0x73,
	0x20,
	0x74,
	0x79,
	0x70,
	0x65,
	0x20,
	0x60,
	0x73,
	0x68,
	0x6f,
	0x77,
	0x20,
	0x77,
	0x27,
	0x2e,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x54,
	0x68,
	0x69,
	0x73,
	0x20,
	0x69,
	0x73,
	0x20,
	0x66,
	0x72,
	0x65,
	0x65,
	0x20,
	0x73,
	0x6f,
	0x66,
	0x74,
	0x77,
	0x61,
	0x72,
	0x65,
	0x2c,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x61,
	0x72,
	0x65,
	0x20,
	0x77,
	0x65,
	0x6c,
	0x63,
	0x6f,
	0x6d,
	0x65,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x72,
	0x65,
	0x64,
	0x69,
	0x73,
	0x74,
	0x72,
	0x69,
	0x62,
	0x75,
	0x74,
	0x65,
	0x20,
	0x69,
	0x74,
	0x0a,
	0x20,
	0x20,
	0x20,
	0x20,
	0x75,
	0x6e,
	0x64,
	0x65,
	0x72,
	0x20,
	0x63,
	0x65,
	0x72,
	0x74,
	0x61,
	0x69,
	0x6e,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x64,
	0x69,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x73,
	0x3b,
	0x20,
	0x74,
	0x79,
	0x70,
	0x65,
	0x20,
	0x60,
	0x73,
	0x68,
	0x6f,
	0x77,
	0x20,
	0x63,
	0x27,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x20,
	0x64,
	0x65,
	0x74,
	0x61,
	0x69,
	0x6c,
	0x73,
	0x2e,
	0x0a,
	0x0a,
	0x54,
	0x68,
	0x65,
	0x20,
	0x68,
	0x79,
	0x70,
	0x6f,
	0x74,
	0x68,
	0x65,
	0x74,
	0x69,
	0x63,
	0x61,
	0x6c,
	0x20,
	0x63,
	0x6f,
	0x6d,
	0x6d,
	0x61,
	0x6e,
	0x64,
	0x73,
	0x20,
	0x60,
	0x73,
	0x68,
	0x6f,
	0x77,
	0x20,
	0x77,
	0x27,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x60,
	0x73,
	0x68,
	0x6f,
	0x77,
	0x20,
	0x63,
	0x27,
	0x20,
	0x73,
	0x68,
	0x6f,
	0x75,
	0x6c,
	0x64,
	0x20,
	0x73,
	0x68,
	0x6f,
	0x77,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x61,
	0x70,
	0x70,
	0x72,
	0x6f,
	0x70,
	0x72,
	0x69,
	0x61,
	0x74,
	0x65,
	0x0a,
	0x70,
	0x61,
	0x72,
	0x74,
	0x73,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x47,
	0x65,
	0x6e,
	0x65,
	0x72,
	0x61,
	0x6c,
	0x20,
	0x50,
	0x75,
	0x62,
	0x6c,
	0x69,
	0x63,
	0x20,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x2e,
	0x20,
	0x20,
	0x4f,
	0x66,
	0x20,
	0x63,
	0x6f,
	0x75,
	0x72,
	0x73,
	0x65,
	0x2c,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x72,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x67,
	0x72,
	0x61,
	0x6d,
	0x27,
	0x73,
	0x20,
	0x63,
	0x6f,
	0x6d,
	0x6d,
	0x61,
	0x6e,
	0x64,
	0x73,
	0x0a,
	0x6d,
	0x69,
	0x67,
	0x68,
	0x74,
	0x20,
	0x62,
	0x65,
	0x20,
	0x64,
	0x69,
	0x66,
	0x66,
	0x65,
	0x72,
	0x65,
	0x6e,
	0x74,
	0x3b,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x20,
	0x61,
	0x20,
	0x47,
	0x55,
	0x49,
	0x20,
	0x69,
	0x6e,
	0x74,
	0x65,
	0x72,
	0x66,
	0x61,
	0x63,
	0x65,
	0x2c,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x77,
	0x6f,
	0x75,
	0x6c,
	0x64,
	0x20,
	0x75,
	0x73,
	0x65,
	0x20,
	0x61,
	0x6e,
	0x20,
	0x22,
	0x61,
	0x62,
	0x6f,
	0x75,
	0x74,
	0x20,
	0x62,
	0x6f,
	0x78,
	0x22,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x59,
	0x6f,
	0x75,
	0x20,
	0x73,
	0x68,
	0x6f,
	0x75,
	0x6c,
	0x64,
	0x20,
	0x61,
	0x6c,
	0x73,
	0x6f,
	0x20,
	0x67,
	0x65,
	0x74,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x72,
	0x20,
	0x65,
	0x6d,
	0x70,
	0x6c,
	0x6f,
	0x79,
	0x65,
	0x72,
	0x20,
	0x28,
	0x69,
	0x66,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x77,
	0x6f,
	0x72,
	0x6b,
	0x20,
	0x61,
	0x73,
	0x20,
	0x61,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x67,
	0x72,
	0x61,
	0x6d,
	0x6d,
	0x65,
	0x72,
	0x29,
	0x20,
	0x6f,
	0x72,
	0x20,
	0x73,
	0x63,
	0x68,
	0x6f,
	0x6f,
	0x6c,
	0x2c,
	0x0a,
	0x69,
	0x66,
	0x20,
	0x61,
	0x6e,
	0x79,
	0x2c,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x73,
	0x69,
	0x67,
	0x6e,
	0x20,
	0x61,
	0x20,
	0x22,
	0x63,
	0x6f,
	0x70,
	0x79,
	0x72,
	0x69,
	0x67,
	0x68,
	0x74,
	0x20,
	0x64,
	0x69,
	0x73,
	0x63,
	0x6c,
	0x61,
	0x69,
	0x6d,
	0x65,
	0x72,
	0x22,
	0x20,
	0x66,
	0x6f,
	0x72,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x67,
	0x72,
	0x61,
	0x6d,
	0x2c,
	0x20,
	0x69,
	0x66,
	0x20,
	0x6e,
	0x65,
	0x63,
	0x65,
	0x73,
	0x73,
	0x61,
	0x72,
	0x79,
	0x2e,
	0x0a,
	0x46,
	0x6f,
	0x72,
	0x20,
	0x6d,
	0x6f,
	0x72,
	0x65,
	0x20,
	0x69,
	0x6e,
	0x66,
	0x6f,
	0x72,
	0x6d,
	0x61,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x20,
	0x6f,
	0x6e,
	0x20,
	0x74,
	0x68,
	0x69,
	0x73,
	0x2c,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x68,
	0x6f,
	0x77,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x61,
	0x70,
	0x70,
	0x6c,
	0x79,
	0x20,
	0x61,
	0x6e,
	0x64,
	0x20,
	0x66,
	0x6f,
	0x6c,
	0x6c,
	0x6f,
	0x77,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x47,
	0x4e,
	0x55,
	0x20,
	0x47,
	0x50,
	0x4c,
	0x2c,
	0x20,
	0x73,
	0x65,
	0x65,
	0x0a,
	0x3c,
	0x68,
	0x74,
	0x74,
	0x70,
	0x3a,
	0x2f,
	0x2f,
	0x77,
	0x77,
	0x77,
	0x2e,
	0x67,
	0x6e,
	0x75,
	0x2e,
	0x6f,
	0x72,
	0x67,
	0x2f,
	0x6c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x73,
	0x2f,
	0x3e,
	0x2e,
	0x0a,
	0x0a,
	0x20,
	0x20,
	0x54,
	0x68,
	0x65,
	0x20,
	0x47,
	0x4e,
	0x55,
	0x20,
	0x47,
	0x65,
	0x6e,
	0x65,
	0x72,
	0x61,
	0x6c,
	0x20,
	0x50,
	0x75,
	0x62,
	0x6c,
	0x69,
	0x63,
	0x20,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x20,
	0x64,
	0x6f,
	0x65,
	0x73,
	0x20,
	0x6e,
	0x6f,
	0x74,
	0x20,
	0x70,
	0x65,
	0x72,
	0x6d,
	0x69,
	0x74,
	0x20,
	0x69,
	0x6e,
	0x63,
	0x6f,
	0x72,
	0x70,
	0x6f,
	0x72,
	0x61,
	0x74,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x72,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x67,
	0x72,
	0x61,
	0x6d,
	0x0a,
	0x69,
	0x6e,
	0x74,
	0x6f,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x70,
	0x72,
	0x69,
	0x65,
	0x74,
	0x61,
	0x72,
	0x79,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x67,
	0x72,
	0x61,
	0x6d,
	0x73,
	0x2e,
	0x20,
	0x20,
	0x49,
	0x66,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x72,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x67,
	0x72,
	0x61,
	0x6d,
	0x20,
	0x69,
	0x73,
	0x20,
	0x61,
	0x20,
	0x73,
	0x75,
	0x62,
	0x72,
	0x6f,
	0x75,
	0x74,
	0x69,
	0x6e,
	0x65,
	0x20,
	0x6c,
	0x69,
	0x62,
	0x72,
	0x61,
	0x72,
	0x79,
	0x2c,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x0a,
	0x6d,
	0x61,
	0x79,
	0x20,
	0x63,
	0x6f,
	0x6e,
	0x73,
	0x69,
	0x64,
	0x65,
	0x72,
	0x20,
	0x69,
	0x74,
	0x20,
	0x6d,
	0x6f,
	0x72,
	0x65,
	0x20,
	0x75,
	0x73,
	0x65,
	0x66,
	0x75,
	0x6c,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x70,
	0x65,
	0x72,
	0x6d,
	0x69,
	0x74,
	0x20,
	0x6c,
	0x69,
	0x6e,
	0x6b,
	0x69,
	0x6e,
	0x67,
	0x20,
	0x70,
	0x72,
	0x6f,
	0x70,
	0x72,
	0x69,
	0x65,
	0x74,
	0x61,
	0x72,
	0x79,
	0x20,
	0x61,
	0x70,
	0x70,
	0x6c,
	0x69,
	0x63,
	0x61,
	0x74,
	0x69,
	0x6f,
	0x6e,
	0x73,
	0x20,
	0x77,
	0x69,
	0x74,
	0x68,
	0x0a,
	0x74,
	0x68,
	0x65,
	0x20,
	0x6c,
	0x69,
	0x62,
	0x72,
	0x61,
	0x72,
	0x79,
	0x2e,
	0x20,
	0x20,
	0x49,
	0x66,
	0x20,
	0x74,
	0x68,
	0x69,
	0x73,
	0x20,
	0x69,
	0x73,
	0x20,
	0x77,
	0x68,
	0x61,
	0x74,
	0x20,
	0x79,
	0x6f,
	0x75,
	0x20,
	0x77,
	0x61,
	0x6e,
	0x74,
	0x20,
	0x74,
	0x6f,
	0x20,
	0x64,
	0x6f,
	0x2c,
	0x20,
	0x75,
	0x73,
	0x65,
	0x20,
	0x74,
	0x68,
	0x65,
	0x20,
	0x47,
	0x4e,
	0x55,
	0x20,
	0x4c,
	0x65,
	0x73,
	0x73,
	0x65,
	0x72,
	0x20,
	0x47,
	0x65,
	0x6e,
	0x65,
	0x72,
	0x61,
	0x6c,
	0x0a,
	0x50,
	0x75,
	0x62,
	0x6c,
	0x69,
	0x63,
	0x20,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x20,
	0x69,
	0x6e,
	0x73,
	0x74,
	0x65,
	0x61,
	0x64,
	0x20,
	0x6f,
	0x66,
	0x20,
	0x74,
	0x68,
	0x69,
	0x73,
	0x20,
	0x4c,
	0x69,
	0x63,
	0x65,
	0x6e,
	0x73,
	0x65,
	0x2e,
	0x20,
	0x20,
	0x42,
	0x75,
	0x74,
	0x20,
	0x66,
	0x69,
	0x72,
	0x73,
	0x74,
	0x2c,
	0x20,
	0x70,
	0x6c,
	0x65,
	0x61,
	0x73,
	0x65,
	0x20,
	0x72,
	0x65,
	0x61,
	0x64,
	0x0a,
	0x3c,
	0x68,
	0x74,
	0x74,
	0x70,
	0x3a,
	0x2f,
	0x2f,
	0x77,
	0x77,
	0x77,
	0x2e,
	0x67,
	0x6e,
	0x75,
	0x2e,
	0x6f,
	0x72,
	0x67,
	0x2f,
	0x70,
	0x68,
	0x69,
	0x6c,
	0x6f,
	0x73,
	0x6f,
	0x70,
	0x68,
	0x79,
	0x2f,
	0x77,
	0x68,
	0x79,
	0x2d,
	0x6e,
	0x6f,
	0x74,
	0x2d,
	0x6c,
	0x67,
	0x70,
	0x6c,
	0x2e,
	0x68,
	0x74,
	0x6d,
	0x6c,
	0x3e,
	0x2e,
	0x0a,
	0x0a, 0
};
